Package: plyr
Version: 1.8.3
Title: Tools for Splitting, Applying and Combining Data
Description: A set of tools that solves a common set of problems: you
    need to break a big problem down into manageable pieces, operate on each
    piece and then put all the pieces back together.  For example, you might
    want to fit a model to each spatial location or time point in your study,
    summarise data by panels or collapse high-dimensional arrays to simpler
    summary statistics. The development of 'plyr' has been generously supported
    by 'Becton Dickinson'.
Authors@R: person("Hadley", "Wickham", , "hadley@rstudio.com", c("aut", "cre"))
URL: http://had.co.nz/plyr, https://github.com/hadley/plyr
BugReports: https://github.com/hadley/plyr/issues
Depends: R (>= 3.1.0)
Imports: Rcpp (>= 0.11.0)
LinkingTo: Rcpp
Suggests: abind, testthat, tcltk, foreach, doParallel, itertools,
        iterators
License: MIT + file LICENSE
LazyData: true
NeedsCompilation: yes
Packaged: 2015-06-11 13:04:58 UTC; hadley
Author: Hadley Wickham [aut, cre]
Maintainer: Hadley Wickham <hadley@rstudio.com>
Repository: CRAN
Date/Publication: 2015-06-12 11:05:51

[![Build Status](https://travis-ci.org/hadley/plyr.png?branch=master)](https://travis-ci.org/hadley/plyr) [![Coverage Status](https://coveralls.io/repos/hadley/plyr/badge.svg?branch=master)](https://coveralls.io/r/hadley/plyr?branch=master)

# plyr

plyr is a set of tools for a common set of problems: you need to __split__ up a big data structure into homogeneous pieces, __apply__ a function to each piece and then __combine__ all the results back together. For example, you might want to:

  * fit the same model each patient subsets of a data frame
  * quickly calculate summary statistics for each group
  * perform group-wise transformations like scaling or standardising

It's already possible to do this with base R functions (like split and the apply family of functions), but plyr makes it all a bit easier with:

  * totally consistent names, arguments and outputs
  * convenient parallelisation through the foreach package
  * input from and output to data.frames, matrices and lists
  * progress bars to keep track of long running operations
  * built-in error recovery, and informative error messages
  * labels that are maintained across all transformations

Considerable effort has been put into making plyr fast and memory efficient, and in many cases plyr is as fast as, or faster than, the built-in equivalents.

A detailed introduction to plyr has been published in JSS: "The Split-Apply-Combine Strategy for Data Analysis", http://www.jstatsoft.org/v40/i01/. You can find out more at http://had.co.nz/plyr/, or track development at http://github.com/hadley/plyr. You can ask questions about plyr (and data manipulation in general) on the plyr mailing list. Sign up at http://groups.google.com/group/manipulatr.

#' Bind matrices by row, and fill missing columns with NA.
#'
#' The matrices are bound together using their column names or the column
#' indices (in that order of precedence.) Numeric columns may be converted to
#' character beforehand, e.g. using format.  If a matrix doesn't have
#' colnames, the column number is used. Note that this means that a
#' column with name \code{"1"} is merged with the first column of a matrix
#' without name and so on. The returned matrix will always have column names.
#'
#' Vectors are converted to 1-column matrices.
#'
#' Matrices of factors are not supported. (They are anyways quite
#' inconvenient.) You may convert them first to either numeric or character
#' matrices. If a matrices of different types are merged, then normal
#' covnersion precendence will apply.
#'
#' Row names are ignored.
#'
#' @param ... the matrices to rbind. The first argument can be a list of
#'   matrices, in which case all other arguments are ignored.
#' @return a matrix with column names
#' @author C. Beleites
#' @seealso \code{\link[base]{rbind}}, \code{\link[base]{cbind}},
#'    \code{\link[plyr]{rbind.fill}}
#' @family binding functions
#' @export
#' @keywords manip
#' @examples
#' A <- matrix (1:4, 2)
#' B <- matrix (6:11, 2)
#' A
#' B
#' rbind.fill.matrix (A, B)
#'
#' colnames (A) <- c (3, 1)
#' A
#' rbind.fill.matrix (A, B)
#'
#' rbind.fill.matrix (A, 99)
rbind.fill.matrix <- function(...) {
  matrices <- list(...)
  if (length(matrices) == 0) return()
  if (is.list(matrices[[1]]) && !is.matrix(matrices[[1]])) {
    matrices <- matrices[[1]]
  }

  ## check the arguments
  tmp <- unlist(lapply(matrices, is.factor))
  if (any(tmp)) {
    stop("Input ", paste(which(tmp), collapse = ", "), " is a factor and ",
      "needs to be converted first to either numeric or character.")
  }

  matrices[] <- lapply(matrices, as.matrix)

  # Work out common column names
  lcols <- lapply(matrices, function(x) amv_dimnames(x)[[2]])
  cols  <- unique(unlist(lcols))

  # Calculate rows in output
  rows <- unlist(lapply(matrices, nrow))
  nrows <- sum(rows)

  # Generate output template
  output <- matrix(NA, nrow = nrows, ncol = length(cols))
  colnames(output) <- cols

  # Compute start and length for each matrix
  pos <- matrix(c(cumsum(rows) - rows + 1, rows), ncol = 2)

  ## fill in the new matrix
  for (i in seq_along(rows)) {
    rng <- seq(pos[i, 1], length = pos[i, 2])
    output[rng, lcols[[i]]] <- matrices[[i]]
  }

  output
}

#' Split list, apply function, and return results in an array.
#'
#' For each element of a list, apply function then combine results into an
#' array.
#'
#' \code{laply} is similar in spirit to \code{\link{sapply}} except
#' that it will always return an array, and the output is transposed with
#' respect \code{sapply} - each element of the list corresponds to a row,
#' not a column.
#'
#' @template ply
#' @template l-
#' @template -a
#' @export
#' @examples
#' laply(baseball, is.factor)
#' # cf
#' ldply(baseball, is.factor)
#' colwise(is.factor)(baseball)
#'
#' laply(seq_len(10), identity)
#' laply(seq_len(10), rep, times = 4)
#' laply(seq_len(10), matrix, nrow = 2, ncol = 2)
laply <-  function(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
                  .drop = TRUE, .parallel = FALSE, .paropts = NULL) {
  if (is.character(.fun)) .fun <- do.call("each", as.list(.fun))
  if (!is.function(.fun)) stop(".fun is not a function.")

  if (!inherits(.data, "split")) .data <- as.list(.data)
  res <- llply(.data = .data, .fun = .fun, ...,
    .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts)

  list_to_array(res, attr(.data, "split_labels"), .drop)
}

#' Round to multiple of any number.
#'
#' @param x numeric or date-time (POSIXct) vector to round
#' @param accuracy number to round to; for POSIXct objects, a number of seconds
#' @param f rounding function: \code{\link{floor}}, \code{\link{ceiling}} or
#'  \code{\link{round}}
#' @keywords manip
#' @export
#' @examples
#' round_any(135, 10)
#' round_any(135, 100)
#' round_any(135, 25)
#' round_any(135, 10, floor)
#' round_any(135, 100, floor)
#' round_any(135, 25, floor)
#' round_any(135, 10, ceiling)
#' round_any(135, 100, ceiling)
#' round_any(135, 25, ceiling)
#'
#' round_any(Sys.time() + 1:10, 5)
#' round_any(Sys.time() + 1:10, 5, floor)
#' round_any(Sys.time(), 3600)
round_any <- function(x, accuracy, f = round) {
  UseMethod("round_any")
}

#' @export
round_any.numeric <- function(x, accuracy, f = round) {
  f(x / accuracy) * accuracy
}

#' @export
round_any.POSIXct <- function(x, accuracy, f = round) {
  tz <- format(x[1], "%Z")
  xr <- round_any(as.numeric(x), accuracy, f)
  as.POSIXct(xr, origin="1970-01-01 00:00.00 UTC", tz=tz)
}

context("Manipulation")

test_that("each() function", {

  expect_equal(each(min, max)(1:10), c(min=1, max=10))
  expect_equal(each(c(min, max))(1:10), c(min=1, max=10))
  expect_equal(each(top=max, bottom=min)(1:10), c(top=10, bottom=1))
  expect_equal(each(top=max, min)(1:10), c(top=10, min=1))
  expect_equal(each(top="max", "min")(1:10), c(top=10, min=1))
  expect_equal(each(c("min", max))(1:10), c(min=1, max=10))

  # Odd behavior, kept for compatibility:
  expect_equal(each(pmin)(1:10, 10:1), c(1:5, 5:1))
  expect_equal(each(max, pmin)(1:10, 10:1), c(max=10, pmin=c(1:5, 5:1)))
  expect_error(each()(1:10))

})

test_that("here() function", {

  df <- data.frame(a = rep(c("a","b"), each = 10), b = 1:20)
  f1 <- function(label) {
     ddply(df, "a", mutate, label = paste(label, b))
  }
  expect_error(f1("name:"))

  f2 <- function(label) {
     ddply(df, "a", here(mutate), label = paste(label, b))
  }
  expect_true(all(grepl("^name: ", f2("name:")$label)))

  f3 <- function() {
    label <- "name:"
    ddply(df, "a", here(mutate), label = paste(label, b))
  }
  expect_true(all(grepl("^name: ", f3()$label)))

})

test_that("defaults() function", {

  expect_equal(defaults(c(a=1, b=2), c(c=3)), c(a=1, b=2, c=3))
  expect_equal(defaults(c(a=1, b=2), c(a=3, b=4)), c(a=1, b=2))
  expect_equal(defaults(c(a=1, b=2), c(a=3, d=4)), c(a=1, b=2, d=4))
  expect_equal(defaults(c(a=1, b=2), c()), c(a=1, b=2))
  expect_equal(defaults(c(), c(a=3, d=4)), c(a=3, d=4))

})

test_that("as.data.frame.function() function", {

  expect_equal(as.data.frame(identity)(1:10), data.frame(value = 1:10))
  expect_equal(as.data.frame(rev)(1:10), data.frame(value = 10:1))

  # Always create value column, even if empty
  expect_equal(as.data.frame(identity)(numeric()), data.frame(value = numeric()))

})

test_that("name_rows() function", {

  expect_equal(name_rows(baseball)$.rownames, rownames(baseball))
  expect_equal(rownames(name_rows(name_rows(baseball))), rownames(baseball))

})

test_that("round_any() function", {

  expect_equal(round_any(135, 10), 140)
  expect_equal(round_any(135, 100), 100)
  expect_equal(round_any(135, 25), 125)
  expect_equal(round_any(135, 10, floor), 130)
  expect_equal(round_any(135, 100, floor), 100)
  expect_equal(round_any(135, 25, floor), 125)
  expect_equal(round_any(135, 10, ceiling), 140)
  expect_equal(round_any(135, 100, ceiling), 200)
  expect_equal(round_any(135, 25, ceiling), 150)

  expect_equal(round_any(as.POSIXct("2000-01-01 11:00:00", tz="UTC"), 86400),
               as.POSIXct("2000-01-01", tz="UTC"))
  expect_equal(round_any(as.POSIXct("2000-01-01 11:11:11", tz="UTC"), 3600),
               as.POSIXct("2000-01-01 11:00", tz="UTC"))
  expect_equal(round_any(as.POSIXct("2000-01-01 11:11:11", tz="UTC"), 10, ceiling),
               as.POSIXct("2000-01-01 11:11:20", tz="UTC"))

})

test_that("take() function", {

  x <- array(seq_len(3 * 4 * 5), c(3, 4, 5))
  expect_equal(take(x, 3, 1), x[,,1, drop = FALSE])
  expect_equal(take(x, 2, 1), x[,1,, drop = FALSE])
  expect_equal(take(x, 1, 1), x[1,,, drop = FALSE])
  expect_equal(take(x, 3, 1, drop = TRUE), x[,,1])
  expect_equal(take(x, 2, 1, drop = TRUE), x[,1,])
  expect_equal(take(x, 1, 1, drop = TRUE), x[1,,])

  expect_equal(take(x, 1:3, 3:5), x[3,4,5, drop = FALSE])
  expect_equal(take(x, 1:2, 2:3), x[2,3,, drop = FALSE])
  expect_equal(take(x, 2:3, 1:2), x[,1,2, drop = FALSE])

  # Odd behavior, tested for compatibility:
  expect_equal(take(x, 1:3, 1), x[1,1,1, drop = FALSE])
  expect_equal(take(x, 1:2, 1), x[1,1,, drop = FALSE])
  expect_equal(take(x, 2:3, 1), x[,1,1, drop = FALSE])

})

#' Number of dimensions.
#'
#' Number of dimensions of an array or vector
#'
#' @param x array
#' @keywords internal
dims <- function(x) length(amv_dim(x))

#' Dimensions.
#'
#' Consistent dimensions for vectors, matrices and arrays.
#'
#' @param x array, matrix or vector
#' @keywords internal
amv_dim <- function(x) if (is.vector(x)) length(x) else dim(x)


#' Dimension names.
#'
#' Consistent dimnames for vectors, matrices and arrays.
#'
#' Unlike \code{\link{dimnames}} no part of the output will ever be
#' null.  If a component of dimnames is omitted, \code{amv_dimnames}
#' will return an integer sequence of the appropriate length.
#'
#' @param x array, matrix or vector
#' @keywords internal
#' @export
amv_dimnames <- function(x) {
  d <- if (is.vector(x)) list(names(x)) else dimnames(x)

  if (is.null(d)) d <- rep(list(NULL), dims(x))
  null_names <- which(unlist(llply(d, is.null)))
  d[null_names] <- llply(null_names, function(i) seq_len(amv_dim(x)[i]))

  # if (is.null(names(d))) names(d) <- paste("X", 1:length(d), sep="")
  d
}

#' Reduce dimensions.
#'
#' Remove extraneous dimensions
#'
#' @param x array
#' @keywords internal
reduce_dim <- function(x) {
  subs <- lapply(dim(x), function(x) if (x == 1) 1 else bquote())
  call <- as.call(c(list(as.name("["), quote(x)), subs, list(drop = TRUE)))
  eval(call)
}

setup_parallel <- function() {
  if (!requireNamespace("foreach", quietly = TRUE)) {
    # EXCLUDE COVERAGE START
    stop("foreach package required for parallel plyr operation",
      call. = FALSE)
    # EXCLUDE COVERAGE END
  }
  if (foreach::getDoParWorkers() == 1) {
    # EXCLUDE COVERAGE START
    warning("No parallel backend registered", call. = TRUE)
    # EXCLUDE COVERAGE END
  }
}

#' Quick data frame.
#'
#' Experimental version of \code{\link{as.data.frame}} that converts a 
#' list to a data frame, but doesn't do any checks to make sure it's a
#' valid format.  Much faster.
#'
#' @param list list to convert to data frame
#' @keywords internal
#' @export
quickdf <- function(list) {
  rows <- unique(unlist(lapply(list, NROW)))
  stopifnot(length(rows) == 1)
  
  names(list) <- make_names(list, "X")
  
  structure(list, 
    class = "data.frame",
    row.names = seq_len(rows))
}

make_names <- function(x, prefix = "X") {
  nm <- names(x)
  if (is.null(nm)) {
    nm <- rep("", length = length(x))
  }
  
  nm[nm == ""] <- paste(prefix, seq_len(sum(nm == "")), sep = "")
  nm
}

#' Split array, apply function, and return results in an array.
#'
#' For each slice of an array, apply function, keeping results as an array.
#'
#' This function is very similar to \code{\link{apply}}, except that it will
#' always return an array, and when the function returns >1 d data structures,
#' those dimensions are added on to the highest dimensions, rather than the
#' lowest dimensions.  This makes \code{aaply} idempotent, so that
#' \code{aaply(input, X, identity)} is equivalent to \code{aperm(input, X)}.
#'
#' @section Warning:Passing a data frame as first argument may lead to
#' unexpected results, see \url{https://github.com/hadley/plyr/issues/212}.
#'
#' @template ply
#' @template a-
#' @template -a
#' @export
#' @examples
#' dim(ozone)
#' aaply(ozone, 1, mean)
#' aaply(ozone, 1, mean, .drop = FALSE)
#' aaply(ozone, 3, mean)
#' aaply(ozone, c(1,2), mean)
#'
#' dim(aaply(ozone, c(1,2), mean))
#' dim(aaply(ozone, c(1,2), mean, .drop = FALSE))
#'
#' aaply(ozone, 1, each(min, max))
#' aaply(ozone, 3, each(min, max))
#'
#' standardise <- function(x) (x - min(x)) / (max(x) - min(x))
#' aaply(ozone, 3, standardise)
#' aaply(ozone, 1:2, standardise)
#'
#' aaply(ozone, 1:2, diff)
aaply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE,
                  .progress = "none", .inform = FALSE, .drop = TRUE,
                  .parallel = FALSE, .paropts = NULL) {
  pieces <- splitter_a(.data, .margins, .expand)

  laply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform, .drop = .drop,
    .parallel = .parallel, .paropts = .paropts)
}

#' Replicate expression and return results in a data frame.
#'
#' Evaluate expression n times then combine results into a data frame
#'
#' This function runs an expression multiple times, and combines the result into
#' a data frame.  If there are no results, then this function returns a data
#' frame with zero rows and columns (\code{data.frame()}). This function is
#' equivalent to \code{\link{replicate}}, but will always return results as a
#' data frame.
#'
#'
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see
#'   \code{\link{create_progress_bar}}
#' @param .id name of the index column. Pass \code{NULL} to avoid creation of
#'   the index column. For compatibility, omit this argument or pass \code{NA}
#'   to use \code{".n"} as column name.
#' @return a data frame
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for Data
#'   Analysis. Journal of Statistical Software, 40(1), 1-29.
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' rdply(20, mean(runif(100)))
#' rdply(20, each(mean, var)(runif(100)))
#' rdply(20, data.frame(x = runif(2)))
rdply <- function(.n, .expr, .progress = "none", .id = NA) {
  res <- .rlply_worker(.n, .progress,
                       eval.parent(substitute(function() .expr)))
  names(res) <- seq_len(.n)
  if (is.null(.id)) {
      labels <- NULL
  } else {
    labels <- data.frame(.n = seq_len(.n))
    if (!is.na(.id)) {
      names(labels) <- .id
    }
  }
  list_to_dataframe(res, labels)
}

#' `Splat' arguments to a function.
#'
#' Wraps a function in do.call, so instead of taking multiple arguments, it
#' takes a single named list which will be interpreted as its arguments.
#'
#' This is useful when you want to pass a function a row of data frame or
#' array, and don't want to manually pull it apart in your function.
#'
#' @param flat function to splat
#' @return a function
#' @export
#' @examples
#' hp_per_cyl <- function(hp, cyl, ...) hp / cyl
#' splat(hp_per_cyl)(mtcars[1,])
#' splat(hp_per_cyl)(mtcars)
#'
#' f <- function(mpg, wt, ...) data.frame(mw = mpg / wt)
#' ddply(mtcars, .(cyl), splat(f))
splat <- function(flat) {
  function(args, ...) {
    do.call(flat, c(args, list(...)))
  }
}

#' Deprecated Functions in Package plyr
#'
#' These functions are provided for compatibility with older versions of
#' \code{plyr} only, and may be defunct as soon as the next release.
#'
#' \itemize{
#'   \item \code{\link{liply}}
#'   \item \code{\link{isplit2}}
#' }
#'
#' @name plyr-deprecated
# EXCLUDE COVERAGE START
NULL
# EXCLUDE COVERAGE END

#' Monthly ozone measurements over Central America.
#'
#'
#' This data set is a subset of the data from the 2006 ASA Data expo
#' challenge, \url{http://stat-computing.org/dataexpo/2006/}. The data are
#' monthly ozone averages on a very coarse 24 by 24 grid covering Central
#' America, from Jan 1995 to Dec 2000. The data is stored in a 3d area with
#' the first two dimensions representing latitude and longitude, and the third
#' representing time.
#'
#' @docType data
#' @name ozone
#' @usage ozone
#' @format A 24 x 24 x 72 numeric array
#' @references \url{http://stat-computing.org/dataexpo/2006/}
#' @keywords datasets
#' @examples
#' value <- ozone[1, 1, ]
#' time <- 1:72
#' month.abbr <- c("Jan", "Feb", "Mar", "Apr", "May",
#'  "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")
#' month <- factor(rep(month.abbr, length = 72), levels = month.abbr)
#' year <- rep(1:6, each = 12)
#' deseasf <- function(value) lm(value ~ month - 1)
#'
#' models <- alply(ozone, 1:2, deseasf)
#' coefs <- laply(models, coef)
#' dimnames(coefs)[[3]] <- month.abbr
#' names(dimnames(coefs))[3] <- "month"
#'
#' deseas <- laply(models, resid)
#' dimnames(deseas)[[3]] <- 1:72
#' names(dimnames(deseas))[3] <- "time"
#'
#' dim(coefs)
#' dim(deseas)
NULL

#' Yearly batting records for all major league baseball players
#'
#' This data frame contains batting statistics for a subset of players
#' collected from \url{http://www.baseball-databank.org/}. There are a total
#' of 21,699 records, covering 1,228 players from 1871 to 2007. Only players
#' with more 15 seasons of play are included.
#'
#' @section Variables:
#' Variables:
#' \itemize{
#'  \item id, unique player id
#'  \item year, year of data
#'  \item stint
#'  \item team, team played for
#'  \item lg, league
#'  \item g, number of games
#'  \item ab, number of times at bat
#'  \item r, number of runs
#'  \item h, hits, times reached base because of a batted, fair ball without
#'      error by the defense
#'  \item X2b, hits on which the batter reached second base safely
#'  \item X3b, hits on which the batter reached third base safely
#'  \item hr, number of home runs
#'  \item rbi, runs batted in
#'  \item sb, stolen bases
#'  \item cs, caught stealing
#'  \item bb, base on balls (walk)
#'  \item so, strike outs
#'  \item ibb, intentional base on balls
#'  \item hbp, hits by pitch
#'  \item sh, sacrifice hits
#'  \item sf, sacrifice flies
#'  \item gidp, ground into double play
#' }
#' @docType data
#' @name baseball
#' @usage baseball
#' @format A 21699 x 22 data frame
#' @references \url{http://www.baseball-databank.org/}
#' @keywords datasets
#' @examples
#' baberuth <- subset(baseball, id == "ruthba01")
#' baberuth$cyear <- baberuth$year - min(baberuth$year) + 1
#'
#' calculate_cyear <- function(df) {
#'   mutate(df,
#'     cyear = year - min(year),
#'     cpercent = cyear / (max(year) - min(year))
#'   )
#' }
#'
#' baseball <- ddply(baseball, .(id), calculate_cyear)
#' baseball <- subset(baseball, ab >= 25)
#'
#' model <- function(df) {
#'   lm(rbi / ab ~ cyear, data=df)
#' }
#' model(baberuth)
#' models <- dlply(baseball, .(id), model)
NULL

#' Replicate expression and return results in a array.
#'
#' Evalulate expression n times then combine results into an array
#'
#' This function runs an expression multiple times, and combines the
#' result into a data frame.  If there are no results, then this function
#' returns a vector of length 0 (\code{vector(0)}).
#' This function is equivalent to \code{\link{replicate}}, but will always
#' return results as a vector, matrix or array.
#'
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @return if results are atomic with same type and dimensionality, a vector, matrix or array; otherwise, a list-array (a list with dimensions)
#' @param .drop should extra dimensions of length 1 be dropped, simplifying the output.  Defaults to \code{TRUE}
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29.
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' raply(100, mean(runif(100)))
#' raply(100, each(mean, var)(runif(100)))
#'
#' raply(10, runif(4))
#' raply(10, matrix(runif(4), nrow=2))
#'
#' # See the central limit theorem in action
#' hist(raply(1000, mean(rexp(10))))
#' hist(raply(1000, mean(rexp(100))))
#' hist(raply(1000, mean(rexp(1000))))
raply <- function(.n, .expr, .progress = "none", .drop = TRUE) {
  res <- .rlply_worker(.n, .progress,
                       eval.parent(substitute(function() .expr)))
  list_to_array(res, NULL, .drop)
}

#' Modify names by name, not position.
#'
#' @param x named object to modify
#' @param replace named character vector, with new names as values, and
#'   old names as names.
#' @export
#' @importFrom stats setNames
#' @examples
#' x <- c("a" = 1, "b" = 2, d = 3, 4)
#' rename(x, c("d" = "c"))
#' rename(mtcars, c("disp" = "displ"))
rename <- function (x, replace) {
  old_names <- names(x)
  new_names <- unname(replace)[match(old_names, names(replace))]
  
  setNames(x, ifelse(is.na(new_names), old_names, new_names))
}

context("Rename")

test_that("No match leaves names unchanged", {
  x <- c(a = 1, b = 2, c = 3, 4)
  y <- rename(x, c(d = "e"))
  
  expect_equal(names(x), names(y))
})

test_that("Single name match makes change", {
  x <- c(a = 1, b = 2)
  y <- rename(x, c(b = "c"))
  
  expect_equal(names(y), c("a", "c"))
})

test_that("Multiple names correctly changed", {
  x <- c(a = 1, b = 2, c = 3)
  y <- rename(x, c("c" = "f", "b" = "e", "a" = "d"))
  
  expect_equal(names(y), c("d", "e", "f"))
})

# Main-stream cases -----------------------------------
context("Rename - Expected Usage")

test_that("No match leaves names unchanged", {
  x <- c(a = 1, b = 2, c = 3, 4)
  y <- rename(x, c(d = "e"), warn_missing = FALSE)

  expect_equal(names(x), names(y))
})

test_that("Missing old values result in message", {
  # This is the same rename operation as above, but should give a message
  x <- c(a = 1, b = 2, c = 3, 4)
  expect_message(rename(x, c(d = "e")))
})

test_that("Single name match makes change", {
  x <- c(a = 1, b = 2)
  y <- rename(x, c(b = "c"))

  expect_equal(names(y), c("a", "c"))
})

test_that("Multiple names correctly changed", {
  x <- c(a = 1, b = 2, c = 3)
  y <- rename(x, c("c" = "f", "b" = "e", "a" = "d"))

  expect_equal(names(y), c("d", "e", "f"))
})

test_that("Empty vectors and lists", {
  expect_identical(rename(character(), c("c" = "f"), warn_missing = FALSE), character())
  expect_identical(rename(list(), c("c" = "f"), warn_missing = FALSE), list())
})

test_that("Renaming lists", {
  x <- list(a = 1, b = 2, c = 3)
  y <- rename(x, c("c" = "f", "b" = "e", "a" = "d"))
  expect_identical(y, list(d = 1, e = 2, f = 3))
})

# Duplicate Names -----------------------------------
context("Rename - Duplicates")

# This batch tests the typical renaming scenarios
test_that("Renaming list with one conflicting variable name - default", {
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c("c" = "f", "b" = "e", "a" = "f")
  expected_response <- "created duplicates"
  #The exact match would be: "The plyr::rename operation has created duplicates for the following name\\(s\\): \\(`f`\\)"
  expect_warning(rename(x = x, replace = replace_list), expected_response)
})
test_that("Renaming list with two conflicting variable names - default", {
  x <- list(a = 1, b = 2, c = 3, d = 4, e = 5)
  replace_list <- c("c" = "f", "b" = "e", "a" = "f", "d" = "g", "e" = "g")
  expected_response <- "created duplicates"
  #The exact match would be: "The plyr::rename operation has created duplicates for the following name\\(s\\): \\(`f`, `g`\\)"
  expect_warning(rename(x = x, replace = replace_list), expected_response)
})
test_that("Renaming list with two conflicting variable names - default", {
  x <- list(a = 1, b = 2, c = 3, d = 4, e = 5)
  replace_list <- c("c" = "f", "b" = "e", "a" = "f", "d" = "g", "e" = "g")
  expected_response <- "created duplicates"
  #The exact match would be: "The plyr::rename operation has created duplicates for the following name\\(s\\): \\(`f`, `g`\\)"
  expect_warning(rename(x = x, replace = replace_list), expected_response)
})
test_that("Renaming list with an conflicting variable name - without warning", {
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c("c" = "f", "b" = "e", "a" = "f")
  result <- rename(x = x, replace = replace_list, warn_duplicated = FALSE)
  expect_identical(result, list(f = 1, e = 2, f = 3))
})


# This batch tests the boundary cases
test_that("Renaming to the same value", {
  #One element is renamed to itself
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c("a" = "a")
  expected_value <- x
  expect_identical(rename(x = x, replace = replace_list), expected_value)
})
test_that("Renaming list with an empty renaming vector", {
  #No renames are requested (which could happen if the calling code was under a lot of automated code.)
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c()
  expected_value <- x
  expect_identical(rename(x = x, replace = replace_list), expected_value)
})
test_that("Single Swapping (shouldn't cause problems)", {
  #Notice how a becomes c, while c becomes f.
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c("c" = "f", "b" = "e", "a" = "c")
  expected_value <- list(c = 1, e = 2, f = 3)
  actual_value <- rename(x = x, replace = replace_list)
  expect_identical(actual_value, expected_value)
})
test_that("Double Swapping (shouldn't cause problems)", {
  #Notice how a becomes c, while c becomes a.
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c("c" = "a", "b" = "z", "a" = "c")
  expected_value <- list(c = 1, z = 2, a = 3)
  actual_value <- rename(x = x, replace = replace_list)
  expect_identical(actual_value, expected_value)
})
test_that("Multiple assignments for the same element", {
  #Notice how it requests to change a to d, e, and f.
  x <- list(a = 1, b = 2, c = 3)
  replace_list <- c("a" = "d", "a" = "e", "a" = "f")
  expected_response <- "The following `from` values were not present in `x`: a, a"
  expected_value <- list(a = 1, a = 2, a = 3)
  expect_message(rename(x = x, replace = replace_list), expected_response)
})

#' Extract matching rows of a data frame.
#'
#' This is particularly useful when you've summarised the data in some way
#' and want to subset the original data by a characteristic of the subset.
#'
#' @param x data frame to subset.
#' @param y data frame defining matching rows.
#' @param on variables to match on - by default will use all variables common
#'   to both data frames.
#' @return a data frame
#' @seealso \code{\link{join}} to combine the columns from both x and y
#' @export
#' @examples
#' longterm <- subset(count(baseball, "id"), freq > 25)
#' bb_longterm <- match_df(baseball, longterm)
match_df <- function(x, y, on = NULL) {
  if (is.null(on)) {
    on <- intersect(names(x), names(y))
    message("Matching on: ", paste(on, collapse = ", "))
  }
  
  keys <- join.keys(x, y, on)
  x[keys$x %in% keys$y, ]
}

context("Join")

# Create smaller subset of baseball data (for speed)
bsmall <- subset(baseball, id %in% sample(unique(baseball$id), 20))[, 1:5]
bsmall$id <- factor(bsmall$id)
bsmall <- bsmall[sample(rownames(bsmall)),  ]
rownames(bsmall) <- NULL

first <- ddply(bsmall, "id", summarise, first = min(year))

test_that("results consistent with merge", {
  b2 <- merge(bsmall, first, by = "id", all.x = TRUE)
  b3 <- join(bsmall, first, by = "id")
  b4 <- join(first, bsmall, by = "id")[names(b3)]

  b2 <- arrange(b2, id, year, stint)
  b3 <- arrange(b3, id, year, stint)
  b4 <- arrange(b4, id, year, stint)

  expect_that(b2, equals(b3))
  expect_that(b2, equals(b4))
})

test_that("order is preserved", {
  b3 <- join(bsmall, first, by = "id")

  expect_that(bsmall$id, equals(b3$id))
  expect_that(bsmall$year, equals(b3$year))
  expect_that(bsmall$stint, equals(b3$stint))
})

test_that("rownames are preserved", {
  b3 <- join(bsmall, first, by = "id")
  expect_that(rownames(b3), equals(rownames(bsmall)))
})

test_that("duplicated keys are duplicated", {
  x <- data.frame(a = c("a", "b"), b = c("a", "b"))
  y <- data.frame(a = c("a", "a"), z = c(1, 2))

  left <- join(x, y, by = "a")
  expect_that(nrow(left), equals(3))
  expect_that(left$z, equals(c(1, 2, NA)))

  inner <- join(x, y, by = "a", type = "inner")
  expect_that(nrow(inner), equals(2))
  expect_that(inner$z, equals(c(1, 2)))
})

test_that("full merge preserves x and y", {
  a <- data.frame(x = 1:10, a = 1:10)
  b <- data.frame(x = 11:15, b = 1:5)

  ab <- join(a, b, by = "x", type = "full")
  expect_that(names(ab), equals(c("x", "a", "b")))
  expect_that(ab$x, equals(1:15))
  expect_that(ab$a, equals(c(1:10, rep(NA, 5))))
  expect_that(ab$b, equals(c(rep(NA, 10), 1:5)))
})

test_that("left and right are equivalent", {
  d1 <- data.frame(a = 1:3, b = 1:3)
  d2 <- data.frame(a = 1:4, c = 1:4)

  right <- join(d1, d2, type="right", by = "a")
  left <- join(d2, d1, type="left", by = "a")
  expect_that(left[c("a", "b" ,"c")], equals(right[c("a", "b" ,"c")]))

  right <- join(d1, d2, type="right", by = "a", match = "first")
  left <- join(d2, d1, type="left", by = "a", match = "first")
  expect_that(left[c("a", "b" ,"c")], equals(right[c("a", "b" ,"c")]))

})


test_that("large number of columns work", {
  df1 <- data.frame(matrix(1:100, ncol = 50), y = 1:2)
  df2 <- data.frame(matrix(1:100, ncol = 50), z = 3:4)

  df <- join(df1, df2)
  expect_that(df$y, equals(1:2))
  expect_that(df$z, equals(3:4))

})

test_that("many potential combinations works", {
  factor_n <- function(m, n) {
    factor(sample(n, m, rep = T), levels = seq_len(n))
  }
  df1 <- as.data.frame(replicate(20, factor_n(100, 100)))
  df2 <- as.data.frame(replicate(20, factor_n(100, 100)))

  j <- join(df1, df2)
  j <- merge(df1, df2, all.x = TRUE)

})

test_that("joins with no common rows work", {
  a <- data.frame(a = 1:10)
  b <- data.frame(b = 1:10)

  full1 <- join(a, b, type = "full")
  full2 <- join(a, b, type = "full", match = "first")
  inner1 <- join(a, b, type = "inner")
  inner2 <- join(a, b, type = "inner", match = "first")
  left1 <- join(a, b, type = "left")
  left2 <- join(a, b, type = "left", match = "first")
  right1 <- join(a, b, type = "right")
  right2 <- join(a, b, type = "right", match = "first")

  expect_equal(nrow(full1), 20)
  expect_equal(nrow(full2), 20)
  expect_equal(nrow(inner1), 0)
  expect_equal(nrow(inner2), 0)
  expect_equal(nrow(left1), 10)
  expect_equal(nrow(left2), 10)
  expect_equal(nrow(right1), 10)
  expect_equal(nrow(right2), 10)
})

test_that("joins with zero row dataframe work", {
  a <- data.frame(a = integer())
  b <- data.frame(a = 1:10, b = letters[1:10])

  full1 <- join(a, b, type = "full")
  full2 <- join(a, b, type = "full", match = "first")
  inner1 <- join(a, b, type = "inner")
  inner2 <- join(a, b, type = "inner", match = "first")
  left1 <- join(a, b, type = "left")
  left2 <- join(a, b, type = "left", match = "first")
  right1 <- join(a, b, type = "right")
  right2 <- join(a, b, type = "right", match = "first")

  expect_equal(nrow(full1), 10)
  expect_equal(nrow(full2), 10)
  expect_equal(nrow(inner1), 0)
  expect_equal(nrow(inner2), 0)
  expect_equal(nrow(left1), 0)
  expect_equal(nrow(left2), 0)
  expect_equal(nrow(right1), 10)
  expect_equal(nrow(right2), 10)
})

test_that("column orders are common, x only, y only", {
  a <- data.frame(a = 1:3, b = 1:3)
  b <- data.frame(a = 1:4, c = 1:4)

  full1 <- join(a, b, type = "full")
  full2 <- join(a, b, type = "full", match = "first")
  inner1 <- join(a, b, type = "inner")
  inner2 <- join(a, b, type = "inner", match = "first")
  left1 <- join(a, b, type = "left")
  left2 <- join(a, b, type = "left", match = "first")
  right1 <- join(a, b, type = "right")
  right2 <- join(a, b, type = "right", match = "first")

  expect_equal(names(full1), c("a", "b", "c"))
  expect_equal(names(full2), c("a", "b", "c"))
  expect_equal(names(inner1), c("a", "b", "c"))
  expect_equal(names(inner2), c("a", "b", "c"))
  expect_equal(names(left1), c("a", "b", "c"))
  expect_equal(names(left2), c("a", "b", "c"))
  expect_equal(names(right1), c("a", "b", "c"))
  expect_equal(names(right2), c("a", "b", "c"))

})

test_that("strings match to factors", {

  dfF <- data.frame(character = c("Aeryn", "Jothee", "Jothee",
                      "Chiana", "Scorpius", "Scorpius"),
                    species = c("Sebacian", "Luxan", "Sebacian",
                      "Nibari", "Sebacian", "Scarran"),
                    stringsAsFactors = TRUE)
  dfS <- colwise(as.character)(dfF)
  matchF <- data.frame(species = "Sebacian", stringsAsFactors = TRUE)
  matchS <- colwise(as.character)(matchF)

  #nor does `join`, (so inner joins are not commutative)
  expect_equal(3, nrow(join(dfF, matchF, type = "inner", by="species")))
  expect_equal(3, nrow(join(dfS, matchS, type = "inner", by="species")))
  expect_equal(3, nrow(join(dfS, matchF, type = "inner", by="species")))
  expect_equal(3, nrow(join(dfF, matchS, type = "inner", by="species")))

})

test_that("join_all", {

  df <- expand.grid(.id = 1, a = 1:2, b = 4:5, c = letters[1:2], d = letters[4:5],
                    KEEP.OUT.ATTRS = FALSE, stringsAsFactors = FALSE)
  df$.id <- as.integer(rownames(df))
  expect_equal(join_all(list(df)), df)
  expect_equal(join_all(list(df[, c(1,2)], df[, c(1,3,4,5)])), df)
  expect_equal(join_all(list(df[, c(1,2)], df[, c(1,3,4)], df[, c(1,4,5)])), df)

})

test_that("match_df", {

  df <- expand.grid(.id = 1, a = 1:2, b = 4:5, c = letters[1:2], d = letters[4:5],
                    KEEP.OUT.ATTRS = FALSE, stringsAsFactors = FALSE)

  expect_equal(match_df(df, df), df)
  expect_equal(match_df(df, df), df)
  expect_equal(nrow(match_df(df, data.frame(a=1, b=4))), 4)

})

# Clear R workspace
rm(list=ls(all=TRUE))

require(stringr)

tmp <- getwd()
setwd("plugins/CountTableProcessing/")
dyn.load("plyr/src/loop_apply.so")
source("plyr/R/loop-apply.r")
source("plyr/R/progress.r")
source("plyr/R/llply.r")
source("plyr/R/indexed-array.r")
source("plyr/R/utils.r")
source("plyr/R/dimensions.r")
source("plyr/R/split-array.r")
source("plyr/R/alply.r")
setwd(tmp)
#print(getwd())

colsplit <- function(string, pattern, names) {
  #vars <- str_split_fixed(string, pattern, n = length(names))
  #
  #df <- data.frame(alply(vars, 2, type.convert, as.is = TRUE),
  #  stringsAsFactors = FALSE)
  m <- length(string) 
  n = length(names)
 
  df = vector("list", m)
  for (i in 1:m) {
     vars <- strsplit(toString(string[i]), pattern)
     df[[i]] <- vars[[1]][1:n]
     dim(df[[i]]) <- n
     names(df[[i]]) <- names
  }
  dim(df) <- m  

  df
}

input <- function(inputfile) {
   input2 <<- read.table(paste(inputfile, ".shared", sep=""), header=TRUE, sep="\t")
   tmp <- colnames(input2)[2]
   tmp2 <- input2[2]
   input2 <<- input2[4:ncol(input2)]
   rownames(input2) <<- t(tmp2)
   otu_names <<- read.table(paste(inputfile, ".0.03.cons.taxonomy", sep=""), header=TRUE, sep="\t")
   otu_names <<- otu_names[,3]
}

mysub <- function(x) {
   gsub("\\(\\d+\\)", "", x)
}

run <- function() {
col_names <- c('Kingdom','Phylum', 'Class', 'Order', 'Family', 'Genus')
taxonomy <- colsplit(otu_names,";",col_names)

m <- dim(taxonomy)
n <- dim(taxonomy[[1]])
for (i in 1:m) {
   for (j in 1:n) {
      taxonomy[[i]][j] <- mysub(taxonomy[[i]][j]) 
   }
}


# Had to do this manually now TMC
column6 <- vector(mode="numeric", length=dim(taxonomy))

for (i in 1:dim(taxonomy)[1]) {
  taxa <- taxonomy[[i]]
  #TMC new version of Mothur uses Root in spot 1
  n <- length(taxa)
  OTU_kingdom = taxa[1]
  if (is.na(OTU_kingdom)) {
     OTU_kingdom = 'unclassified' 
  }
  OTU_phylum = taxa[2]
  if (is.na(OTU_phylum)) {
     OTU_phylum = 'unclassified'
  }
  OTU_class = taxa[3]
  if (is.na(OTU_class)) {
     OTU_class = 'unclassified'
  }
  OTU_order = taxa[4]
  if (is.na(OTU_order)) {
     OTU_order = 'unclassified'
  }
  OTU_family = taxa[5]
  if (is.na(OTU_family)) {
     OTU_family = 'unclassified'
  }
  OTU_genus = taxa[6]
  if (is.na(OTU_genus)) {
     OTU_genus = 'unclassified'
  }

  if (OTU_genus == 'unclassified') {
    if (OTU_family != 'unclassified') {
      taxonomy[[i]][6] <- paste('Family', OTU_family, sep=".")
    }
    else {
      if (OTU_order != 'unclassified') {
        taxonomy[[i]][6] <- paste('Order', OTU_order, sep=".")
        taxonomy[[i]][5] <- paste('Order', OTU_order, sep=".")
      } else {
        if (OTU_class != 'unclassified') {
          taxonomy[[i]][6] <- paste('Class', OTU_class, sep=".")
          taxonomy[[i]][5] <- paste('Class', OTU_class, sep=".")
          taxonomy[[i]][4] <- paste('Class', OTU_class, sep=".")
        }
        else {
          if (OTU_phylum != 'unclassified') {
            taxonomy[[i]][6] <- paste('Phylum', OTU_phylum, sep=".")
            taxonomy[[i]][5] <- paste('Phylum', OTU_phylum, sep=".")
            taxonomy[[i]][4] <- paste('Phylum', OTU_phylum, sep=".")
            taxonomy[[i]][3] <- paste('Phylum', OTU_phylum, sep=".")
          }
          else {
            taxonomy[[i]][6] <- paste('Kingdom', OTU_kingdom, sep=".")
            taxonomy[[i]][5] <- paste('Kingdom', OTU_kingdom, sep=".")
            taxonomy[[i]][4] <- paste('Kingdom', OTU_kingdom, sep=".")
            taxonomy[[i]][3] <- paste('Kingdom', OTU_kingdom, sep=".")
            taxonomy[[i]][2] <- paste('Kingdom', OTU_kingdom, sep=".")
          }
        }
      }
    }
  }
  column6[i] <- taxonomy[[i]][6]
}
tmp_colnames <- column6 #t(column6)
#Fix colnames  (This is pretty slow, maybe it can be done faster if we do it differently)
t_colnames <- c();
for(i in 1:length(column6)){
	current <- which(t_colnames[,1]==taxonomy[[i]][6])
	if(length(current)>0){
		tmp_colnames[i] <- sprintf("%s.%04d", tmp_colnames[i], as.integer(t_colnames[current,2]))
		t_colnames[current,2] <- as.integer(t_colnames[current,2]) + 1
	}else{
		tmp_colnames[i] <- paste(tmp_colnames[i], "0001", sep=".")
		t_colnames <- rbind(t_colnames, c(taxonomy[[i]][6], 2));
	}
}
colnames(input2) <- tmp_colnames;

sample_list <- strsplit(as.vector(rownames(input2)),'\\.')
samples <- cbind(matrix(unlist(sample_list), ncol = 1, byrow = TRUE), "")
#Now calculate the duplicates

preNAP = "";
for (i in 1:nrow(samples)) {
	if(samples[i,1] == preNAP){
		samples[i,2] = "X"
	}
	preNAP = samples[i,1]
}
#Remove the duplicates from input and add the row names
input2 <<- input2[which(samples[,2]!="X"),]
rownames(input2) <- samples[which(samples[,2]!="X"),1]
}

output <- function(outputfile) {
fileOut <- paste(outputfile, sep="")
write.table(input2, file=fileOut, sep=",", append=FALSE, col.names=NA, na="")

}

#' Aggregate multiple functions into a single function.
#'
#' Combine multiple functions into a single function returning a named vector
#' of outputs.
#' Note: you cannot supply additional parameters for the summary functions
#'
#' @param ... functions to combine. each function should produce a single
#'    number as output
#' @keywords manip
#' @seealso \code{\link{summarise}} for applying summary functions to data
#' @export
#' @examples
#' # Call min() and max() on the vector 1:10
#' each(min, max)(1:10)
#' # This syntax looks a little different.  It is shorthand for the
#' # the following:
#' f<- each(min, max)
#' f(1:10)
#' # Three equivalent ways to call min() and max() on the vector 1:10
#' each("min", "max")(1:10)
#' each(c("min", "max"))(1:10)
#' each(c(min, max))(1:10)
#' # Call length(), min() and max() on a random normal vector
#' each(length, mean, var)(rnorm(100))
each <- function(...) {
  fnames <- laply(match.call()[-1], deparse)
  fs <- list(...)
  if (length(fs[[1]]) > 1) {
    fs <- fs[[1]]

    # Jump through hoops to work out names
    snames <- as.list(match.call()[2])[[1]]
    fnames <- unlist(lapply(as.list(snames)[-1], deparse))
  }

  # Find function names and replace with function objects
  char <- laply(fs, is.character)
  fnames[char] <- fs[char]
  fs[char] <- llply(fs[char], match.fun)

  unames <- names(fs)
  if (is.null(unames)) unames <- fnames
  unames[unames == ""] <- fnames[unames == ""]

  n <- length(fs)

  if (n == 1) {
    # If there is only one function, things are simple.  We just
    # need to name the output, if appropriate.
    function(x, ...) {
      res <- fs[[1]](x, ...) # nolint
      if (length(res) == 1) names(res) <- unames
      res
    }
  } else {
    # nolint start
    proto <- NULL
    result <- NULL
    # nolint end

    function(x, ...) {
      # For n > 1 things are a little tricky
      # Construct protoype for output on first call
      if (is.null(proto)) {
        result <<- vector("list", length = n)
        names(result) <- unames

        for (i in 1:n) result[[i]] <- fs[[i]](x, ...) # nolint
        proto <<- list_to_vector(result)
      } else {
        for (i in 1:n) proto[[i]] <- fs[[i]](x, ...) # nolint
      }
      proto
    }
  }
}

#' @section Input: This function splits data frames by variables.
#'
#' @param .data data frame to be processed
#' @param .variables variables to split data frame by, as quoted
#'   variables, a formula or character vector
#' @param .drop should combinations of variables that do not appear in the 
#'   input data be preserved (FALSE) or dropped (TRUE, default)
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#' @family data frame input

#' Call function with arguments in array or data frame, discarding results.
#'
#' Call a multi-argument function with values taken from columns of an
#' data frame or array, and discard results into a list.
#'
#' @template ply
#' @template m-
#' @template -_
#' @export
m_ply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none",
                  .inform = FALSE, .print = FALSE, .parallel = FALSE,
                  .paropts = NULL) {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)

  f <- splat(.fun)
  a_ply(.data = .data, .margins = 1, .fun = f, ..., .expand = .expand,
    .progress = .progress, .inform = .inform, .print = .print,
    .parallel = .parallel, .paropts = .paropts)
}

#' Split data frame, apply function, and return results in a data frame.
#'
#' For each subset of a data frame, apply function then combine results into a
#' data frame.
#' To apply a function for each row, use \code{\link{adply}} with
#' \code{.margins} set to \code{1}.
#'
#' @template ply
#' @template d-
#' @template -d
#' @seealso \code{\link{tapply}} for similar functionality in the base package
#' @export
#' @examples
#' # Summarize a dataset by two variables
#' dfx <- data.frame(
#'   group = c(rep('A', 8), rep('B', 15), rep('C', 6)),
#'   sex = sample(c("M", "F"), size = 29, replace = TRUE),
#'   age = runif(n = 29, min = 18, max = 54)
#' )
#'
#' # Note the use of the '.' function to allow
#' # group and sex to be used without quoting
#' ddply(dfx, .(group, sex), summarize,
#'  mean = round(mean(age), 2),
#'  sd = round(sd(age), 2))
#'
#' # An example using a formula for .variables
#' ddply(baseball[1:100,], ~ year, nrow)
#' # Applying two functions; nrow and ncol
#' ddply(baseball, .(lg), c("nrow", "ncol"))
#'
#' # Calculate mean runs batted in for each year
#' rbi <- ddply(baseball, .(year), summarise,
#'   mean_rbi = mean(rbi, na.rm = TRUE))
#' # Plot a line chart of the result
#' plot(mean_rbi ~ year, type = "l", data = rbi)
#'
#' # make new variable career_year based on the
#' # start year for each player (id)
#' base2 <- ddply(baseball, .(id), mutate,
#'  career_year = year - min(year) + 1
#' )
ddply <- function(.data, .variables, .fun = NULL, ..., .progress = "none",
                  .inform = FALSE, .drop = TRUE, .parallel = FALSE,
                  .paropts = NULL) {
  if (empty(.data)) return(.data)
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop)

  ldply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts)
}

context("Split data frame")

df <- data.frame(x = factor(1:10), y = letters[1:10])

test_that("correct order is used", {
  expect_that(ddply(df, .(x), .drop = FALSE), equals(df))
  expect_that(ddply(df, .(x), .drop = TRUE), equals(df))
})

context("Data frames")


test_that("results ordered in order of split variables", {
  d <- data.frame(x = c("a","b"), y = c("d","c"), stringsAsFactors = FALSE)

  plyed <- ddply(d, c("x" ,"y"))
  expect_that(plyed$x, equals(c("a", "b")))
  expect_that(plyed$y, equals(c("d", "c")))
  
  plyed <- ddply(d, c("y" ,"x"))
  expect_that(plyed$y, equals(c("c", "d")))
  expect_that(plyed$x, equals(c("b", "a")))
  
})

test_that("character vectors not change to factors", {
  d <- data.frame(x = c("a","b"), y = c("d","c"), stringsAsFactors = FALSE)

  plyed <- ddply(d, c("x" ,"y"), nrow)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))

  plyed <- ddply(d, c("x"), identity)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))

  plyed <- ddply(d, c("x" ,"y"), nrow, .drop = FALSE)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))

  plyed <- ddply(d, c("x"), identity, .drop = FALSE)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))  
})


# Bug report contributed by Thomas P Harte <THarte@tiaa-cref.org>
test_that("column names not changed", {
  d1 <- data.frame(`--WEIRD`=1:5, a = letters[1:5], `-b` = 1:5, 
    check.names = FALSE)
  d2 <- ddply(d1, .(`--WEIRD`), force) 
  expect_that(names(d2), equals(names(d1)))
  
  
})

# Bug reported by Karl Ove Hufthammer <karl@huftis.org>
test_that("label variables always preserved", {

  d <- data.frame(x = 101:104, y = 1:4)
  f <- function(df) sum(df$y)
  g <- function(df) if(df$x <= 102) sum(df$y)
  
  out1 <- ddply(d, "x", f) # This one works correctly
  out2 <- ddply(d, "x", g) # This one doesn’t
  
  expect_that(names(out1), equals(names(out2)))
  expect_that(out1$x[1:2], equals(out2$x))

  
})

context("Split data frame")


test_that("correct order is used", {
  df <- data.frame(x = factor(1:10), y = letters[1:10])

  expect_that(ddply(df, .(x), .drop = FALSE), equals(df))
  expect_that(ddply(df, .(x), .drop = TRUE), equals(df))
})

test_that("factor levels are preserved", {
  df <- data.frame(a = factor(1:4, levels = 1:5), x = runif(4))

  out1 <- ddply(df, "a", strip_splits, .drop = TRUE)
  out2 <- ddply(df, "a", strip_splits, .drop = FALSE)

  expect_is(out1$a, "factor")
  expect_is(out2$a, "factor")

  expect_equal(levels(out1$a), levels(df$a))
  expect_equal(levels(out2$a), levels(df$a))
})

context("Join")

# Create smaller subset of baseball data (for speed)
bsmall <- subset(baseball, id %in% sample(unique(baseball$id), 20))[, 1:5]
bsmall$id <- factor(bsmall$id)
bsmall <- bsmall[sample(rownames(bsmall)),  ]
rownames(bsmall) <- NULL

first <- ddply(bsmall, "id", summarise, first = min(year))

test_that("results consistent with merge", {  
  b2 <- merge(bsmall, first, by = "id", all.x = TRUE)
  b3 <- join(bsmall, first, by = "id")
  b4 <- join(first, bsmall, by = "id")[names(b3)]
  
  b2 <- arrange(b2, id, year, stint)
  b3 <- arrange(b3, id, year, stint)
  b4 <- arrange(b4, id, year, stint)
  
  expect_that(b2, equals(b3))
  expect_that(b2, equals(b4))
})

test_that("order is preserved", {
  b3 <- join(bsmall, first, by = "id")

  expect_that(bsmall$id, equals(b3$id))
  expect_that(bsmall$year, equals(b3$year))
  expect_that(bsmall$stint, equals(b3$stint))  
})

test_that("rownames are preserved", {
  b3 <- join(bsmall, first, by = "id")
  expect_that(rownames(b3), equals(rownames(bsmall)))
})

test_that("duplicated keys are duplicated", {
  x <- data.frame(a = c("a", "b"), b = c("a", "b"))
  y <- data.frame(a = c("a", "a"), z = c(1, 2))
  
  left <- join(x, y, by = "a")
  expect_that(nrow(left), equals(3))
  expect_that(left$z, equals(c(1, 2, NA)))
  
  inner <- join(x, y, by = "a", type = "inner")
  expect_that(nrow(inner), equals(2))
  expect_that(inner$z, equals(c(1, 2)))
})

test_that("full merge preserves x and y", {
  a <- data.frame(x = 1:10, a = 1:10)
  b <- data.frame(x = 11:15, b = 1:5)
  
  ab <- join(a, b, by = "x", type = "full")
  expect_that(names(ab), equals(c("x", "a", "b")))
  expect_that(ab$x, equals(1:15))
  expect_that(ab$a, equals(c(1:10, rep(NA, 5))))
  expect_that(ab$b, equals(c(rep(NA, 10), 1:5)))    
})

test_that("left and right are equivalent", {
  d1 <- data.frame(a = 1:3, b = 1:3)
  d2 <- data.frame(a = 1:4, c = 1:4)

  right <- join(d1, d2, type="right", by = "a")
  left <- join(d2, d1, type="left", by = "a")
  expect_that(left[c("a", "b" ,"c")], equals(right[c("a", "b" ,"c")]))

  right <- join(d1, d2, type="right", by = "a", match = "first")
  left <- join(d2, d1, type="left", by = "a", match = "first")
  expect_that(left[c("a", "b" ,"c")], equals(right[c("a", "b" ,"c")]))

})


test_that("large number of columns work", {
  df1 <- data.frame(matrix(1:100, ncol = 50), y = 1:2)
  df2 <- data.frame(matrix(1:100, ncol = 50), z = 3:4)
  
  df <- join(df1, df2)
  expect_that(df$y, equals(1:2))
  expect_that(df$z, equals(3:4))
  
})

test_that("many potential combinations works", {
  factor_n <- function(m, n) {
    factor(sample(n, m, rep = T), levels = seq_len(n))
  }
  df1 <- as.data.frame(replicate(20, factor_n(100, 100)))
  df2 <- as.data.frame(replicate(20, factor_n(100, 100)))

  j <- join(df1, df2)
  j <- merge(df1, df2, all.x = TRUE)
  
  
})

#' Split array, apply function, and return results in a list.
#'
#' For each slice of an array, apply function then combine results into a
#' list.
#'
#' The list will have "dims" and "dimnames" corresponding to the
#' margins given. For instance \code{alply(x, c(3,2), ...)} where
#' \code{x} has dims \code{c(4,3,2)} will give a result with dims
#' \code{c(2,3)}.
#'
#' \code{alply} is somewhat similar to \code{\link{apply}} for cases
#' where the results are not atomic.
#'
#' @template ply
#' @template a-
#' @template -l
#' @param .dims if \code{TRUE}, copy over dimensions and names from input.
#' @export
#' @examples
#' alply(ozone, 3, quantile)
#' alply(ozone, 3, function(x) table(round(x)))
alply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE,
                  .progress = "none", .inform = FALSE, .parallel = FALSE,
                  .paropts = NULL, .dims = FALSE) {
  pieces <- splitter_a(.data, .margins, .expand)

  res <- llply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts)

  if (.dims) {
    labels <- attr(pieces, "split_labels")
    #splitting a dataframe along dimension 1 is a special case which
    #gets a different output from splitter_a, so guard against that
    if (length(labels) == length(.margins)) {
      res_labels <- lapply(labels, function(x) as.character(unique(x)))
      res_dim <- sapply(res_labels, length)
      if (length(res_dim) > 0) {
        dim(res) <-  res_dim
        dimnames(res) <- res_labels
      }
    }
  }
  res
}

#' Order a data frame by its colums.
#'
#' This function completes the subsetting, transforming and ordering triad
#' with a function that works in a similar way to \code{\link{subset}} and
#' \code{\link{transform}} but for reordering a data frame by its columns.
#' This saves a lot of typing!
#'
#' @param df data frame to reorder
#' @param ... expressions evaluated in the context of \code{df} and then fed
#'   to \code{\link{order}}
#' @keywords manip
#' @seealso \code{\link{order}} for sorting function in the base package
#' @export
#' @examples
#' # sort mtcars data by cylinder and displacement
#' mtcars[with(mtcars, order(cyl, disp)), ]
#' # Same result using arrange: no need to use with(), as the context is implicit
#' # NOTE: plyr functions do NOT preserve row.names
#' arrange(mtcars, cyl, disp)
#' # Let's keep the row.names in this example
#' myCars = cbind(vehicle=row.names(mtcars), mtcars)
#' arrange(myCars, cyl, disp)
#' # Sort with displacement in descending order
#' arrange(myCars, cyl, desc(disp))
arrange <- function(df, ...) {
  stopifnot(is.data.frame(df))

  ord <- eval(substitute(order(...)), df, parent.frame())
  if(length(ord) != nrow(df)) {
    stop("Length of ordering vectors don't match data frame size",
      call. = FALSE)
  }
  unrowname(df[ord, , drop = FALSE])
}

#' Descending order.
#'
#' Transform a vector into a format that will be sorted in descending order.
#'
#' @param x vector to transform
#' @keywords manip
#' @export
#' @examples
#' desc(1:10)
#' desc(factor(letters))
#' first_day <- seq(as.Date("1910/1/1"), as.Date("1920/1/1"), "years")
#' desc(first_day)
desc <- function(x) -xtfrm(x)

context("Arrange")

test_that("bogus sort order", {
  expect_error(arrange(mtcars, diff(mpg)), "Length of ordering vectors")
})

test_that("descending sort", {
  expect_equal(arrange(mtcars, desc(mpg)), arrange(mtcars, -mpg))
})

library(testthat)
context("Count")

count_f <- function(...) count(...)$freq
table_f <- function(...) {
  x <- unname(as.numeric(table(rev(...))))
  x[x != 0]
}

test_that("count matches table", {
  data <- list(
    mtcars["cyl"],
    mtcars["mpg"],
    mtcars[c("cyl", "vs")])

  for (datum in data) {
    expect_that(count_f(datum), equals(table_f(datum)))
  }

})

test_that("random order doesn't affect count", {
  usual <- count(mtcars, "cyl")

  for (i in 1:5) {
    mtcars_r <- mtcars[sample(1:nrow(mtcars)), ]
    expect_that(count(mtcars_r, "cyl"), equals(usual))
  }

})

test_that("weighted count matches xtab", {
  xt1 <- as.data.frame(xtabs(g ~ id, data = baseball), responseName = "freq")
  xt1$id <- as.character(xt1$id)
  ct1 <- count(baseball, "id", "g")

  expect_that(ct1, equals(xt1))

  xt2 <- as.data.frame(xtabs(g ~ year + team, data = baseball),
    responseName = "freq")
  xt2 <- subset(xt2, freq > 0)
  xt2$year <- as.numeric(as.character(xt2$year))
  xt2$team <- as.character(xt2$team)
  xt2 <- arrange(xt2, year, team)
  ct2 <- count(baseball, c("year", "team"), "g")

  expect_that(ct2, equals(xt2))

})

test_that("count works with factors and dates", {
  genders <- c("Female", "Male")
  n <- c(5, 10)
  gender_data <- factor(rep.int(genders, n))

  expect_equal(count(gender_data), data.frame(x = genders, freq = n))

  this_week <- seq(Sys.Date(), Sys.Date() + 6, "1 day")
  n2 <- 1:7
  day_data <- rep(this_week, n2)

  expect_equal(count(day_data), data.frame(x = this_week, freq = n2))
})

test_that("vaggregate corner cases", {
  res <- vaggregate(1:99, rep(1:11, 9), sum)
  expect_equal(res, vaggregate(1:99, expand.grid(1:11, 1:9)[,1,drop=FALSE], sum))
  expect_equal(res, vaggregate(1:99, rep(0.5 + (1:11), 9), sum, .default = 1))
})

library(testthat)
context("Count")

count_f <- function(...) count(...)$freq
table_f <- function(...) { 
  x <- unname(as.numeric(table(rev(...))))
  x[x != 0]
}

test_that("count matches table", {
  data <- list(
    mtcars["cyl"],
    mtcars["mpg"],
    mtcars[c("cyl", "vs")])
  
  for(datum in data) {
    expect_that(count_f(datum), equals(table_f(datum)))
  }  

})

test_that("random order doesn't affect count", {
  usual <- count(mtcars, "cyl")
  
  for(i in 1:5) {
    mtcars_r <- mtcars[sample(1:nrow(mtcars)), ]
    expect_that(count(mtcars_r, "cyl"), equals(usual))
  }
  
})

test_that("weighted count matches xtab", {
  xt1 <- as.data.frame(xtabs(g ~ id, data = baseball), responseName = "freq")
  xt1$id <- as.character(xt1$id)
  ct1 <- count(baseball, "id", "g")
  
  expect_that(ct1, equals(xt1))
  
  xt2 <- as.data.frame(xtabs(g ~ year + team, data = baseball), 
    responseName = "freq")
  xt2 <- subset(xt2, freq > 0)
  xt2$year <- as.numeric(as.character(xt2$year))
  xt2$team <- as.character(xt2$team)
  xt2 <- arrange(xt2, year, team)
  ct2 <- count(baseball, c("year", "team"), "g")
  
  expect_that(ct2, equals(xt2))
  
})

#' @export
length.indexed <- function(x) length(x$index)

#' @export
names.indexed <- function(x) {
  labels <- attr(x, "split_labels")
  labels[] <- lapply(labels, as.character)

  do.call(paste, c(labels, list(sep = ".")))
}

#' @export
as.list.indexed <- function(x, ...) {
  n <- length(x)
  out <- vector("list", n)
  for (i in seq_len(n)) {
    out[[i]] <- x[[i]]
  }
  names(out) <- names(x)
  class(out) <- c("split", "list")
  out
}

#' @export
print.indexed <- function(x, ...) {
  print(as.list(x))
}

#' @export
"[.indexed" <- function(x, ...) {
  as.list(x)[...]
}

#' Split array, apply function, and discard results.
#'
#' For each slice of an array, apply function and discard results
#'
#' @template ply
#' @template a-
#' @template -_
#' @export
a_ply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE,
                  .progress = "none", .inform = FALSE,
                  .print = FALSE, .parallel = FALSE, .paropts = NULL) {
  pieces <- splitter_a(.data, .margins, .expand)

  l_ply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform, .print = .print,
    .parallel = .parallel, .paropts = .paropts)
}

#' Toggle row names between explicit and implicit.
#'
#' Plyr functions ignore row names, so this function provides a way to preserve
#' them by converting them to an explicit column in the data frame.  After the
#' plyr operation, you can then apply \code{name_rows} again to convert back
#' from the explicit column to the implicit \code{rownames}.
#'
#' @param df a data.frame, with either \code{rownames}, or a column called
#'  \code{.rownames}.
#' @export
#' @keywords manip
#' @examples
#' name_rows(mtcars)
#' name_rows(name_rows(mtcars))
#'
#' df <- data.frame(a = sample(10))
#' arrange(df, a)
#' arrange(name_rows(df), a)
#' name_rows(arrange(name_rows(df), a))
name_rows <- function(df) {
  stopifnot(is.data.frame(df))

  rn_col <- !is.null(df$.rownames)

  if (rn_col) {
    rownames(df) <- df$.rownames
    df$.rownames <- NULL
  } else {
    df$.rownames <- rownames(df)
    rownames(df) <- NULL
  }

  df
}

#' Vector aggregate.
#'
#' This function is somewhat similar to \code{tapply}, but is designed for
#' use in conjunction with \code{id}. It is simpler in that it only 
#' accepts a single grouping vector (use \code{\link{id}} if you have more)
#' and uses \code{\link{vapply}} internally, using the \code{.default} value
#' as the template.
#' 
#' \code{vaggregate} should be faster than \code{tapply} in most situations
#' because it avoids making a copy of the data.
#' 
#' @param .value vector of values to aggregate
#' @param .group grouping vector
#' @param .fun aggregation function
#' @param ... other arguments passed on to \code{.fun}
#' @param .default default value used for missing groups.  This argument is 
#'   also used as the template for function output.
#' @param .n total number of groups
#' @export
#' @examples
#' # Some examples of use borrowed from ?tapply
#' n <- 17; fac <- factor(rep(1:3, length = n), levels = 1:5)
#' table(fac)
#' vaggregate(1:n, fac, sum)
#' vaggregate(1:n, fac, sum, .default = NA_integer_)
#' vaggregate(1:n, fac, range)
#' vaggregate(1:n, fac, range, .default = c(NA, NA) + 0)
#' vaggregate(1:n, fac, quantile)
#' # Unlike tapply, vaggregate does not support multi-d output:
#' tapply(warpbreaks$breaks, warpbreaks[,-1], sum)
#' vaggregate(warpbreaks$breaks, id(warpbreaks[,-1]), sum)
#' 
#' # But it is about 10x faster
#' x <- rnorm(1e6)
#' y1 <- sample.int(10, 1e6, replace = TRUE)
#' system.time(tapply(x, y1, mean))
#' system.time(vaggregate(x, y1, mean))
vaggregate <- function(.value, .group, .fun, ..., .default = NULL, .n = nlevels(.group)) {
  if (!is.integer(.group)) {
    if (is.list(.group)) {
      .group <- id(.group)
    } else {
      .group <- id(list(.group))
    }
  }

  if (is.null(.default)) {
    .default <- .fun(.value[0], ...)
  }
  
  fun <- function(i) {
    if (length(i) == 0) return(.default)
    .fun(.value[i], ...)
  }

  indices <- split_indices(seq_along(.value), .group, .n)
  vapply(indices, fun, .default)
}

nlevels <- function(x) {
  n <- attr(x, "n")
  if (!is.null(n)) n else max(x)
}

#' Call function with arguments in array or data frame, returning an array.
#'
#' Call a multi-argument function with values taken from columns of an
#' data frame or array, and combine results into an array
#'
#' @template ply
#' @template m-
#' @template -a
#' @export
#' @examples
#' maply(cbind(mean = 1:5, sd = 1:5), rnorm, n = 5)
#' maply(expand.grid(mean = 1:5, sd = 1:5), rnorm, n = 5)
#' maply(cbind(1:5, 1:5), rnorm, n = 5)
maply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none",
                  .inform = FALSE, .drop = TRUE, .parallel = FALSE,
                  .paropts = NULL) {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)

  f <- splat(.fun)
  aaply(.data = .data, .margins = 1, .fun = f, ...,
    .expand = .expand, .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts, .drop = .drop)
}

if (Sys.info()["user"] == "hadley")  {
 library(devtools)
 # check("reshape2", document = FALSE)
 check_cran("lubridate")
 check_cran("ggplot2")
 check_cran("reshape")
 check_cran("stringr")
 check_cran("nullabor")
 check_cran("stringr")
 check_cran("productplots")
 check_cran("reshape2")

}

#' Call function with arguments in array or data frame, returning a list.
#'
#' Call a multi-argument function with values taken from columns of an
#' data frame or array, and combine results into a list.
#'
#' @template ply
#' @template m-
#' @template -l
#' @export
#' @examples
#' mlply(cbind(1:4, 4:1), rep)
#' mlply(cbind(1:4, times = 4:1), rep)
#'
#' mlply(cbind(1:4, 4:1), seq)
#' mlply(cbind(1:4, length = 4:1), seq)
#' mlply(cbind(1:4, by = 4:1), seq, to = 20)
mlply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none",
                  .inform = FALSE, .parallel = FALSE, .paropts = NULL) {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)

  f <- splat(.fun)
  alply(.data = .data, .margins = 1, .fun = f, ...,
    .expand = .expand, .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts)
}

#' List to array.
#'
#' Reduce/simplify a list of homogenous objects to an array
#'
#' @param res list of input data
#' @param labels a data frame of labels, one row for each element of res
#' @param .drop should extra dimensions be dropped (TRUE) or preserved (FALSE)
#' @family list simplification functions
#' @keywords internal
list_to_array <- function(res, labels = NULL, .drop = FALSE) {
  if (length(res) == 0) return(vector())
  n <- length(res)

  atomic <- sapply(res, is.atomic)
  if (all(atomic) || all(!atomic)) {
    dlength <- unique.default(llply(res, dims))
    if (length(dlength) != 1)
      stop("Results must have the same number of dimensions.")

    dims <- unique(do.call("rbind", llply(res, amv_dim)))

    if (is.null(dims))
      stop("Results must have one or more dimensions.", call. = FALSE)
    if (nrow(dims) != 1)
      stop("Results must have the same dimensions.", call. = FALSE)

    res_dim <- amv_dim(res[[1]])
    res_labels <- amv_dimnames(res[[1]])
    if (any(vapply(res_labels, anyDuplicated, integer(1)) != 0)) {
      warning("Duplicate names not supported.", call. = FALSE)
    }
    res_index <- expand.grid(res_labels)

    res <- unlist(res, use.names = FALSE, recursive = FALSE)
  } else {
    stop("Results must have compatible types.")
  }

  if (is.null(labels)) {
    labels <- data.frame(X = seq_len(n))
    in_labels <- list(NULL)
    in_dim <- n
  } else {
    in_labels <- lapply(labels,
      function(x) if(is.factor(x)) levels(x) else sort(unique(x), na.last = TRUE))
    in_dim <- sapply(in_labels, length)
  }

  # Work out where each result should go in the new array
  index_old <- rep(id(rev(labels)), each = nrow(res_index))
  index_new <- rep(id(rev(res_index)), nrow(labels))
  index <- (index_new - 1) * prod(in_dim) + index_old

  out_dim <- unname(c(in_dim, res_dim))
  out_labels <- c(in_labels, res_labels)
  n <- prod(out_dim)

  if (length(index) < n) {
    overall <- match(1:n, index, nomatch = NA)
  } else {
    overall <- order(index)
  }

  out_array <- res[overall]
  dim(out_array) <- out_dim
  dimnames(out_array) <- out_labels
  if (.drop) reduce_dim(out_array) else out_array
}

#' Loop apply
#'
#' An optimised version of lapply for the special case of operating on 
#' \code{seq_len(n)}
#'
#' @param n length of sequence
#' @param f function to apply to each integer
#' @param env environment in which to evaluate function
#' @useDynLib plyr
#' @keywords internal manip
loop_apply <- function(n, f, env = parent.frame()) {
  print("CALLING LOOP APPLY")
  .Call("loop_apply", as.integer(n), f, env)
  print("DONE LOOP APPLY")
}

#' Split list, apply function, and discard results.
#'
#' For each element of a list, apply function and discard results
#'
#' @template ply
#' @template l-
#' @template -_
#' @export
#' @examples
#' l_ply(llply(mtcars, round), table, .print = TRUE)
#' l_ply(baseball, function(x) print(summary(x)))
l_ply <- function(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
                  .print = FALSE, .parallel = FALSE, .paropts = NULL) {
  if (is.character(.fun) || is.list(.fun)) .fun <- each(.fun)
  if (!is.function(.fun)) stop(".fun is not a function.")

  pieces <- as.list(.data)

  n <- length(pieces)
  if (n == 0) return(invisible())

  if (.parallel && .progress != "none") {
    message("Progress disabled when using parallel plyr")
    .progress <- "none"
  }

  progress <- create_progress_bar(.progress)
  progress$init(n)
  on.exit(progress$term())

  if (.parallel && .print) {
    message("Printing disabled for parallel processing")
    .print <- FALSE
  }

  do.ply <- function(i) {
    piece <- pieces[[i]]

    # Display informative error messages, if desired
    if (.inform) {
      res <- try(.fun(piece, ...))
      if (inherits(res, "try-error")) {
        piece <- paste(capture.output(print(piece)), collapse = "\n")
        stop("with piece ", i, ": \n", piece, call. = FALSE)
      }
    } else {
      res <- .fun(piece, ...)
    }
    if (.print) {
      print(res)
    }
    progress$step()
  }
  if (.parallel) {
    setup_parallel()
    .paropts$.combine <- function(...) NULL

    i <- seq_len(n)
    fe_call <- as.call(c(list(quote(foreach::foreach), i = i), .paropts))
    fe <- eval(fe_call)

    foreach::`%dopar%`(fe, do.ply(i))
  } else {
    for (i in seq_len(n)) {
      do.ply(i)
    }
  }

  invisible()
}

context("Parallel")

with_parallel <- function(code) {
  skip_on_cran()
  skip_if_not_installed("doParallel")

  doParallel::registerDoParallel(cores = 2)
  on.exit(doParallel::stopImplicitCluster())
  code
}

test_that("l_ply respects .parallel", {
  with_parallel(
    expect_that(
      l_ply(c(0.1, 0.1), Sys.sleep, .parallel = TRUE),
      takes_less_than(0.18))
  )
})

test_that("l_ply + .parallel complains about invalid arguments", {
  with_parallel({
    expect_message(
      l_ply(1:10, force, .parallel = TRUE, .print = TRUE),
      "Printing disabled")
    expect_message(
      l_ply(1:10, force, .parallel = TRUE, .progress = "text"),
      "Progress disabled")
  })
})

test_that("llply + .parallel complains about invalid arguments", {
  with_parallel({
    expect_message(
      llply(1:10, force, .parallel = TRUE, .progress = "text"),
      "Progress disabled")
  })
})

test_that(".paropts passes options to foreach", {
  combine <- function(a, b) NULL
  with_parallel(x <- llply(1:10, identity, .parallel = TRUE,
    .paropts = list(.combine = combine)))
  expect_equal(x, NULL)
})

#' Experimental iterator based version of llply.
#' 
#' Because iterators do not have known length, \code{liply} starts by 
#' allocating an output list of length 50, and then doubles that length 
#' whenever it runs out of space.  This gives O(n ln n) performance rather 
#' than the O(n ^ 2) performance from the naive strategy of growing the list
#' each time.
#' 
#' @keywords manip
#' @param .iterator iterator object
#' @param .fun function to apply to each piece
#' @param ... other arguments passed on to \code{.fun}
#' @export
#' @examples
#' if(require("iterators")) {
#'   system.time(dlply(baseball, "id", summarise, mean_rbi = mean(rbi)))
#'   system.time({
#'     baseball_id <- isplit2(baseball, baseball$id)
#'     liply(baseball_id, summarise, mean_rbi = mean(rbi, na.rm = TRUE))
#'   })
#'   # Iterators get used up:
#'   liply(baseball_id, summarise, mean_rbi = mean(rbi, na.rm = TRUE))
#' }
liply <- function(.iterator, .fun = NULL, ...) {
  stopifnot(inherits(.iterator, "iter"))
  if (is.null(.fun)) return(as.list(.iterator))
  
  iterator <- itertools::ihasNext(.iterator)
  
  if (is.character(.fun)) .fun <- each(.fun)
  if (!is.function(.fun)) stop(".fun is not a function.")
  
  result <- vector("list", 50)
  i <- 0

  while(itertools::hasNext(iterator)) {
    piece <- iterators::nextElem(iterator)
    res <- .fun(piece, ...)
    
    # Double length of vector when necessary.  Gives O(n ln n) performance
    # instead of naive O(n^2)
    i <- i + 1
    if (i > length(result)) {
      length(result) <- length(result) * 2
    }
    if (!is.null(res)) result[[i]] <- res
  }
  length(result) <- i
  
  result
}

#' Split iterator that returns values, not indices.
#'
#' @keywords internal
#' @export
isplit2 <- function (x, f, drop = FALSE, ...)  {
  it <- iterators::isplit(seq_len(nrow(x)), f, drop = drop, ...)
  nextEl <- function() {
    i <- iterators::nextElem(it)
    x[i$value, , drop = FALSE]
  }
  structure(list(nextElem = nextEl), class = c("abstractiter", "iter"))
}

#' @section Input: This function splits lists by elements and combines the
#'   result into a data frame.
#'
#' @param .data list to be processed
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#' @family list input

#' @section Output: 
#'   The most unambiguous behaviour is achieved when \code{.fun} returns a 
#'   data frame - in that case pieces will be combined with
#'   \code{\link{rbind.fill}}.  If \code{.fun} returns an atomic vector of
#'   fixed length, it will be \code{rbind}ed together and converted to a data
#'   frame. Any other values will result in an error.
#'
#'  If there are no results, then this function will return a data
#'  frame with zero rows and columns (\code{data.frame()}).
#'
#' @return A data frame, as described in the output section.
#' @family data frame output

#' Column-wise function.
#'
#' Turn a function that operates on a vector into a function that operates
#' column-wise on a data.frame.
#'
#' \code{catcolwise} and \code{numcolwise} provide version that only operate
#' on discrete and numeric variables respectively.
#'
#' @param .fun function
#' @param .cols either a function that tests columns for inclusion, or a
#'   quoted object giving which columns to process
#' @param ... other arguments passed on to \code{.fun}
#' @export
#' @examples
#' # Count number of missing values
#' nmissing <- function(x) sum(is.na(x))
#'
#' # Apply to every column in a data frame
#' colwise(nmissing)(baseball)
#' # This syntax looks a little different.  It is shorthand for the
#' # the following:
#' f <- colwise(nmissing)
#' f(baseball)
#'
#' # This is particularly useful in conjunction with d*ply
#' ddply(baseball, .(year), colwise(nmissing))
#'
#' # To operate only on specified columns, supply them as the second
#' # argument.  Many different forms are accepted.
#' ddply(baseball, .(year), colwise(nmissing, .(sb, cs, so)))
#' ddply(baseball, .(year), colwise(nmissing, c("sb", "cs", "so")))
#' ddply(baseball, .(year), colwise(nmissing, ~ sb + cs + so))
#'
#' # Alternatively, you can specify a boolean function that determines
#' # whether or not a column should be included
#' ddply(baseball, .(year), colwise(nmissing, is.character))
#' ddply(baseball, .(year), colwise(nmissing, is.numeric))
#' ddply(baseball, .(year), colwise(nmissing, is.discrete))
#'
#' # These last two cases are particularly common, so some shortcuts are
#' # provided:
#' ddply(baseball, .(year), numcolwise(nmissing))
#' ddply(baseball, .(year), catcolwise(nmissing))
#'
#' # You can supply additional arguments to either colwise, or the function
#' # it generates:
#' numcolwise(mean)(baseball, na.rm = TRUE)
#' numcolwise(mean, na.rm = TRUE)(baseball)
colwise <- function(.fun, .cols = true, ...) {
  if (!is.function(.cols)) {
    .cols <- as.quoted(.cols)
    filter <- function(df) eval.quoted(.cols, df)
  } else {
    filter <- function(df) Filter(.cols, df)
  }

  dots <- list(...)
  function(df, ...) {
    stopifnot(is.data.frame(df))
    df <- strip_splits(df)
    filtered <- filter(df)
    if (length(filtered) == 0) return(data.frame())

    out <- do.call("lapply", c(list(filtered, .fun, ...), dots))
    names(out) <- names(filtered)

    quickdf(out)
  }
}

#' @rdname colwise
#' @export
catcolwise <- function(.fun, ...) {
  colwise(.fun, is.discrete, ...)
}

#' @rdname colwise
#' @export
numcolwise <- function(.fun, ...) {
  colwise(.fun, is.numeric, ...)
}

#' Subset splits.
#'
#' Subset splits, ensuring that labels keep matching
#'
#' @keywords internal
#' @param x split object
#' @param i index
#' @param ... unused
#' @method [ split
#' @rdname get-split
#' @export
"[.split" <- function(x, i, ...) {
  structure(
    NextMethod(),
    class = c("split", "list"),
    split_type = attr(x, "split_type"),
    split_labels = attr(x, "split_labels")[i, , drop = FALSE]
  )
}

#' Convert split list to regular list.
#'
#' Strip off label related attributed to make a strip list as regular list
#'
#' @keywords internal
#' @param x object to convert to a list
#' @param ... unused
#' @method as.list split
#' @export
as.list.split <- function(x, ...) {
  attr(x, "split_type") <- NULL
  attr(x, "split_labels") <- NULL
  class(x) <- setdiff(class(x), "split")
  x
}

#' Print split.
#'
#' Don't print labels, so it appears like a regular list
#'
#' @keywords internal
#' @param x object to print
#' @param ... unused
#' @method print split
#' @export
print.split <- function(x, ...) {
  print(as.list(x))
}

#' Join two data frames together.
#'
#' Join, like merge, is designed for the types of problems
#' where you would use a sql join.
#'
#' The four join types return:
#'
#' \itemize{
#'  \item \code{inner}:  only rows with matching keys in both x and y
#'  \item \code{left}:   all rows in x, adding matching columns from y
#'  \item \code{right}:  all rows in y, adding matching columns from x
#'  \item \code{full}:   all rows in x with matching columns in y, then the
#'    rows of y that don't match x.
#' }
#'
#' Note that from plyr 1.5, \code{join} will (by default) return all matches,
#' not just the first match, as it did previously.
#'
#' Unlike merge, preserves the order of x no matter what join type is used.
#' If needed, rows from y will be added to the bottom.  Join is often faster
#' than merge, although it is somewhat less featureful - it currently offers
#' no way to rename output or merge on different variables in the x and y
#' data frames.
#'
#' @param x data frame
#' @param y data frame
#' @param by character vector of variable names to join by. If omitted, will
#'   match on all common variables.
#' @param type type of join: left (default), right, inner or full.  See
#'   details for more information.
#' @param match how should duplicate ids be matched? Either match just the
#'   \code{"first"} matching row, or match \code{"all"} matching rows. Defaults
#'   to \code{"all"} for compatibility with merge, but \code{"first"} is
#'   significantly faster.
#' @keywords manip
#' @export
#' @examples
#' first <- ddply(baseball, "id", summarise, first = min(year))
#' system.time(b2 <- merge(baseball, first, by = "id", all.x = TRUE))
#' system.time(b3 <- join(baseball, first, by = "id"))
#'
#' b2 <- arrange(b2, id, year, stint)
#' b3 <- arrange(b3, id, year, stint)
#' stopifnot(all.equal(b2, b3))
join <- function(x, y, by = NULL, type = "left", match = "all") {
  type <- match.arg(type, c("left", "right", "inner", "full"))
  match <- match.arg(match, c("first", "all"))

  if (is.null(by)) {
    by <- intersect(names(x), names(y))
    message("Joining by: ", paste(by, collapse = ", "))
  }

  switch(match,
    "first" = .join_first(x, y, by, type),
    "all" = .join_all(x, y, by, type))
}

.join_first <- function(x, y, by, type) {
  keys <- join.keys(x, y, by = by)

  x.cols <- setdiff(names(x), by)
  y.cols <- setdiff(names(y), by)

  if (type == "inner") {
    x.match <- match(keys$y, keys$x, 0)
    y.match <- match(keys$x, keys$y, 0)

    cbind(
      x[x.match, by, drop = FALSE],
      x[x.match, x.cols, drop = FALSE],
      y[y.match, y.cols, drop = FALSE]
    )
  } else if (type == "left") {
    y.match <- match(keys$x, keys$y)
    y.matched <- unrowname(y[y.match, y.cols, drop = FALSE])

    cbind(x[by], x[x.cols], y.matched)
  } else if (type == "right") {
    if (any(duplicated(keys$y))) {
      stop("Duplicated key in y", call. = FALSE)
    }

    x.match <- match(keys$y, keys$x)
    x.matched <- unrowname(x[x.match, x.cols, drop = FALSE])

    cbind(y[by], x.matched, y[y.cols])
  } else if (type == "full") {
    # x with matching y's then any unmatched ys

    y.match <- match(keys$x, keys$y)
    y.matched <- unrowname(y[y.match, y.cols, drop = FALSE])

    y.unmatch <- is.na(match(keys$y, keys$x))

    rbind.fill(cbind(x[c(by, x.cols)], y.matched), y[y.unmatch, , drop = FALSE])
  }
}

# Basic idea to perform a full cartesian product of the two data frames
# and then evaluate which rows meet the merging criteria. But that is
# horrendously inefficient, so we do various types of hashing, implemented
# in R as split_indices
.join_all <- function(x, y, by, type) {
  x.cols <- setdiff(names(x), by)
  y.cols <- setdiff(names(y), by)

  if (type == "inner") {
    ids <- join_ids(x, y, by)
    out <- cbind(x[ids$x, , drop = FALSE], y[ids$y, y.cols, drop = FALSE])
  } else if (type == "left") {
    ids <- join_ids(x, y, by, all = TRUE)
    out <- cbind(x[ids$x, , drop = FALSE], y[ids$y, y.cols, drop = FALSE])
  } else if (type == "right") {
    # Flip x and y, but make sure to put new columns in the right place
    ids <- join_ids(y, x, by, all = TRUE)
    out <- cbind(
      y[ids$x, by, drop = FALSE],
      x[ids$y, x.cols, drop = FALSE],
      y[ids$x, y.cols, drop = FALSE]
    )
  } else if (type == "full") {
    # x's with all matching y's, then non-matching y's - just the same as
    # join.first
    ids <- join_ids(x, y, by, all = TRUE)

    matched <- cbind(x[ids$x, , drop = FALSE],
                     y[ids$y, y.cols, drop = FALSE])
    unmatched <- y[setdiff(seq_len(nrow(y)), ids$y), , drop = FALSE]
    out <- rbind.fill(matched, unmatched)
  }

  unrowname(out)
}

join_ids <- function(x, y, by, all = FALSE) {
  keys <- join.keys(x, y, by = by)

  ys <- split_indices(keys$y, keys$n)
  length(ys) <- keys$n

  if (all) {
    # replace NULL with NA to preserve those x's without matching y's
    nulls <- vapply(ys, function(x) length(x) == 0, logical(1))
    ys[nulls] <- list(NA_real_)
  }

  ys <- ys[keys$x]
  xs <- rep(seq_along(keys$x), vapply(ys, length, numeric(1)))

  list(x = xs, y = unlist(ys))
}

#' Join keys.
#' Given two data frames, create a unique key for each row.
#'
#' @param x data frame
#' @param y data frame
#' @param by character vector of variable names to join by
#' @keywords internal
#' @export
join.keys <- function(x, y, by) {
  joint <- rbind.fill(x[by], y[by])
  keys <- id(joint, drop = TRUE)

  n_x <- nrow(x)
  n_y <- nrow(y)

  list(
    x = keys[seq_len(n_x)],
    y = keys[n_x + seq_len(n_y)],
    n = attr(keys, "n")
  )
}

#' Split list, apply function, and return results in a list.
#'
#' For each element of a list, apply function, keeping results as a list.
#' \code{llply} is equivalent to \code{\link{lapply}} except that it will 
#' preserve labels and can display a progress bar.
#' 
#' @template ply
#' @template l-
#' @template -l
#' @param .inform produce informative error messages?  This is turned off by
#'   by default because it substantially slows processing speed, but is very
#'   useful for debugging
#' @export
#' @examples
#' llply(llply(mtcars, round), table)
#' llply(baseball, summary)
#' # Examples from ?lapply
#' x <- list(a = 1:10, beta = exp(-3:3), logic = c(TRUE,FALSE,FALSE,TRUE))
#'
#' llply(x, mean)
#' llply(x, quantile, probs = 1:3/4)
llply <- function(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE, .parallel = FALSE) {
  if (is.null(.fun)) return(as.list(.data))
  if (is.character(.fun) || is.list(.fun)) .fun <- each(.fun)
  if (!is.function(.fun)) stop(".fun is not a function.")

  if (!inherits(.data, "split")) {
    pieces <- as.list(.data)

    # This special case can be done much faster with lapply, so do it.
    fast_path <- .progress == "none" && !.inform && !.parallel
    if (fast_path) {
      return(structure(lapply(pieces, .fun, ...), dim = dim(pieces)))
    }
    
  } else {
    pieces <- .data
  }
  
  n <- length(pieces)
  if (n == 0) return(list())
  
  progress <- create_progress_bar(.progress)
  progress$init(n)
  on.exit(progress$term())

  result <- vector("list", n)
  do.ply <- function(i) {
    piece <- pieces[[i]]

    # Display informative error messages, if desired
    if (.inform) {
      res <- try(.fun(piece, ...))
      if (inherits(res, "try-error")) {
        piece <- paste(capture.output(print(piece)), collapse = "\n")
        stop("with piece ", i, ": \n", piece, call. = FALSE)
      }      
    } else {
      res <- .fun(piece, ...)
    }
    progress$step()
    res
  }
  if (.parallel) {
    if (!require("foreach")) {
      stop("foreach package required for parallel plyr operation", 
        call. = FALSE)
    }
    if (getDoParWorkers() == 1) {
      warning("No parallel backend registered", call. = TRUE)
    }
    result <- foreach(i = seq_len(n)) %dopar% do.ply(i)
  } else {
    result <- loop_apply(n, do.ply)
  }
  
  attributes(result)[c("split_type", "split_labels")] <-
    attributes(pieces)[c("split_type", "split_labels")]
  names(result) <- names(pieces)

  # Only set dimension if not null, otherwise names are removed
  if (!is.null(dim(pieces))) {
    dim(result) <- dim(pieces)    
  }
  
  result
}

#' Split data frame, apply function, and return results in a list.
#'
#' For each subset of a data frame, apply function then combine results into a
#' list. \code{dlply} is similar to \code{\link{by}} except that the results
#' are returned in a different format.
#' 
#' @template ply
#' @template d-
#' @template -l
#' @export
#' @examples
#' linmod <- function(df) {
#'   lm(rbi ~ year, data = mutate(df, year = year - min(year)))
#' }
#' models <- dlply(baseball, .(id), linmod)
#' models[[1]]
#'
#' coef <- ldply(models, coef)
#' with(coef, plot(`(Intercept)`, year))
#' qual <- laply(models, function(mod) summary(mod)$r.squared)
#' hist(qual)
dlply <- function(.data, .variables, .fun = NULL, ..., .progress = "none", .drop = TRUE, .parallel = FALSE) {
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop)
  
  llply(.data = pieces, .fun = .fun, ..., 
    .progress = .progress, .parallel = .parallel)
}

#' Split array, apply function, and return results in a list.
#'
#' For each slice of an array, apply function then combine results into a
#' list. \code{alply} is somewhat similar to \code{\link{apply}} for cases
#' where the results are not atomic.
#' 
#' @template ply
#' @template a-
#' @template -l
#' @export
#' @examples
#' alply(ozone, 3, quantile)
#' alply(ozone, 3, function(x) table(round(x)))
alply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE, .progress = "none", .parallel = FALSE) {
  pieces <- splitter_a(.data, .margins, .expand)
  
  llply(.data = pieces, .fun = .fun, ..., 
    .progress = .progress, .parallel = .parallel)
}

context("Lists")

test_that("data frame variables converted to list names", {
  x <- dlply(esoph, .(alcgp), function(df) mean(df$ncases))
  expect_that(names(x), equals(levels(esoph$alcgp)))

  x <- dlply(esoph, .(alcgp, agegp), function(df) mean(df$ncases))
  y <- ddply(esoph, .(alcgp, agegp), function(df) mean(df$ncases))
  labs <- paste(y$alcgp, y$agegp, sep = ".")
  expect_that(names(x), equals(labs))
  
})

test_that("list names are preserved", {
  a <- 1:10
  expect_that(names(llply(a)), equals(NULL))

  names(a) <- letters[1:10]
  expect_that(names(llply(a)), equals(letters[1:10]))
  
})

context("Lists")

test_that("data frame variables converted to list names", {
  x <- dlply(esoph, .(alcgp), function(df) mean(df$ncases))
  expect_that(names(x), equals(levels(esoph$alcgp)))

  x <- dlply(esoph, .(alcgp, agegp), function(df) mean(df$ncases))
  y <- ddply(esoph, .(alcgp, agegp), function(df) mean(df$ncases))
  labs <- paste(y$alcgp, y$agegp, sep = ".")
  expect_that(names(x), equals(labs))

})

test_that("list names are preserved", {
  a <- 1:10
  expect_that(names(llply(a)), equals(NULL))

  names(a) <- letters[1:10]
  expect_that(names(llply(a)), equals(letters[1:10]))

})

# Test for #142
test_that(".n column can be renamed or dropped", {
  f <- function() data.frame(r=runif(1))

  out1 <- rdply(4, f)
  out2 <- rdply(4, f, .id='x')

  expect_equal(names(out1), c('.n', 'r'))
  expect_equal(names(out2), c('x', 'r'))

  # more testing
  expect_identical(out1$.n, seq_len(4))
  expect_identical(out2$x, seq_len(4))

  out <- rdply(4, f, .id=NULL)
  expect_equal(names(out), c('r'))
  expect_false(out$r[4] == 4)

  out <- rdply(4, f, .id='r') # names conflict
  expect_equal(names(out), c('r'))

  out <- rdply(4, f, .id='.n') # defaults
  expect_equal(names(out), c('.n', 'r'))
  expect_identical(out$.n, seq_len(4))
})

context("Progress bars")

test_that("unknown progress bar raised warning, not error", {
  old <- options(warn = 2)
  on.exit(options(old))
  expect_that(
    llply(1:10, identity, .progress = "blah"),
    throws_error("Cannot find progress bar")
  )
})

context("Empty inputs")

test_that("empty arrays returns object of same shape", {
  x <- structure(integer(0), .Dim = c(0L, 0L, 0L))

  expect_that(aaply(x, 1, identity), equals(logical()))
  expect_that(aaply(x, 2, identity), equals(logical()))
  expect_that(aaply(x, 3, identity), equals(logical()))

  expect_that(adply(x, 1, identity), equals(data.frame()))
  expect_that(alply(x, 1, identity), is_equivalent_to(list()))
})

test_that("empty lists return an empty object", {
  expect_that(llply(list(), identity), equals(list()))
  expect_that(laply(list(), identity), equals(logical()))
  expect_that(ldply(list(), identity), equals(data.frame()))
})

test_that("empty data frames returns empty object", {
  df <- data.frame(x = numeric(0), a = numeric(0))
  expect_that(ddply(df, "a", identity), equals(df))
  expect_that(dlply(df, "a", identity), equals(list()))
  expect_that(daply(df, "a", identity), equals(logical()))
})

test_that("empty data frame results returns empty object", {
  df <- data.frame(a = 1:10)
  expect_that(
    ddply(df, "a", function(x) NULL),
    equals(data.frame()))
  expect_that(
    dlply(df, "a", function(x) NULL),
    equals(rep(list(NULL), 10), check.attributes = FALSE))
  expect_that(
    daply(df, "a", function(x) NULL),
    throws_error("must have one or more dimensions"))

})

#' Round to multiple of any number.
#' 
#' @param x numeric vector to round
#' @param accuracy number to round to
#' @param f rounding function: \code{\link{floor}}, \code{\link{ceiling}} or 
#'  \code{\link{round}}
#' @keywords manip
#' @export
#' @examples
#' round_any(135, 10)
#' round_any(135, 100)
#' round_any(135, 25)
#' round_any(135, 10, floor)
#' round_any(135, 100, floor)
#' round_any(135, 25, floor)
#' round_any(135, 10, ceiling)
#' round_any(135, 100, ceiling)
#' round_any(135, 25, ceiling)
round_any <- function(x, accuracy, f = round) {
  f(x / accuracy) * accuracy
}

#' Set defaults.
#'
#' Convient method for combining a list of values with their defaults.
#' 
#' @param x list of values
#' @param y defaults
#' @keywords manip 
#' @export
defaults <- function(x, y)  {
  c(x, y[setdiff(names(y), names(x))])
} 

#' Extract matching rows of a data frame.
#'
#' Match works in the same way as join, but instead of return the combined
#' dataset, it only returns the matching rows from the first dataset. This is
#' particularly useful when you've summarised the data in some way
#' and want to subset the original data by a characteristic of the subset.
#'
#' \code{match_df} shares the same semantics as \code{\link{join}}, not
#' \code{\link{match}}:
#'
#' \itemize{
#'   \item the match criterion is \code{==}, not \code{\link{identical}}).
#'   \item it doesn't work for columns that are not atomic vectors
#'   \item if there are no matches, the row will be omitted'
#' }
#'
#' @param x data frame to subset.
#' @param y data frame defining matching rows.
#' @param on variables to match on - by default will use all variables common
#'   to both data frames.
#' @return a data frame
#' @seealso \code{\link{join}} to combine the columns from both x and y
#'  and \code{\link{match}} for the base function selecting matching items
#' @export
#' @examples
#' # count the occurrences of each id in the baseball dataframe, then get the subset with a freq >25
#' longterm <- subset(count(baseball, "id"), freq > 25)
#' # longterm
#' #             id freq
#' # 30   ansonca01   27
#' # 48   baineha01   27
#' # ...
#' # Select only rows from these longterm players from the baseball dataframe
#' # (match would default to match on shared column names, but here was explicitly set "id")
#' bb_longterm <- match_df(baseball, longterm, on="id")
#' bb_longterm[1:5,]
match_df <- function(x, y, on = NULL) {
  if (is.null(on)) {
    on <- intersect(names(x), names(y))
    message("Matching on: ", paste(on, collapse = ", "))
  }

  keys <- join.keys(x, y, on)
  x[keys$x %in% keys$y, , drop = FALSE]
}

#' Replace specified values with new values, in a factor or character vector.
#'
#' If \code{x} is a factor, the named levels of the factor will be
#' replaced with the new values.
#'
#' This function works only on character vectors and factors, but the
#' related \code{mapvalues} function works on vectors of any type and factors,
#' and instead of a named vector specifying the original and replacement values,
#' it takes two separate vectors
#'
#' @param x factor or character vector to modify
#' @param replace named character vector, with new values as values, and
#'   old values as names.
#' @param warn_missing print a message if any of the old values are
#'   not actually present in \code{x}
#'
#' @seealso \code{\link{mapvalues}} to replace values with vectors of any type
#' @export
#' @examples
#' x <- c("a", "b", "c")
#' revalue(x, c(a = "A", c = "C"))
#' revalue(x, c("a" = "A", "c" = "C"))
#'
#' y <- factor(c("a", "b", "c", "a"))
#' revalue(y, c(a = "A", c = "C"))
revalue <- function(x, replace = NULL, warn_missing = TRUE) {
  if (!is.null(x) && !is.factor(x) && !is.character(x)) {
    stop("x is not a factor or a character vector.")
  }

  mapvalues(x, from = names(replace), to = replace, warn_missing = warn_missing)
}


#' Replace specified values with new values, in a vector or factor.
#'
#' Item in \code{x} that match items \code{from} will be replaced by
#' items in \code{to}, matched by position. For example, items in \code{x} that
#' match the first element in \code{from} will be replaced by the first
#' element of \code{to}.
#'
#' If \code{x} is a factor, the matching levels of the factor will be
#' replaced with the new values.
#'
#' The related \code{revalue} function works only on character vectors
#' and factors, but this function works on vectors of any type and factors.
#'
#' @param x the factor or vector to modify
#' @param from a vector of the items to replace
#' @param to a vector of replacement values
#' @param warn_missing print a message if any of the old values are
#'   not actually present in \code{x}
#'
#' @seealso \code{\link{revalue}} to do the same thing but with a single
#'   named vector instead of two separate vectors.
#' @export
#' @examples
#' x <- c("a", "b", "c")
#' mapvalues(x, c("a", "c"), c("A", "C"))
#'
#' # Works on factors
#' y <- factor(c("a", "b", "c", "a"))
#' mapvalues(y, c("a", "c"), c("A", "C"))
#'
#' # Works on numeric vectors
#' z <- c(1, 4, 5, 9)
#' mapvalues(z, from = c(1, 5, 9), to = c(10, 50, 90))
mapvalues <- function(x, from, to, warn_missing = TRUE) {
  if (length(from) != length(to)) {
    stop("`from` and `to` vectors are not the same length.")
  }
  if (!is.atomic(x)) {
    stop("`x` must be an atomic vector.")
  }

  if (is.factor(x)) {
    # If x is a factor, call self but operate on the levels
    levels(x) <- mapvalues(levels(x), from, to, warn_missing)
    return(x)
  }

  mapidx <- match(x, from)
  mapidxNA  <- is.na(mapidx)

  # index of items in `from` that were found in `x`
  from_found <- sort(unique(mapidx))
  if (warn_missing && length(from_found) != length(from)) {
    message("The following `from` values were not present in `x`: ",
      paste(from[!(1:length(from) %in% from_found) ], collapse = ", "))
  }

  x[!mapidxNA] <- to[mapidx[!mapidxNA]]
  x
}

context("Replace values")


# Character vector
chr <- c("A2", "A1", "A3", "A1")
# Factor: To complicate things, set levels in a different order
fac  <- factor(c("A1", "A2", "A3"), levels=c("A2", "A1", "A3"))
# Numeric vector
num <- c(4, 1, 5, 8)


# test warn if any missing

test_that("Empty mapping results in no change", {
  expect_identical(mapvalues(chr, from = NULL, to = NULL), chr)
  expect_identical(revalue(chr, NULL), chr)

  expect_identical(mapvalues(fac, from = NULL, to = NULL), fac)
  expect_identical(revalue(fac, NULL), fac)
})

test_that("Basic mapping works", {
  newchr <- c("B2", "A1", "B3", "A1")
  expect_identical(mapvalues(chr, c("A3", "A2"), c("B3", "B2")), newchr)
  expect_identical(revalue(chr, c(A3="B3", A2="B2")), newchr)

  newfac <- factor(c("A1", "B2", "B3"), levels=c("B2", "A1", "B3"))
  expect_identical(mapvalues(fac, c("A3", "A2"), c("B3", "B2")), newfac)
  expect_identical(revalue(fac, c(A3="B3", A2="B2")), newfac)

  newnum <- c(40, 1, 5, 80)
  expect_identical(mapvalues(num, c(4, 8), c(40, 80)), newnum)
  # revalue doesn't work for numeric vectors
})

test_that("Mapping with repeated original values - uses first instance, and gives message", {
  newchr <- c("A2", "B1", "A3", "B1")
  expect_message(
    expect_identical(mapvalues(chr, c("A1", "A1"), c("B1", "C1")), newchr))
  expect_message(
    expect_identical(revalue(chr, c(A1="B1", A1="C1")), newchr))


  newfac <- factor(c("B1", "A2", "A3"), levels=c("A2", "B1", "A3"))
  expect_message(
    expect_identical(mapvalues(fac, c("A1", "A1"), c("B1", "C1")), newfac))
  expect_message(
    expect_identical(revalue(fac, c(A1="B1", A1="C1")), newfac))

  newnum <- c(4, 1, 5, 80)
  expect_message(
    expect_identical(mapvalues(num, c(8, 8), c(80, 800)), newnum))
})

test_that("Mapping with repeated new value (for factors, levels are in earliest position)", {
  newchr <- c("BX", "A1", "BX", "A1")
  expect_identical(mapvalues(chr, c("A3", "A2"), c("BX", "BX")), newchr)
  expect_identical(revalue(chr, c(A3="BX", A2="BX")), newchr)


  newfac <- factor(c("A1", "BX", "BX"), levels=c("BX", "A1"))
  expect_identical(revalue(fac, c(A3="BX", A2="BX")), newfac)

  # Factors can have levels in different orders
  newfac2 <- factor(c("BX", "A2", "BX"), levels=c("A2", "BX"))
  expect_identical(revalue(fac, c(A3="BX", A1="BX")), newfac2)
})

test_that("Mapping with multiple matches works", {
  newchr <- c("B2", "B1", "A3", "B1")
  expect_identical(mapvalues(chr, c("A1", "A2"), c("B1", "B2")), newchr)
  expect_identical(revalue(chr, c(A1="B1", A2="B2")), newchr)
  # Not relevant for factors because they can't have two levels be the same
})

test_that("Mapping with non-matching original levels results in no change, and message", {
  expect_message(
    expect_identical(revalue(chr, c(A4="B4")), chr))
  expect_message(
    expect_identical(revalue(chr, c(A3="B3", A4="B4")), c("A2", "A1", "B3", "A1")))

  expect_message(
    expect_identical(revalue(fac, c(A4="B4")), fac))
  expect_message(
    expect_identical(revalue(fac, c(A3="B3", A4="B4")),
                     factor(c("A1", "A2", "B3"), levels=c("A2", "A1", "B3"))))
})

test_that("Swapping values works", {
  newchr <- c("A3", "A1", "A2", "A1")
  expect_identical(mapvalues(chr, c("A2", "A3"), c("A3", "A2")), newchr)
  expect_identical(revalue(chr, c(A2="A3", A3="A2")), newchr)

  newfac <- factor(c("A1", "A3", "A2"), levels=c("A3", "A1", "A2"))
  expect_identical(mapvalues(fac, c("A2", "A3"), c("A3", "A2")), newfac)
  expect_identical(revalue(fac, c(A2="A3", A3="A2")), newfac)
})

test_that("Mapping with ' ' and '$' in original and replacement works", {
  chr2 <- c("A2", "A $1", "A3", "A $1")
  expect_identical(revalue(chr2, c("A $1"="B $1")),
                  c("A2", "B $1", "A3", "B $1"))

  fac2 <- factor(c("A $1", "A2", "A3"), levels=c("A2", "A $1", "A3"))
  expect_identical(revalue(fac2, c("A $1"="B $1")),
                   factor(c("B $1", "A2", "A3"), levels=c("A2", "B $1", "A3")))
})

test_that("revalue and mapvalues only accept atomic vectors", {
  expect_error(revalue(list(A=3), c("3"=30)))
  expect_error(mapvalues(list(A=3), 3, 30))
})

test_that("revalue and mapvalues accept empty vectors and NULL", {
  expect_identical(revalue(character(0), c("3"=30), warn_missing=FALSE), character(0))
  expect_identical(mapvalues(character(0), 3, 30, warn_missing=FALSE), character(0))

  expect_identical(revalue(NULL, c("3"=30), warn_missing=FALSE), NULL)
  expect_identical(mapvalues(NULL, 3, 30, warn_missing=FALSE), NULL)
})

test_that("revalue and mapvalues respect warn_missing", {
  # revalue
  expect_that(revalue("a", c("a"="A")), not(shows_message()))
  expect_that(revalue("a", c("b"="B"), warn_missing=TRUE), shows_message())
  expect_that(revalue("a", c("b"="B"), warn_missing=FALSE), not(shows_message()))

  # mapvalues
  expect_that(mapvalues("a", "a", "A"), not(shows_message()))
  expect_that(mapvalues("a", "b", "B", warn_missing=TRUE), shows_message())
  expect_that(mapvalues("a", "b", "B", warn_missing=FALSE), not(shows_message()))

  # mapvalues with factors
  expect_that(mapvalues(factor("a"), "a", "A"), not(shows_message()))
  expect_that(mapvalues(factor("a"), "b", "B", warn_missing=TRUE), shows_message())
  expect_that(mapvalues(factor("a"), "b", "B", warn_missing=FALSE), not(shows_message()))
})

#' Compute a unique numeric id for each unique row in a data frame.
#'
#' Properties:
#' \itemize{
#'   \item \code{order(id)} is equivalent to \code{do.call(order, df)}
#'   \item rows containing the same data have the same value
#'   \item if \code{drop = FALSE} then room for all possibilites
#' }
#'
#' @param .variables list of variables
#' @param drop drop unusued factor levels?
#' @return a numeric vector with attribute n, giving total number of
#'   possibilities
#' @keywords internal
#' @seealso \code{\link{id_var}}
#' @aliases id ninteraction
#' @export
id <- function(.variables, drop = FALSE) {
  # Drop all zero length inputs
  lengths <- vapply(.variables, length, integer(1))
  .variables <- .variables[lengths != 0]

  if (length(.variables) == 0) {
    n <- nrow(.variables) %||% 0L
    return(structure(seq_len(n), n = n))
  }

  # Special case for single variable
  if (length(.variables) == 1) {
    return(id_var(.variables[[1]], drop = drop))
  }

  # Calculate individual ids
  ids <- rev(lapply(.variables, id_var, drop = drop))
  p <- length(ids)

  # Calculate dimensions
  ndistinct <- vapply(ids, attr, "n", FUN.VALUE = numeric(1),
    USE.NAMES = FALSE)

  n <- prod(ndistinct)
  if (n > 2 ^ 31) {
    # Too big for integers, have to use strings, which will be much slower :(

    char_id <- do.call("paste", c(ids, sep = "\r"))
    res <- match(char_id, unique(char_id))
  } else {
    combs <- c(1, cumprod(ndistinct[-p]))

    mat <- do.call("cbind", ids)
    res <- c((mat - 1L) %*% combs + 1L) # nolint
  }
  attr(res, "n") <- n


  if (drop) {
    id_var(res, drop = TRUE)
  } else {
    structure(as.integer(res), n = attr(res, "n"))
  }
}
ninteraction <- id

#' Numeric id for a vector.
#' @keywords internal
id_var <- function(x, drop = FALSE) {
  if (length(x) == 0) return(structure(integer(), n = 0L))
  if (!is.null(attr(x, "n")) && !drop) return(x)

  if (is.factor(x) && !drop) {
    x <- addNA(x, ifany = TRUE)
    id <- as.integer(x)
    n <- length(levels(x))
  } else {
    levels <- sort(unique(x), na.last = TRUE)
    id <- match(x, levels)
    n <- max(id)
  }
  structure(id, n = n)
}

context("id")

simple_vectors <- list(
  letters,
  sample(letters),
  1:26
)

test_that("for vector, equivalent to rank", {
  for(case in simple_vectors) {
    rank <- rank(case, ties = "min")
    rank_df <- id(as.data.frame(case))

    expect_that(rank, is_equivalent_to(rank_df))
  }
})

test_that("duplicates numbered sequentially", {
  for(case in simple_vectors) {
    rank <- rep(rank(case, ties = "min"), each = 2)
    rank_df <- id(as.data.frame(rep(case, each = 2)))

    expect_that(rank, is_equivalent_to(rank_df))
  }
})

test_that("n calculated correctly", {
  n <- function(x) attr(id(x), "n")
  for(case in simple_vectors) {
    expect_that(n(as.data.frame(case)), equals(26))
  }

})

test_that("for vector + constant, equivalent to rank", {
  for(case in simple_vectors) {
    rank <- rank(case, ties = "min")

    after <- id(data.frame(case, x = 1))
    before <- id(data.frame(x = 1, case))

    expect_that(rank, is_equivalent_to(before))
    expect_that(rank, is_equivalent_to(after))
  }
})

test_that("grids are correctly ranked", {
  df <- rev(expand.grid(1:10, 1:2))

  expect_that(id(df), is_equivalent_to(1:20))
  expect_that(id(df, drop = T), is_equivalent_to(1:20))
})

test_that("NAs are placed last", {
  expect_that(id_var(c(NA, 1)), is_equivalent_to(c(2, 1)))
})

test_that("zero length input gives single number", {
  expect_that(id(character()), is_equivalent_to(1))  
})

#' Split array, apply function, and return results in a data frame.
#'
#' For each slice of an array, apply function then combine results into a data
#' frame.
#'
#' @template ply
#' @template a-
#' @template -d
#' @param .id name(s) of the index column(s).
#'   Pass \code{NULL} to avoid creation of the index column(s).
#'   Omit or pass \code{NA} to use the default names
#'   \code{"X1"}, \code{"X2"}, \ldots.
#'   Otherwise, this argument must have the same length as
#'   \code{.margins}.
#' @export
adply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE,
                  .progress = "none", .inform = FALSE, .parallel = FALSE,
                  .paropts = NULL, .id = NA) {
  pieces <- splitter_a(.data, .margins, .expand, .id)
  .id <- NA
  if (is.null(attr(pieces, "split_labels"))) {
    .id <- NULL
  }

  ldply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts,
    .id = .id)
}

#' Fail with specified value.
#'
#' Modify a function so that it returns a default value when there is an
#' error.
#'
#' @param default default value
#' @param f function
#' @param quiet all error messages be suppressed?
#' @return a function
#' @seealso \code{\link{try_default}}
#' @keywords debugging
#' @export
#' @examples
#' f <- function(x) if (x == 1) stop("Error!") else 1
#' \dontrun{
#' f(1)
#' f(2)
#' }
#'
#' safef <- failwith(NULL, f)
#' safef(1)
#' safef(2)
failwith <- function(default = NULL, f, quiet = FALSE) {
  f <- match.fun(f)
  function(...) try_default(f(...), default, quiet = quiet)
}

#' Try, with default in case of error.
#'
#' \code{try_default} wraps try so that it returns a default value in the case of error.
#' \code{tryNULL} provides a useful special case when dealing with lists.
#'
#' @param expr expression to try
#' @param default default value in case of error
#' @param quiet should errors be printed (TRUE) or ignored (FALSE, default)
#' @export
#' @keywords internal
#' @seealso \code{\link{tryapply}}
try_default <- function(expr, default, quiet = FALSE) {
  result <- default
  if (quiet) {
    tryCatch(result <- expr, error = function(e) NULL)
  } else {
    try(result <- expr)
  }
  result
}

#' @rdname try_default
#' @export
tryNULL <- function(expr) try_default(expr, NULL, quiet = TRUE)


#' Apply with built in try.
#' Uses compact, lapply and tryNULL
#'
#' @param list list to apply function \code{f} on
#' @param f function
#' @param ... further arguments to \code{f}
#' @keywords internal
#' @export
tryapply <- function(list, fun, ...) {
  compact(lapply(list, function(x) tryNULL(fun(x, ...))))
}

context("Debugging")

test_that("failwith() function", {

  expect_equal(failwith(1:10, stop, quiet = TRUE)("error"), 1:10)

})

test_that("tryNULL() function", {

  old_options <- options(show.error.messages = FALSE)
  on.exit(options(old_options), add = TRUE)
  expect_equal(tryNULL(stop("error")), NULL)

})

test_that("tryapply() function", {

  safe_divide <- function(y, x) {
    stopifnot(y != 0)
    x / y
  }

  expect_equal(tryapply(-3:3, safe_divide, x = 1), as.list(1 / (-3:3)[-4]))

})

#' Capture current evaluation context.
#'
#' This function captures the current context, making it easier
#' to use \code{**ply} with functions that do special evaluation and
#' need access to the environment where ddply was called from.
#'
#' @author Peter Meilstrup, \url{https://github.com/crowding}
#' @param f a function that does non-standard evaluation
#' @export
#' @examples
#' df <- data.frame(a = rep(c("a","b"), each = 10), b = 1:20)
#' f1 <- function(label) {
#'    ddply(df, "a", mutate, label = paste(label, b))
#' }
#' \dontrun{f1("name:")}
#' # Doesn't work because mutate can't find label in the current scope
#'
#' f2 <- function(label) {
#'    ddply(df, "a", here(mutate), label = paste(label, b))
#' }
#' f2("name:")
#' # Works :)
here <- function(f) {
  call <- substitute(function(...) (f)(...), list(f = f)) # nolint
  fun <- eval(call, parent.frame())
  attr(fun, "srcref") <- srcfilecopy("<text>", deparse(call))
  fun
}

#' Quote variables to create a list of unevaluated expressions for later
#' evaluation.
#'
#' This function is similar to \code{\link{~}} in that it is used to
#' capture the name of variables, not their current value.  This is used
#' throughout plyr to specify the names of variables (or more complicated
#' expressions).
#'
#' Similar tricks can be performed with \code{\link{substitute}}, but when
#' functions can be called in multiple ways it becomes increasingly tricky
#' to ensure that the values are extracted from the correct frame.  Substitute
#' tricks also make it difficult to program against the functions that use
#' them, while the \code{quoted} class provides
#' \code{as.quoted.character} to convert strings to the appropriate
#' data structure.
#'
#' @param ... unevaluated expressions to be recorded.  Specify names if you
#'   want the set the names of the resultant variables
#' @param .env environment in which unbound symbols in \code{...} should be
#'   evaluated.  Defaults to the environment in which \code{.} was executed.
#' @return list of symbol and language primitives
#' @aliases . quoted is.quoted
#' @export . is.quoted
#' @rdname quoted
#' @examples
#' .(a, b, c)
#' .(first = a, second = b, third = c)
#' .(a ^ 2, b - d, log(c))
#' as.quoted(~ a + b + c)
#' as.quoted(a ~ b + c)
#' as.quoted(c("a", "b", "c"))
#'
#' # Some examples using ddply - look at the column names
#' ddply(mtcars, "cyl", each(nrow, ncol))
#' ddply(mtcars, ~ cyl, each(nrow, ncol))
#' ddply(mtcars, .(cyl), each(nrow, ncol))
#' ddply(mtcars, .(log(cyl)), each(nrow, ncol))
#' ddply(mtcars, .(logcyl = log(cyl)), each(nrow, ncol))
#' ddply(mtcars, .(vs + am), each(nrow, ncol))
#' ddply(mtcars, .(vsam = vs + am), each(nrow, ncol))
. <- function(..., .env = parent.frame()) {
  structure(as.list(match.call()[-1]), env = .env, class="quoted")
}

is.quoted <- function(x) inherits(x, "quoted")

#' Print quoted variables.
#'
#' Display the \code{\link{str}}ucture of quoted variables
#'
#' @keywords internal
#' @export
print.quoted <- function(x, ...) str(x)

#' Compute names of quoted variables.
#'
#' Figure out names of quoted variables, using specified names if they exist,
#' otherwise converting the values to character strings.  This may create
#' variable names that can only be accessed using \code{``}.
#'
#' @keywords internal
#' @export
names.quoted <- function(x) {
  deparse2 <- function(x) paste(deparse(x), collapse = "")
  part_names <- unlist(lapply(x, deparse2))
  user_names <- names(unclass(x))

  if (!is.null(user_names)) {
    part_names[user_names != ""] <- user_names[user_names != ""]
  }

  unname(part_names)
}

#' Evaluate a quoted list of variables.
#'
#' Evaluates quoted variables in specified environment
#'
#' @return a list
#' @keywords internal
#' @param expr quoted object to evalution
#' @param try if TRUE, return \code{NULL} if evaluation unsuccesful
#' @export
eval.quoted <- function(exprs, envir = NULL, enclos = NULL, try = FALSE) {
  if (is.numeric(exprs)) return(envir[exprs])

  if (!is.null(envir) && !is.list(envir) && !is.environment(envir)) {
    stop("envir must be either NULL, a list, or an environment.")
  }

  qenv <- if (is.quoted(exprs)) attr(exprs, "env") else parent.frame()
  if (is.null(envir)) envir <- qenv
  if (is.data.frame(envir) && is.null(enclos)) enclos <- qenv

  if (try) {
    results <- lapply(exprs, failwith(NULL, eval, quiet = TRUE),
      envir = envir, enclos = enclos)
  } else {
    results <- lapply(exprs, eval, envir = envir, enclos = enclos)
  }
  names(results) <- names(exprs)

  results
}

#' Convert input to quoted variables.
#'
#' Convert characters, formulas and calls to quoted .variables
#'
#' This method is called by default on all plyr functions that take a
#' \code{.variables} argument, so that equivalent forms can be used anywhere.
#'
#' Currently conversions exist for character vectors, formulas and
#' call objects.
#'
#' @return a list of quoted variables
#' @seealso \code{\link[=quoted]{.}}
#' @param x input to quote
#' @param env environment in which unbound symbols in expression should be
#'   evaluated. Defaults to the environment in which \code{as.quoted} was
#'   executed.
#' @export
#' @examples
#' as.quoted(c("a", "b", "log(d)"))
#' as.quoted(a ~ b + log(d))
as.quoted <- function(x, env = parent.frame()) UseMethod("as.quoted")

#' @export
as.quoted.call <- function(x, env = parent.frame()) {
  structure(as.list(x)[-1], env = env, class = "quoted")
}

#' @export
as.quoted.character <- function(x, env = parent.frame()) {
  structure(
    lapply(x, function(x) parse(text = x)[[1]]),
    env = env, class = "quoted"
  )
}

#' @export
as.quoted.numeric <- function(x, env = parent.frame()) {
  structure(x, env = env, class = c("quoted", "numeric"))
}

#' @export
as.quoted.formula <- function(x, env = parent.frame()) {
  simplify <- function(x) {
    if (length(x) == 2 && x[[1]] == as.name("~")) {
      return(simplify(x[[2]]))
    }
    if (length(x) < 3) return(list(x))
    op <- x[[1]]; a <- x[[2]]; b <- x[[3]]

    if (op == as.name("+") || op == as.name("*") || op == as.name("~")) {
      c(simplify(a), simplify(b))
    } else if (op == as.name("-")) {
      c(simplify(a), bquote(-.(x), list(x=simplify(b))))
    } else {
      list(x)
    }
  }

  structure(simplify(x), env = env, class = "quoted")
}

#' @export
as.quoted.quoted <- function(x, env = parent.frame()) x

#' @export
as.quoted.NULL <- function(x, env = parent.frame()) {
  structure(list(), env = env, class = "quoted")
}

#' @export
as.quoted.name <- function(x, env = parent.frame()) {
  structure(list(x), env = env, class = "quoted")
}

#' @export
as.quoted.factor <- function(x, env = parent.frame()) {
  as.quoted(as.character(x), env)
}

#' @export
c.quoted <- function(..., recursive = FALSE) {
  structure(NextMethod("c"), class = "quoted",
    env = attr(list(...)[[1]], "env"))
}

#' @export
"[.quoted" <- function(x, i, ...) {
  structure(NextMethod("["), env = attr(x, "env"), class = "quoted")
}

context("Quoting")

test_that("quoting captures current environment", {
  x <- .(a, b, c)
  expect_that(attr(x, "env"), is_identical_to(environment()))
  
  x <- as.quoted(c("a", "b", "c"))
  expect_that(attr(x, "env"), is_identical_to(environment()))  
})

test_that("evaluation takes place in correct environment", {
  a <- 2
  x <- local({
    a <- 1
    .(a)
  })
  
  expect_that(eval.quoted(x)$a, equals(1))
  
  df <- data.frame(x = 1:10)
  x <- local({
    a <- 1
    .(x * a)
  })
  expect_that(eval.quoted(x, df)[[1]], equals(1:10))
  
})

test_that("names work for long expressions", {
 q <- .(foo = barjasdfgjadhfgjsdhfgusdhfgusheguisdhguioahsrofasdgsdfgsdfg +
              dfgafgasdfgsdfgsdfgsdfgsdfgsdfgsdfg)
 expect_that(names(q), equals("foo"))              
})

context("Quoting")

test_that("quoting captures current environment", {
  x <- .(a, b, c)
  expect_that(attr(x, "env"), is_identical_to(environment()))

  x <- as.quoted(c("a", "b", "c"))
  expect_that(attr(x, "env"), is_identical_to(environment()))
})

test_that("can't pass bogus environment for evaluation", {
  expect_that(eval.quoted(.(x), envir = -1), throws_error("must be"))
})

test_that("evaluation takes place in correct environment", {
  a <- 2
  x <- local({
    a <- 1
    .(a)
  })

  expect_that(eval.quoted(x)$a, equals(1))

  df <- data.frame(x = 1:10)
  x <- local({
    a <- 1
    .(x * a)
  })
  expect_that(eval.quoted(x, df)[[1]], equals(1:10))

})

test_that("failsafe evaluation", {
  b <- 2
  x <- local({
    a <- 1
    .(a)
  })

  expect_that(eval.quoted(x, try = TRUE)$b, equals(NULL))
})

test_that("names work for long expressions", {
 # nolint start
 q <- .(foo = barjasdfgjadhfgjsdhfgusdhfgusheguisdhguioahsrofasdgsdfgsdfg +
              dfgafgasdfgsdfgsdfgsdfgsdfgsdfgsdfg)
 # nolint end
 expect_that(names(q), equals("foo"))
})

test_that("printing works", {
  expect_that(print(as.quoted(NULL)), testthat::prints_text("list()"))
  expect_that(print(as.quoted("id")), testthat::prints_text("id"))
  expect_that(print(as.quoted("3")), testthat::prints_text("3"))
  expect_that(print(as.quoted(c("a", "b"))), testthat::prints_text("List of 2"))
  expect_that(print(as.quoted(~a+b)), testthat::prints_text("List of 2"))
  expect_that(print(as.quoted(~a)), testthat::prints_text("List of 1"))
  expect_that(print(as.quoted(as.name("a"))), testthat::prints_text("List of 1"))
})

test_that("concatenation", {
  expect_equal(c(.(a), .(b)), .(a, b))
  expect_equal(c(.(a), .(b, c)), .(a, b, c))
  expect_equal(c(.(a), .(b), .(c)), .(a, b, c))
})

test_that("extraction", {
  expect_equal(.(a, b)[1], .(a))
  expect_equal(.(a, b, c)[-1], .(b, c))
})

#' Construct an immutable data frame.
#' 
#' An immutable data frame works like an ordinary data frame, except that when
#' you subset it, it returns a reference to the original data frame, not a 
#' a copy. This makes subsetting substantially faster and has a big impact
#' when you are working with large datasets with many groups.
#'
#' This method is still a little experimental, so please let me know if you
#' run into any problems.
#'
#' @param df a data frame
#' @return an immutable data frame
#' @S3method [ idf
#' @S3method names idf
#' @S3method dim idf
#' @S3method as.data.frame idf
#' @S3method [[ idf
#' @keywords manip
#' @export
#' @examples
#' system.time(dlply(baseball, "id", nrow))
#' system.time(dlply(idata.frame(baseball), "id", nrow))
idata.frame <- function(df) {
  self <- new.env()
  self$`_data` <- df
  self$`_rows` <- seq_len(nrow(df))
  self$`_cols` <- names(df)
  
  for (name in names(df)) {
    f <- eval(substitute(function(v) {
      if (missing(v)) {
        `_data`[[name]]
      } else {
        stop("Immutable")
      }
    }, list(name = name)))
    environment(f) <- self
    makeActiveBinding(name, f, self)
  }
  
  structure(self, 
    class = c("idf", "environment"))
}

"[.idf" <- function(x, i, j, drop = TRUE) { 
  # Single column special cases
  if (nargs() == 2) {
    j <- i
    i <- TRUE
    drop <- FALSE
  }
  if (!missing(j) && length(j) == 1 && drop) {
    if (missing(i)) i <- TRUE
    return(x[[j]][i])
  }
  
  # New rows
  rows <- x$`_rows`
  if (!missing(i)) {
    if (is.character(i)) stop("Row names not supported")
    rows <- rows[i]
  }
  
  # New cols
  cols <- x$`_cols`
  if (!missing(j)) {
    if (is.character(j)) {
      cols <- intersect(cols, j)
    } else {
      cols <- cols[j]
    }    
  }
  
  # Make active bindings for functions like lm and eval that will treat this
  # object as an environment or list
  self <- new.env(parent = parent.env(x))
  self$`_rows` <- rows
  self$`_cols` <- cols
  self$`_data` <- x$`_data`

  for (col in cols) {
    f <- eval(substitute(function(v) {
      if (missing(v)) {
        `_data`[[name]][`_rows`]
      } else {
        stop("Immutable")
      }
    }, list(name = col)))
    environment(f) <- self
    makeActiveBinding(col, f, self)
  }
  
  structure(self,
    class = c("idf", "environment"))
}

names.idf <- function(x) x$`_cols`

dim.idf <- function(x) c(length(x$`_rows`), length(x$`_cols`))

as.data.frame.idf <- function(x, ...) {
  x$`_data`[x$`_rows`, x$`_cols`]
}

"[[.idf" <- function(x, i) {
  if (is.numeric(i)) {
    i <- names(x)[i]
  }
  x$`_data`[[i]][x$`_rows`]
}

# "[[<-.idf" <- "[<-.idf" <- function(...) stop("Immutable")

context("Immutable")

# Create smaller subset of baseball data (for speed)
bsmall <- subset(baseball, id %in% sample(unique(baseball$id), 20))[, 1:5]
bsmall$id <- factor(bsmall$id)
bsmall <- bsmall[sample(rownames(bsmall)),  ]
rownames(bsmall) <- NULL

test_that("idf is immutable", {
  #Since idf are constructed by scratch in both idata.frame and `[.idf]`
  #I will test idf objects created both ways.

  #create both before testing any, to make sure that subsetting
  #doesn't change the subsetted idf
  idf <- idata.frame(bsmall)
  x <- idf[1:10, ]
  y <- bsmall[1:10, ]

  expect_error(x[1,"year"] <- 1994)
  expect_error(x[["stint"]] <- rev(y[["stint"]]))
  expect_error(x$team <- sort(y$team))
  expect_error(names(idf) <- c("ID", "YR", "ST", "TM", "LG"))

  expect_error(idf[1,"year"] <- 1994)
  expect_error(idf[["stint"]] <- rev(bsmall[["stint"]]))
  expect_error(idf$team <- sort(bsmall$team))
  expect_error(names(idf) <- c("ID", "YR", "ST", "TM", "LG"))
})

test_that("idf subset by [i]", {
  idf <- idata.frame(bsmall)

  x <- idf[3]
  y <- bsmall[3]

  expect_equal(idf[[2]], bsmall[[2]])
  expect_equal(x[[1]], y[[1]])
})

test_that("idf subset data by [i,j]", {
  idf <- idata.frame(bsmall)

  x <- idf[1:10, ]
  y <- bsmall[1:10, ]

  xx <- x[3:5, c('id', 'team')]
  yy <- y[3:5, c('id', 'team')]

  xxx <- idf[ , names(idf)]
  yyy <- idf[ , names(y)]

  expect_equal(idf[3, "year"], bsmall[[3, "year"]])
  expect_equal(x[, "year"], y[, "year"])
  expect_equal(xx[, "id"], yy[, "id"])
  expect_equal(xxx[, "team"], yyy[, "team"])
})

test_that("idf extract by [[i]]", {
  idf <- idata.frame(bsmall)

  x <- idf[6:20,]
  y <- bsmall[6:20,]

  expect_equal(x[[4]], y[[4]])
  expect_equal(idf[[3]], bsmall[[3]])
  expect_equal(idf[["year"]], bsmall[["year"]])
})

test_that("idf extract $name", {
  idf <- idata.frame(bsmall)

  x <- idf[500:510,]
  y <- bsmall[500:510,]

  expect_equal(x$team, y$team)
  expect_equal(idf$team, bsmall$team)
})

test_that("idf as environment", {
  idf <- idata.frame(bsmall)

  x <- idf[5:10,]
  y <- bsmall[5:10,]

  expect_equal(with(x, mean(year)), with(y, mean(year)))
  expect_equal(with(idf, table(team)), with(bsmall, table(team)))
})

#' @section Input: This function splits matrices, arrays and data frames by
#'   dimensions
#'
#' @param .data matrix, array or data frame to be processed
#' @param .margins a vector giving the subscripts to split up \code{data} by. 
#'   1 splits up by rows, 2 by columns and c(1,2) by rows and columns, and so
#'   on for higher dimensions
#' @family array input
#' @param .expand if \code{.data} is a data frame, should output be 1d (expand
#'   = FALSE), with an element for each row; or nd (expand = TRUE), with a
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#'  dimension for each variable.

#' Split list, apply function, and return results in a list.
#'
#' For each element of a list, apply function, keeping results as a list.
#'
#' \code{llply} is equivalent to \code{\link{lapply}} except that it will
#' preserve labels and can display a progress bar.
#'
#' @template ply
#' @template l-
#' @template -l
#' @export
#' @examples
#' llply(llply(mtcars, round), table)
#' llply(baseball, summary)
#' # Examples from ?lapply
#' x <- list(a = 1:10, beta = exp(-3:3), logic = c(TRUE,FALSE,FALSE,TRUE))
#'
#' llply(x, mean)
#' llply(x, quantile, probs = 1:3/4)
llply <- function(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
                  .parallel = FALSE, .paropts = NULL) {
  if (is.null(.fun)) return(as.list(.data))
  if (is.character(.fun) || is.list(.fun)) .fun <- each(.fun)
  if (!is.function(.fun)) stop(".fun is not a function.")

  if (!inherits(.data, "split")) {
    pieces <- as.list(.data)

    # This special case can be done much faster with lapply, so do it.
    fast_path <- .progress == "none" && !.inform && !.parallel
    if (fast_path) {
      return(structure(lapply(pieces, .fun, ...), dim = dim(pieces)))
    }

  } else {
    pieces <- .data
  }

  n <- length(pieces)
  if (n == 0) return(list())


  if (.parallel && .progress != "none") {
    message("Progress disabled when using parallel plyr")
    .progress <- "none"
  }

  result <- vector("list", n)
  for (i in 1:n) {
     result[i] <- .fun(pieces[[i]])
  } 

  result
#  progress <- create_progress_bar(.progress)
#  progress$init(n)
#  on.exit(progress$term())

#  result <- vector("list", n)
#  do.ply <- function(i) {
#    print("PIECES")
#    piece <- pieces[[i]]
#    print("PIECE")
#    print(piece)
    # Display informative error messages, if desired
#    if (.inform) {
#      res <- try(.fun(piece, ...))
#      if (inherits(res, "try-error")) {
#        piece <- paste(capture.output(print(piece)), collapse = "\n")
#        stop("with piece ", i, ": \n", piece, call. = FALSE)
#      }
#    } else {
#      print("DOING ELSE")
#      res <- .fun(piece, ...)
#    }
#    progress$step()
#    res
#  }
#  if (.parallel) {
#    setup_parallel()

#    i <- seq_len(n)
#    fe_call <- as.call(c(list(quote(foreach::foreach), i = i), .paropts))
#    fe <- eval(fe_call)
#
#    result <- foreach::`%dopar%`(fe, do.ply(i))
#  } else {
#    
#    print("PIECES")
#    print(pieces)
#    print("PIECES DATA")
#    print(pieces[[1]])
#    print("FUNCTION DATA")
#    print(.fun)
#    print("FUNCTION APPLIED TO FIRST VALUE")
#    print(.fun(pieces[[1]]))
#    print("CURRENT RESULT")
#    print(result)
#    print("READY TO START LOOP")
#    for (i in 0:n-1) {
       #print("RESULT I BEFORE ASSIGNMENT")
       #print(result[i+1])
       #print("DOPLY I")
       #piece <- pieces[[i+1]]
       #print("FUNCTION")
       #print(.fun(piece, ...))
       #result[i+1] <- .fun(piece, ...)
       #print("ATTEMPTING ASSIGNMENT")
       #result[[i+1]] = ""
       #print("ABLE TO ASSIGN TO EMPTY STRING")
       #print(result[[i+1]])
       #print("HERE IS THE ENTIRE RESULT")
       #print(result)
       #print("NOW ATTEMPTING SECOND ASSIGNMENT")
       #result[[i+1]] = .fun(pieces[[i+1]])
       #print("DONE ASSIGNMENT")
       #print(do.ply(i+1))
       #result[i] <- do.ply(i+1)
       #print("RESULT I")
       #print(result[i])
       #print("RESULT I AFTER ASSIGNMENT")
       #print(result[i])
    #print("DOING LOOP APPLY IN LLPLY")
    #result <- .C("loop_apply", n=n, f=do.ply)   #loop_apply(n, do.ply)
    #print("RESULT IN ELSE")
    #print(result)
    #print("NAMES IN ELSE")
    #print(names(result))
    #print("DONE LOOP APPLY IN LLPLY")
  #}
  #}
  #attributes(result)[c("split_type", "split_labels")] <-
  #  attributes(pieces)[c("split_type", "split_labels")]
  #print("PIECES AFTER ELSE")
  #print(pieces) 
  #print("RESULT AFTER ELSE")
  #print(result)
  #print("NAMES RESULT AFTER ELSE")
  #print(names(result))
  #print("NAMES PIECES AFTER ELSE")
  #print(names(pieces))
  #names(result) <- names(pieces)
  #print("FINAL RESULTS")
  #print(result)
  # Only set dimension if not null, otherwise names are removed
  #if (!is.null(dim(pieces))) {
  #  dim(result) <- dim(pieces)
  #}

  #result
}

#' Replicate expression and return results in a list.
#'
#' Evalulate expression n times then combine results into a list
#'
#' This function runs an expression multiple times, and combines the
#' result into a list.  If there are no results, then this function will return
#' a list of length 0  (\code{list()}). This function is equivalent to
#' \code{\link{replicate}}, but will always return results as a list.
#'
#'
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @return list of results
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29.
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' mods <- rlply(100, lm(y ~ x, data=data.frame(x=rnorm(100), y=rnorm(100))))
#' hist(laply(mods, function(x) summary(x)$r.squared))
rlply <- function(.n, .expr, .progress = "none") {
  res <- .rlply_worker(.n, .progress,
                       eval.parent(substitute(function() .expr)))
  res
}

.rlply_worker <- function(.n, .progress, .expr_wrap, .print = FALSE,
                          .discard = FALSE) {
  if (!is.vector(.n, "numeric") || length(.n) > 1L)
    stop(".n must be an integer vector of length 1")
  if (.n == 0L)
    return (list())

  progress <- create_progress_bar(.progress)

  progress$init(.n)
  on.exit(progress$term())

  if (.print) {
    wrap <- function(f) function() {
      print(f())
    }
  } else {
    wrap <- identity
  }

  # The logic below is responsible for ascertaining that .expr is evaluated
  # exactly .n times, whether it's a function or an expression.  (See GitHub
  # issue #158.)  When the function .rlply_worker is called, the .expr_wrap
  # argument is a function that returns the .expr argument passed to the calling
  # r*ply function.  The .wrapped_expr_to_fun function will convert the
  # .expr_wrap argument to a list that contains a function and the result of the
  # first evaluation, which is necessary because there seems to be no other way
  # to find out if .expr is a function or an expression without evaluating it at
  # least once.  After that, only .n - 1 further evaluations are necessary.
  #
  # In addition, results are printed and/or discareded depending on the `wrap`
  # function defined above.
  fun <- .wrapped_expr_to_fun(.expr_wrap)
  f <- wrap(fun$f)

  if (.discard) {
    wrap(function() fun$val)()
    progress$step()

    for (i in seq.int(from = 2L, length.out = .n - 1L)) {
      f()
      progress$step()
    }

    invisible(NULL)
  } else {
    result <- vector("list", length = .n)
    result[1L] <- list(wrap(function() fun$val)())
    progress$step()

    for (i in seq.int(from = 2L, length.out = .n - 1L)) {
      result[i] <- list(f())
      progress$step()
    }

    result
  }
}

#' r*ply helper function
#'
#' Call a function to check if the result is a function or an expression, to
#' support expressions as arguments to the r*ply family.
#'
#' @param .expr_wrap function to call
#' @return named list with two components. f -- function, val -- result of first
#'   evaluation
#' @noRd
.wrapped_expr_to_fun <- function(.expr_wrap) {
  # When .expr_wrap is evaluated, it will return either a function or an
  # expression.  In the first case, this function is assigned to the f
  # component, and also called once explicitly to assign the val component.  In
  # the second case, this has been already the first evaluation of .expr -- the
  # parameter wrapped by .expr_wrap; the results are reused for the val
  # component, and the wrapped function is assigned to f.
  res <- .expr_wrap()

  if (is.function(res)) {
    list(f = res, val = res())
  } else {
    list(f = .expr_wrap, val = res)
  }
}

#' Combine data.frames by row, filling in missing columns.
#'
#' \code{rbind}s a list of data frames filling missing columns with NA.
#'
#' This is an enhancement to \code{\link{rbind}} that adds in columns
#' that are not present in all inputs, accepts a list of data frames, and
#' operates substantially faster.
#'
#' Column names and types in the output will appear in the order in which
#' they were encountered.
#'
#' Unordered factor columns will have their levels unified and
#' character data bound with factors will be converted to
#' character. POSIXct data will be converted to be in the same time
#' zone. Array and matrix columns must have identical dimensions after
#' the row count. Aside from these there are no general checks that
#' each column is of consistent data type.
#'
#' @param ... input data frames to row bind together.  The first argument can
#'   be a list of data frames, in which case all other arguments are ignored.
#'   Any NULL inputs are silently dropped. If all inputs are NULL, the output
#'   is NULL.
#' @keywords manip
#' @family binding functions
#' @return a single data frame
#' @export
#' @examples
#' rbind.fill(mtcars[c("mpg", "wt")], mtcars[c("wt", "cyl")])
rbind.fill <- function(...) {
  dfs <- list(...)
  if (length(dfs) == 0) return()
  if (is.list(dfs[[1]]) && !is.data.frame(dfs[[1]])) {
    dfs <- dfs[[1]]
  }
  dfs <- compact(dfs)

  if (length(dfs) == 0) return()
  if (length(dfs) == 1) return(dfs[[1]])

  # Check that all inputs are data frames
  is_df <- vapply(dfs, is.data.frame, logical(1))
  if (any(!is_df)) {
    stop("All inputs to rbind.fill must be data.frames", call. = FALSE)
  }

  # Calculate rows in output
  # Using .row_names_info directly is about 6 times faster than using nrow
  rows <- unlist(lapply(dfs, .row_names_info, 2L))
  nrows <- sum(rows)

  # Generate output template
  ot <- output_template(dfs, nrows)
  setters <- ot$setters
  getters <- ot$getters

  # Case of zero column inputs
  if (length(setters) == 0) {
    return(as.data.frame(matrix(nrow = nrows, ncol = 0)))
  }

  # Compute start and length for each data frame
  pos <- matrix(c(cumsum(rows) - rows + 1, rows), ncol = 2)

  # Copy inputs into output
  for (i in seq_along(rows)) {
    rng <- seq(pos[i, 1], length = pos[i, 2])
    df <- dfs[[i]]

    for (var in names(df)) {
      setters[[var]](rng, df[[var]]) # nolint
    }
  }

  quickdf(lapply(getters, function(x) x()))
}

# Construct named lists of setters and getters.
output_template <- function(dfs, nrows) {
  vars <- unique(unlist(lapply(dfs, base::names)))   # ~ 125,000/s
  output <- vector("list", length(vars))
  names(output) <- vars

  seen <- rep(FALSE, length(output))
  names(seen) <- vars

  for (df in dfs) {
    matching <- intersect(names(df), vars[!seen])
    for (var in matching) {
      output[[var]] <- allocate_column(df[[var]], nrows, dfs, var)
    }

    seen[matching] <- TRUE
    if (all(seen)) break  # Quit as soon as all done
  }

  list(setters=lapply(output, `[[`, "set"),
       getters=lapply(output, `[[`, "get"))
}

# Allocate space for a column to be filled out by rbind.fill.
#
# @param example An example vector taken from the first data frame
# @param nrows The number of rows
# @param dfs The list of data frames that will be combined. This may
# need to be scanned (to unify factor levels or check array dimension
# consistency)
# @param var The name of the column.
#
# @return A list of two accessor functions `list(set=<>, get=<>)`.
# `.$set(rows, value)` stores data in the given rows.
# `.$get()` retreives the column data.
allocate_column <- function(example, nrows, dfs, var) {
  #Compute the attributes of the column and allocate.  Returns a
  #mutator function f(rows, values) rather than the actual allocated
  #column.

  a <- attributes(example)
  type <- typeof(example)
  class <- a$class
  isList <- is.recursive(example)

  a$names <- NULL
  a$class <- NULL

  if (is.data.frame(example)) {
    stop("Data frame column '", var, "' not supported by rbind.fill")
  }

  if (is.array(example)) {
    if (length(dim(example)) > 1) {
      if ("dimnames" %in% names(a)) {
        a$dimnames[1] <- list(NULL)
        if (!is.null(names(a$dimnames)))
            names(a$dimnames)[1] <- ""
      }

      # Check that all other args have consistent dims
      df_has <- vapply(dfs, function(df) var %in% names(df), FALSE)
      dims <- unique(lapply(dfs[df_has], function(df) dim(df[[var]])[-1]))
      if (length(dims) > 1)
          stop("Array variable ", var, " has inconsistent dims")

      a$dim <- c(nrows, dim(example)[-1])
      length <- prod(a$dim)
    } else {
      #1d arrays devolve into vectors
      a$dim <- NULL
      a$dimnames <- NULL
      length <- nrows
    }
  } else {
    length <- nrows
  }

  if (is.factor(example)) {
    df_has <- vapply(dfs, function(df) var %in% names(df), FALSE)
    isfactor <- vapply(dfs[df_has], function(df) is.factor(df[[var]]), FALSE)
    if (all(isfactor)) {
      #will be referenced by the mutator
      levels <- unique(unlist(lapply(dfs[df_has],
                                     function(df) levels(df[[var]]))))
      a$levels <- levels
      handler <- "factor"
    } else {
      #fall back on character
      type <- "character"
      handler <- "character"
      class <- NULL
      a$levels <- NULL
    }
  } else if (inherits(example, "POSIXt")) {
    tzone <- attr(example, "tzone")
    class <- c("POSIXct", "POSIXt")
    type <- "double"
    handler <- "time"
  } else {
    handler <- type
  }

  column <- vector(type, length)
  if (!isList) {
    column[] <- NA
  }
  attributes(column) <- a

  #construct an assignment expression like `column[rows, ...] <- what`
  #appropriate for the number of dims
  assignment <- make_assignment_call(length(a$dim))

  #It is especially important never to inspect the column when in the
  #main rbind.fill loop. To avoid that, we've done specialization
  #(figuring out the array assignment form and data type) ahead of
  #time, and instead of returning the column, we return accessor
  #functions that close over the column.
  setter <- switch(
      handler,
      character = function(rows, what) {
        what <- as.character(what)
        eval(assignment)
      },
      factor = function(rows, what) {
        #duplicate what `[<-.factor` does
        what <- match(what, levels)
        #no need to check since we already computed levels
        eval(assignment)
      },
      time = function(rows, what) {
        what <- as.POSIXct(what, tz = tzone)
        eval(assignment)
      },
      function(rows, what) {
        eval(assignment)
      })

  getter <- function() {
    class(column) <<- class
    column
  }

  list(set=setter, get=getter)
}

#construct an assignment expression like `column[rows, ...] <- what`
#appropriate for the number of dims
make_assignment_call <- function(ndims) {
  assignment <- quote(column[rows] <<- what)
  if (ndims >= 2) {
    assignment[[2]] <- as.call(
        c(as.list(assignment[[2]]),
          rep(list(quote(expr = )), ndims - 1)))
  }
  assignment
}

context("rbind.fill")

test_that("variable classes are preserved", {
  a <- data.frame(a = factor(letters[1:3]), b = 1:3, c = date())
  b <- data.frame(
    a = factor(letters[3:5]), 
    d = as.Date(c("2008-01-01", "2009-01-01", "2010-01-01")))
  b$e <- as.POSIXlt(as.Date(c("2008-01-01", "2009-01-01", "2010-01-01"))) 
  b$f <- matrix (1:6, nrow = 3)
  
  ab1 <- rbind.fill(a, b)[, letters[1:6]]
  ab2 <- rbind.fill(b, a)[c(4:6, 1:3), letters[1:6]]
  ab2$a <- factor(ab2$a, levels(ab1$a))
  rownames(ab2) <- NULL
  
  expect_that(ab1, equals(ab2))
  expect_that(unname(lapply(ab1, class)), 
    equals(list("factor", "integer", "factor", "Date", c("POSIXct", "POSIXt"),
                "matrix")))
})

test_that("same as rbind for simple cases", {
  bsmall <- baseball[1:1000, ]
  bplayer <- split(bsmall, bsmall$id)
  b1 <- do.call("rbind", bplayer)
  rownames(b1) <- NULL
  b2 <- rbind.fill(bplayer)
  
  expect_that(b1, equals(b2))
})

test_that("columns are in expected order", {
  a <- data.frame(a = 1, b = 2, c = 3)
  b <- data.frame(b = 2, d = 4, e = 4)
  c <- data.frame(c = 1, b = 2, a = 1)
  
  expect_that(names(rbind.fill(a, b)), equals(c("a", "b", "c", "d", "e")))
  expect_that(names(rbind.fill(a, c)), equals(c("a", "b", "c")))
  expect_that(names(rbind.fill(c, a)), equals(c("c", "b", "a")))
})

test_that("matrices are preserved", {
  a <- data.frame(a = factor(letters[3:5]))
  a$b <- matrix(1:6, nrow = 3)
  
  expect_that(rbind.fill(a, a)$b, is_equivalent_to(rbind(a, a)$b))
  
  b <- data.frame(c = 1:3)

  ab1 <- rbind.fill(a, b) [           , letters[1:3]]
  ab2 <- rbind.fill(b, a) [c(4:6, 1:3), letters[1:3]]
  ab2$a <- factor(ab2$a, levels(ab1$a))
  rownames(ab2) <- NULL
  
  expect_that(ab1, equals(ab2))
})

test_that("missing levels in factors preserved", {
  f <- addNA(factor(c("a", "b", NA)))
  df1 <- data.frame(a = f)
  df2 <- data.frame(b = f)
  rbind.fill(df1, df2)
})

test_that("time zones are preserved", {
  dstart <- "2011-01-01 00:01"
  dstop <- "2011-01-02 04:15"

  get_tz <- function(x) attr(as.POSIXlt(x), "tz")

  tzs <- c("", "CET", "UTC")
  for(tz in tzs) {
    start <- data.frame(x = as.POSIXct(dstart, tz = tz))
    end <- data.frame(x = as.POSIXct(dstop, tz = tz))
    
    both <- rbind.fill(start, end)
    expect_that(get_tz(both$x)[1], equals(tz), label = tz)
  }

})

test_that("arrays are ok", {
  df <- data.frame(x = 1)
  df$x <- array(1, 1)

  df2 <- rbind.fill(df, df)
  expect_that(df2$x, is_equivalent_to(rbind(df, df)$x))
})

test_that("attributes are preserved", {
  d1 <- data.frame(a = runif(10), b = runif(10))
  d2 <- data.frame(a = runif(10), b = runif(10))

  attr(d1$b, "foo") <- "one"
  attr(d1$b, "bar") <- "bar"
  attr(d2$b, "foo") <- "two"
  attr(d2$b, "baz") <- "baz"
  
  d12 <- rbind.fill(d1, d2)
  d21 <- rbind.fill(d2, d1)
  
  expect_that(attr(d12$b, "foo"), equals("one"))
  expect_that(attr(d21$b, "foo"), equals("two"))
  
})

test_that("characters override factors", {
  d1a <- data.frame(x=c('a','b'), y=1:2)
  d2a <- data.frame(x=c('b','d'), z=1:2, stringsAsFactors=F)
  
  d1b <- data.frame(x=c('a','b'), y=1:2, stringsAsFactors=F)
  d2b <- data.frame(x=c('b','d'), z=1:2)
  
  d3a <- rbind.fill(d1a,d2a)
  d3b <- rbind.fill(d1b,d2b)
  
  expect_that(d3a$x, is_a("character"))
  expect_that(d3b$x, is_a("character"))
})

context("rbind.fill")

test_that("variable classes are preserved", {
  a <- data.frame(a = factor(letters[1:3]), b = 1:3, c = date())
  b <- data.frame(
    a = factor(letters[3:5]),
    d = as.Date(c("2008-01-01", "2009-01-01", "2010-01-01")))
  b$e <- as.POSIXlt(as.Date(c("2008-01-01", "2009-01-01", "2010-01-01")))
  b$f <- matrix (1:6, nrow = 3)

  ab1 <- rbind.fill(a, b)[, letters[1:6]]
  ab2 <- rbind.fill(b, a)[c(4:6, 1:3), letters[1:6]]
  ab2$a <- factor(ab2$a, levels(ab1$a))
  rownames(ab2) <- NULL

  expect_that(ab1, equals(ab2))
  expect_that(unname(lapply(ab1, class)),
    equals(list("factor", "integer", "factor", "Date", c("POSIXct", "POSIXt"),
                "matrix")))
})

test_that("same as rbind for simple cases", {
  bsmall <- baseball[1:1000, ]
  bplayer <- split(bsmall, bsmall$id)
  b1 <- do.call("rbind", bplayer)
  rownames(b1) <- NULL
  b2 <- rbind.fill(bplayer)

  expect_that(b1, equals(b2))
})

test_that("columns are in expected order", {
  a <- data.frame(a = 1, b = 2, c = 3)
  b <- data.frame(b = 2, d = 4, e = 4)
  c <- data.frame(c = 1, b = 2, a = 1)

  expect_that(names(rbind.fill(a, b)), equals(c("a", "b", "c", "d", "e")))
  expect_that(names(rbind.fill(a, c)), equals(c("a", "b", "c")))
  expect_that(names(rbind.fill(c, a)), equals(c("c", "b", "a")))
})

test_that("matrices are preserved", {
  a <- data.frame(a = factor(letters[3:5]))
  a$b <- matrix(1:6, nrow = 3)

  expect_that(rbind.fill(a, a)$b, is_equivalent_to(rbind(a, a)$b))

  b <- data.frame(c = 1:3)

  ab1 <- rbind.fill(a, b) [           , letters[1:3]]
  ab2 <- rbind.fill(b, a) [c(4:6, 1:3), letters[1:3]]
  ab2$a <- factor(ab2$a, levels(ab1$a))
  rownames(ab2) <- NULL

  expect_that(ab1, equals(ab2))
})

test_that("character or factor or list-matrices are preserved", {
  d1 <- data.frame(a=1:2,
                   x=I(matrix(c('a', 'b', 'c', 'd'), nrow=2)))
  d2 <- data.frame(b=1:2,
                   x=I(`dim<-`(factor(c('a', 'b', 'c', 'd')), c(2,2))))
  d3 <- data.frame(b=1:2,
                   x=I(array(as.list(1:4), c(2,2))))

  b1 <- rbind.fill(d1, d1)
  b2 <- rbind.fill(d2, d2)
  b3 <- rbind.fill(d3, d3)

  expect_equal(dim(b1$x), c(4,2))
  expect_equal(typeof(b1$x), "character")

  expect_equal(dim(b2$x), c(4,2))
  expect_is(b2$x, "factor")

  expect_equal(dim(b3$x), c(4,2))
  expect_equal(typeof(b3$x), "list")
})

test_that("missing levels in factors preserved", {
  f <- addNA(factor(c("a", "b", NA)))
  df1 <- data.frame(a = f)
  df2 <- data.frame(b = f)
  rbind.fill(df1, df2)
})

test_that("time zones are preserved", {
  dstart <- "2011-01-01 00:01"
  dstop <- "2011-01-02 04:15"

  get_tz <- function(x) attr(as.POSIXlt(x), "tz")

  tzs <- c("CET", "UTC")
  for (tz in tzs) {
    start <- data.frame(x = as.POSIXct(dstart, tz = tz))
    end <- data.frame(x = as.POSIXct(dstop, tz = tz))

    both <- rbind.fill(start, end)
    expect_that(get_tz(both$x)[1], equals(tz), label = tz)
  }

})

test_that("1d arrays treated as vectors", {
  df <- data.frame(x = 1)
  df$x <- array(1, 1)

  #1d arrays converted into vectors
  df2 <- rbind.fill(df, df)
  expect_that(df2$x, is_equivalent_to(rbind(df, df)$x))
  expect_that(dim(df2$x), equals(dim(rbind(df, df)$x)))

  #if dims are stripped, dimnames should be also
  df <- data.frame(x = 1)
  df$x <- array(2, 1, list(x="one"))
  df2 <- rbind.fill(df, df)
  expect_that(is.null(dimnames(df2$x)), is_true())

  #can bind 1d array to vector
  dfV <- data.frame(x=3)
  dfO1 <- rbind.fill(df, dfV)
  dfO2 <- rbind.fill(dfV, df)
  expect_equal(dfO1, data.frame(x=c(2, 3)))
  expect_equal(dfO2, data.frame(x=c(3, 2)))
})

test_that("multidim arrays ok", {
  library(abind)
  df <- data.frame(x = 1:3)
  df$x <- array(1:27, c(3,3,3))

  df2 <- rbind.fill(df, df)
  expect_equal(dim(df2$x), dim(abind(along=1, df$x, df$x)))
  expect_that(df2$x, is_equivalent_to(abind(along=1, df$x, df$x)))
 })

test_that("Array column names preserved", {
  x <- data.frame(hair.color = dimnames(HairEyeColor)[[1]])
  x$obs <- unclass(HairEyeColor[,,1])

  xx1 <- rbind(x, x)
  xx2 <- rbind.fill(x, x)

  #plyr is against row names, but should respect col names like rbind
  rownames(xx1) <- NULL
  rownames(xx1$obs) <- NULL

  #but unlike rbind it should also preserve names-of-dimnames.
  names(dimnames(xx1$obs)) <- c("", "Eye")

  expect_equal(xx1, xx2)
})

test_that("attributes are preserved", {
  d1 <- data.frame(a = runif(10), b = runif(10))
  d2 <- data.frame(a = runif(10), b = runif(10))

  attr(d1$b, "foo") <- "one"
  attr(d1$b, "bar") <- "bar"
  attr(d2$b, "foo") <- "two"
  attr(d2$b, "baz") <- "baz"

  d12 <- rbind.fill(d1, d2)
  d21 <- rbind.fill(d2, d1)

  expect_that(attr(d12$b, "foo"), equals("one"))
  expect_that(attr(d21$b, "foo"), equals("two"))
})

test_that("characters override and convert factors", {
  d1a <- data.frame(x=c('a','b'), y=1:2)
  d2a <- data.frame(x=c('c','d'), z=1:2, stringsAsFactors=F)

  d1b <- data.frame(x=c('a','b'), y=1:2, stringsAsFactors=F)
  d2b <- data.frame(x=c('c','d'), z=1:2)

  d3a <- rbind.fill(d1a,d2a)
  d3b <- rbind.fill(d1b,d2b)

  expect_equal(d3a$x, c("a", "b", "c", "d"))
  expect_equal(d3b$x, c("a", "b", "c", "d"))
})

test_that("factor to character conversion preserves attributes", {
  d1 <- data.frame(a = letters[1:10], b = factor(letters[11:20]),
                   stringsAsFactors=FALSE)
  d2 <- data.frame(a = factor(letters[11:20]), b = letters[11:20],
                   stringsAsFactors=FALSE)

  attr(d1$a, "foo") <- "one"
  attr(d1$b, "foo") <- "two"
  attr(d2$a, "foo") <- "bar"
  attr(d2$b, "foo") <- "baz"

  d12 <- rbind.fill(d1, d2)

  expect_equal(attr(d12$a, "foo"), "one")
  expect_equal(attr(d12$b, "foo"), "two")
})

test_that("zero row data frames ok", {
  d1 <- data.frame(x = 1:2, y = 2:3)
  d2 <- data.frame(y = 3:4, z = 5:6)

  za <- rbind.fill(subset(d1, FALSE))
  zb <- rbind.fill(d1, subset(d2, FALSE))
  zc <- rbind.fill(subset(d1, FALSE), subset(d2, FALSE))

  expect_equal(class(za), "data.frame")
  expect_equal(nrow(za), 0)
  expect_true(all(names(za) %in% c("x", "y")))

  expect_equal(class(zb), "data.frame")
  expect_equal(nrow(zb), 2)
  expect_true(all(names(zb) %in% c("x", "y", "z")))
  expect_equal(zb$y, d1$y)
  expect_equal(zb$z, rep(as.numeric(NA), nrow(d1)))

  expect_equal(class(zc), "data.frame")
  expect_equal(nrow(zc), 0)
  expect_true(all(names(zc) %in% c("x", "y", "z")))
})

test_that("zero col data frames ok", {
  d1 <- data.frame(x = "a", y = 1L)
  d2 <- data.frame(y = 2L, z = 3L)

  za <- rbind.fill(d1[0, ], d2[0, ])
  zb <- rbind.fill(d1[0, ], d2)
  zc <- rbind.fill(d1, d2[0, ])

  expect_equal(names(za), c("x", "y", "z"))
  expect_equal(names(zb), c("x", "y", "z"))
  expect_equal(names(zc), c("x", "y", "z"))

  expect_equal(nrow(za), 0)
  expect_equal(nrow(zb), 1)
  expect_equal(nrow(zc), 1)
})

test_that("rbind.fill rejects non-vector columns", {
  a <- list(a=list(1), b=c(3), c="d", f=function() NULL)
  attr(a, "row.names") <- c(NA_integer_, -1)
  class(a) <- "data.frame"
  expect_error(rbind.fill(a,a), "cannot make")
})

test_that("rbind.fill rejects data frame columns", {
  a <- data.frame(a=1:3, b=2:4, c=3:5)
  a$c <- data.frame(x=10:12, y=11:13)
  rownames(a) <- NULL
  rownames(a$c) <- NULL
  expect_error(rbind.fill(a,a), "not supported")
})

rbind_time <- function(size,
                       classes = c("numeric", "character",
                                   "array", "factor", "time")) {
  unit <- quickdf(list(numeric = 1:3,
                       character = c("a", "b", "c"),
                       array = array(1:6, c(3,2)),
                       factor = factor(c("a", "b", "c")),
                       time = as.POSIXct(Sys.time()) + 1:3))
  args <- rep(list(unit[classes]), size)
  system.time(do.call(rbind.fill, args))
}

get_rbind_times <- function(...) {
  # nolint start
  rbind_time(10) #warm up/JIT
  mdply(.fun = rbind_time, ...)
  # nolint end
}

if (identical(Sys.getenv("NOT_CRAN"), "true") &&
    !identical(Sys.getenv("TRAVIS"), "true")) {

expect_linear_enough <- function(timings, threshold=0.1) {
  #expect that no more than `threshold` of a `size` input's runtime is
  #accounted for by quadratic behavior
  model <- lm(I(user.self / size) ~ size, timings)
  expect_less_than(threshold, summary(model)$coefficients[2,4])
}

test_that("rbind.fill performance linear", {
  timings <- get_rbind_times(data.frame(size = 2 ^ (1:10)),
                             classes=c("numeric", "character", "array"))
  expect_linear_enough(timings)
})

test_that("rbind.fill performance linear with factors", {
  timings <- get_rbind_times(data.frame(size = 2 ^ (1:10)),
                             classes=c("factor"))
  expect_linear_enough(timings)
})

test_that("rbind.fill performance linear with times", {
  timings <- get_rbind_times(data.frame(size = 2 ^ (1:10)),
                             classes=c("time"))
  expect_linear_enough(timings)
})

test_that("NULLs silently dropped", {
  expect_equal(rbind.fill(mtcars, NULL), mtcars)
  expect_equal(rbind.fill(NULL, mtcars), mtcars)
  expect_equal(rbind.fill(NULL, NULL), NULL)

})

}

#' Take a subset along an arbitrary dimension
#'
#' @param x matrix or array to subset
#' @param along dimension to subset along
#' @param indices the indices to select
#' @param drop should the dimensions of the array be simplified? Defaults
#'   to \code{FALSE} which is the opposite of the useful R default.
#' @export
#' @keywords manip
#' @examples
#' x <- array(seq_len(3 * 4 * 5), c(3, 4, 5))
#' take(x, 3, 1)
#' take(x, 2, 1)
#' take(x, 1, 1)
#' take(x, 3, 1, drop = TRUE)
#' take(x, 2, 1, drop = TRUE)
#' take(x, 1, 1, drop = TRUE)
take <- function(x, along, indices, drop = FALSE) {
  nd <- length(dim(x))

  index <- as.list(rep(TRUE, nd))
  index[along] <- indices

  eval(as.call(c(as.name("["), as.name("x"), index, drop = drop)))
}

#' Combine data.frames by row, filling in missing columns.
#'
#' \code{rbind}s a list of data frames filling missing columns with NA.
#' 
#' This is an enhancement to \code{\link{rbind}} that adds in columns
#' that are not present in all inputs, accepts a list of data frames, and 
#' operates substantially faster.
#'
#' Column names and types in the output will appear in the order in which 
#' they were encountered. No checking is performed to ensure that each column
#' is of consistent type in the inputs.
#' 
#' @param ... input data frames to row bind together
#' @keywords manip
#' @family binding functions
#' @return a single data frame
#' @export
#' @examples
#' rbind.fill(mtcars[c("mpg", "wt")], mtcars[c("wt", "cyl")])
rbind.fill <- function(...) {
  dfs <- list(...)
  if (length(dfs) == 0) return()
  if (is.list(dfs[[1]]) && !is.data.frame(dfs[[1]])) {
    dfs <- dfs[[1]]
  }
  dfs <- Filter(Negate(empty), dfs)
  
  if (length(dfs) == 0) return()
  if (length(dfs) == 1) return(dfs[[1]])
  
  # Calculate rows in output
  # Using .row_names_info directly is about 6 times faster than using nrow
  rows <- unlist(lapply(dfs, .row_names_info, 2L))
  nrows <- sum(rows)
  
  # Generate output template
  output <- output_template(dfs, nrows)
  
  # Compute start and end positions for each data frame
  pos <- matrix(cumsum(rbind(1, rows - 1)), ncol = 2, byrow = TRUE)
  
  # Copy inputs into output
  for(i in seq_along(rows)) { 
    rng <- pos[i, 1]:pos[i, 2]
    df <- dfs[[i]]
    
    for(var in names(df)) {
      if (!is.matrix(output[[var]])) {
        if (is.factor(output[[var]]) && is.character(df[[var]])) {
          output[[var]] <- as.character(output[[var]])
        }
        output[[var]][rng] <- df[[var]]
      } else {
        output[[var]][rng, ] <- df[[var]]
      }
    }
  } 
  
  quickdf(output)
}

output_template <- function(dfs, nrows) {
  vars <- unique(unlist(lapply(dfs, base::names)))   # ~ 125,000/s
  output <- vector("list", length(vars))
  names(output) <- vars
  
  seen <- rep(FALSE, length(output))
  names(seen) <- vars
  
  is_array <- seen
  is_matrix <- seen
  is_factor <- seen
    
  for(df in dfs) {    
    matching <- intersect(names(df), vars[!seen])
    for(var in matching) {
      value <- df[[var]]

      if (is.vector(value) && is.atomic(value)) {
        output[[var]] <- rep(NA, nrows)
      } else if (is.factor(value)) {
        output[[var]] <- factor(rep(NA, nrows), ordered = is.ordered(value))
        is_factor[var] <- TRUE
      } else if (is.matrix(value)) {
        is_matrix[var] <- TRUE
      } else if (is.array(value)) {
        is_array[var] <- TRUE
      } else if (inherits(value, "POSIXt")) {
        output[[var]] <- as.POSIXct(rep(NA, nrows))
        attr(output[[var]], "tzone") <- attr(value, "tzone")
      } else if (is.list(value)) {
        output[[var]] <- vector("list", nrows)
      } else {
        output[[var]] <- rep(NA, nrows)
        class(output[[var]]) <- class(value)
        attributes(output[[var]]) <- attributes(value)
      }
    }

    seen[matching] <- TRUE
    if (all(seen)) break  # Quit as soon as all done
  }

  # Set up factors
  for(var in vars[is_factor]) {
    all <- unique(lapply(dfs, function(df) levels(df[[var]])))
    output[[var]] <- factor(output[[var]], levels = unique(unlist(all)),
      exclude = NULL)
  }

  # Set up matrices
  for(var in vars[is_matrix]) {
    width <- unique(unlist(lapply(dfs, function(df) ncol(df[[var]]))))
    if (length(width) > 1) 
      stop("Matrix variable ", var, " has inconsistent widths")
      
    vec <- rep(NA, nrows * width)
    output[[var]] <- array(vec, c(nrows, width))
  }
  
  # Set up arrays
  for (var in vars[is_array]) {
    dims <- unique(unlist(lapply(dfs, function(df) dims(df[[var]]))))
    if (any(dims) > 1) {
      stop("rbind.fill can only work with 1d arrays")
    }
    
    output[[var]] <- rep(NA, nrows)    
  }
  
  output
}

#' An indexed array.
#'
#' Create a indexed array, a space efficient way of indexing into a large
#' array.
#'
#' @param env environment containing data frame
#' @param index list of indices
#' @keywords internal
#' @aliases indexed_array [[.indexed_array names.indexed_array
#'   length.indexed_array
indexed_array <- function(env, index) {
  exact <- all(unlist(llply(index, is.numeric)))

  # Situations that should use [
  #   * data.frame
  #   * normal array
  #   * normal vector
  #   * list-array with inexact indexing
  #
  # Situations that should use [[
  #   * list
  #   * list-array with exact indexing

  if (is.list(env$data)) {
    if (is.data.frame(env$data) || (is.array(env$data) && !exact)) {
      subs <- "["
    } else {
      subs <- "[["
    }
  } else {
    subs <- "["
  }

  # Don't drop if data is a data frame
  drop <- !is.data.frame(env$data)

  structure(
    list(env = env, index = index, drop = drop, subs = as.name(subs)),
    class = c("indexed_array", "indexed")
  )
}

#' @export
length.indexed_array <- function(x) nrow(x$index)

#' @export
"[[.indexed_array" <- function(x, i) {
  indices <- unname(x$index[i, , drop = TRUE])
  print(indices)
  indices <- lapply(indices, function(x) if (x == "") bquote() else x )

  call <- as.call(c(
    list(x$subs, quote(x$env$data)),
    indices,
    list(drop = x$drop)))
  eval(call)
}

#' @export
names.indexed_array <- function(x) rownames(x$index)

#' Call function with arguments in array or data frame, returning a data frame.
#'
#' Call a multi-argument function with values taken from columns of an data frame or array, and combine results into a data frame
#' 
#' The \code{m*ply} functions are the \code{plyr} version of \code{mapply},
#' specialised according to the type of output they produce.  These functions
#' are just a convenient wrapper around \code{a*ply} with \code{margins = 1}
#' and \code{.fun} wrapped in \code{\link{splat}}.
#' 
#' This function combines the result into a data frame.  If there are no
#' results, then this function will return a data frame with zero rows and
#' columns (\code{data.frame()}).
#' 
#' 
#' @keywords manip
#' @param .data matrix or data frame to use as source of arguments
#' @param .fun function to be called with varying arguments
#' @param ... other arguments passed on to \code{.fun}
#' @param .expand should output be 1d (expand = FALSE), with an element for
#'   each row; or nd (expand = TRUE), with a dimension for each variable.
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#' @return a data frame
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' mdply(data.frame(mean = 1:5, sd = 1:5), rnorm, n = 2)
#' mdply(expand.grid(mean = 1:5, sd = 1:5), rnorm, n = 2)
#' mdply(cbind(mean = 1:5, sd = 1:5), rnorm, n = 5)
#' mdply(cbind(mean = 1:5, sd = 1:5), as.data.frame(rnorm), n = 5)
mdply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none", .parallel = FALSE) {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)

  f <- splat(.fun)
  adply(.data = .data, .margins = 1, .fun = f, ..., 
    .expand = .expand, .progress = .progress, .parallel = .parallel)
}

#' Call function with arguments in array or data frame, returning an array.
#'
#' Call a multi-argument function with values taken from columns of an data frame or array, and combine results into an array
#' 
#' The \code{m*ply} functions are the \code{plyr} version of \code{mapply},
#' specialised according to the type of output they produce.  These functions
#' are just a convenient wrapper around \code{a*ply} with \code{margins = 1}
#' and \code{.fun} wrapped in \code{\link{splat}}.
#' 
#' This function combines the result into an array.  If there are no results,
#' then this function will return a vector of length 0 (\code{vector()}).
#' 
#' 
#' @keywords manip
#' @param .data matrix or data frame to use as source of arguments
#' @param .fun function to be called with varying arguments
#' @param ... other arguments passed on to \code{.fun}
#' @param .expand should output be 1d (expand = FALSE), with an element for
#'   each row; or nd (expand = TRUE), with a dimension for each variable.
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#' @return if results are atomic with same type and dimensionality, a vector, matrix or array; otherwise, a list-array (a list with dimensions)
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' maply(cbind(mean = 1:5, sd = 1:5), rnorm, n = 5)
#' maply(expand.grid(mean = 1:5, sd = 1:5), rnorm, n = 5)
#' maply(cbind(1:5, 1:5), rnorm, n = 5)
maply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none", .parallel = FALSE) {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)
  
  f <- splat(.fun)
  aaply(.data = .data, .margins = 1, .fun = f, ..., 
    .expand = .expand, .progress = .progress, .parallel = .parallel)
}

#' Call function with arguments in array or data frame, returning a list.
#'
#' Call a multi-argument function with values taken from columns of an data frame or array, and combine results into a list
#' 
#' The \code{m*ply} functions are the \code{plyr} version of \code{mapply},
#' specialised according to the type of output they produce.  These functions
#' are just a convenient wrapper around \code{a*ply} with \code{margins = 1}
#' and \code{.fun} wrapped in \code{\link{splat}}.
#' 
#' This function combines the result into a list.  If there are no results,
#' then this function will return a list of length 0  (\code{list()}).
#' 
#' 
#' @keywords manip
#' @param .data matrix or data frame to use as source of arguments
#' @param .fun function to be called with varying arguments
#' @param ... other arguments passed on to \code{.fun}
#' @param .expand should output be 1d (expand = FALSE), with an element for
#'   each row; or nd (expand = TRUE), with a dimension for each variable.
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#' @return list of results
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' mlply(cbind(1:4, 4:1), rep)
#' mlply(cbind(1:4, times = 4:1), rep)
#' 
#' mlply(cbind(1:4, 4:1), seq)
#' mlply(cbind(1:4, length = 4:1), seq)
#' mlply(cbind(1:4, by = 4:1), seq, to = 20)
mlply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none", .parallel = FALSE) {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)

  f <- splat(.fun)
  alply(.data = .data, .margins = 1, .fun = f, ..., 
    .expand = .expand, .progress = .progress, .parallel = .parallel)
}

#' Call function with arguments in array or data frame, discarding results.
#'
#' Call a multi-argument function with values taken from columns of an data frame or array, and discard results
#' 
#' The \code{m*ply} functions are the \code{plyr} version of \code{mapply},
#' specialised according to the type of output they produce.  These functions
#' are just a convenient wrapper around \code{a*ply} with \code{margins = 1}
#' and \code{.fun} wrapped in \code{\link{splat}}.
#' 
#' This function combines the result into a list.  If there are no results,
#' then this function will return a list of length 0  (\code{list()}).
#' 
#' @keywords manip
#' @param .data matrix or data frame to use as source of arguments
#' @param .fun function to be called with varying arguments
#' @param ... other arguments passed on to \code{.fun}
#' @param .expand should output be 1d (expand = FALSE), with an element for
#'   each row; or nd (expand = TRUE), with a dimension for each variable.
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
m_ply <- function(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none") {
  if (is.matrix(.data) & !is.list(.data)) .data <- .matrix_to_df(.data)

  f <- splat(.fun)
  a_ply(.data = .data, .margins = 1, .fun = f, ..., 
    .expand = .expand, .progress = .progress)
}

.matrix_to_df <- function(.data) {
  cnames <- colnames(.data)
  if (is.null(cnames)) cnames <- rep("", ncol(.data))
  .data <- as.data.frame(.data, stringsAsFactors = FALSE)
  colnames(.data) <- cnames
  .data  
}

context("Mapply")

test_that("Lack of names is preserved", {
  list <- mlply(cbind(1:5, 1:5), list)
  expect_that(names(list[[1]]), equals(NULL))

  vector <- mlply(cbind(1:5, 1:5), c)
  expect_that(names(vector[[1]]), equals(NULL))
})

test_that("No expansion creates single output dimension", {
  a <- maply(cbind(1:20, 1:20), "+", .expand = FALSE)
  expect_that(a, is_equivalent_to(1:20 * 2))
  
  d <- mdply(cbind(1:20, 1:20), "+", .expand = FALSE)
  expect_that(d$X1, equals(1:20))
  expect_that(d$V1, equals(1:20 * 2))
})

test_that("Expand = TRUE creates multiple output dimensions", {
  a <- maply(cbind(1:20, 1:20), "+", .expand = TRUE)
  expect_that(dim(a), equals(c(20, 20)))
  expect_that(diag(a), is_equivalent_to(1:20 * 2))
  
  d <- mdply(cbind(1:20, 1:20), "+", .expand = TRUE)
  expect_that(d$X1, equals(1:20))
  expect_that(d$X2, equals(1:20))
  expect_that(d$V1, equals(1:20 * 2))
})

#' Replicate expression and discard results.
#'
#' Evalulate expression n times then discard results
#'
#' This function runs an expression multiple times, discarding the results.
#' This function is equivalent to \code{\link{replicate}}, but never returns
#' anything
#'
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .print automatically print each result? (default: \code{FALSE})
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29.
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' r_ply(10, plot(runif(50)))
#' r_ply(25, hist(runif(1000)))
r_ply <- function(.n, .expr, .progress = "none", .print = FALSE) {
  .rlply_worker(.n, .progress,
                eval.parent(substitute(function() .expr)),
                .discard = TRUE, .print = .print)
  invisible(NULL)
}

#' Make a function return a data frame.
#'
#' Create a new function that returns the existing function wrapped in a
#' data.frame with a single column, \code{value}.
#'
#' This is useful when calling \code{*dply} functions with a function that
#' returns a vector, and you want the output in rows, rather than columns.
#' The \code{value} column is always created, even for empty inputs.
#'
#' @keywords manip
#' @param x function to make return a data frame
#' @param row.names necessary to match the generic, but not used
#' @param optional necessary to match the generic, but not used
#' @param ... necessary to match the generic, but not used
#' @method as.data.frame function
#' @export
as.data.frame.function <- function(x, row.names, optional, ...) {
  function(...) data.frame(value = x(...))
}

#' Recursively join a list of data frames.
#'
#' @param dfs A list of data frames.
#' @inheritParams join
#' @export
#' @examples
#' dfs <- list(
#'   a = data.frame(x = 1:10, a = runif(10)),
#'   b = data.frame(x = 1:10, b = runif(10)),
#'   c = data.frame(x = 1:10, c = runif(10))
#' )
#' join_all(dfs)
#' join_all(dfs, "x")
join_all <- function(dfs, by = NULL, type = "left", match = "all") {
  if (length(dfs) == 1) return(dfs[[1]])

  joined <- dfs[[1]]
  for (i in 2:length(dfs)) {
    joined <- join(joined, dfs[[i]], by = by, type = type, match = match)
  }

  joined
}

# This file was generated by Rcpp::compileAttributes
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Split indices.
#'
#' An optimised version of split for the special case of splitting row
#' indices into groups, as used by \code{\link{splitter_d}}.
#'
#' @param index integer indices
#' @param n largest integer (may not appear in index). This is hint: if
#'   the largest value of \code{group} is bigger than \code{n}, the output
#'   will silently expand.
#' @useDynLib plyr
#' @keywords internal manip
#' @export
#' @examples
#' split_indices(sample(10, 100, rep = TRUE))
#' split_indices(sample(10, 100, rep = TRUE), 10)
split_indices <- function(group, n = 0L) {
    .Call('plyr_split_indices', PACKAGE = 'plyr', group, n)
}

context("Split indices")

test_that("Error if n too small", {
  expect_error(split_indices(1:10, -5), "n must be")
})

test_that("index expands if n too small", {
  expect_equal(split_indices(1:10, 5), as.list(1:10))
})

test_that("n is optional in split indices", {
  x <- sample(100)
  a <- split_indices(x)
  b <- split_indices(x, 100)

  expect_equal(a, b)
})

test_that("succeeds for large number of groups", {
  i <- 2097142
  expect_equal(length(split_indices(seq_len(i), i)), i)
})

#' Text progress bar with time.
#'
#' A textual progress bar that estimates time remaining. It displays the
#' estimated time remaining and, when finished, total duration.
#'
#' @family progress bars
#' @export
#' @examples
#' l_ply(1:100, function(x) Sys.sleep(.01), .progress = "time")
progress_time <- function() {
  n <- 0
  txt <- NULL
  list(
    init = function(x) {
      txt <<- txtTimerBar(x)
      setTxtProgressBar(txt, 0)
    },
    step = function() {
      n <<- n + 1
      setTxtProgressBar(txt, n)
    },
    term = function() close(txt)
  )
}

txtTimerBar <- function(n = 1) {
  # nolint start
  start <- .last_update_time <- proc.time()[3]
  times <- numeric(n)
  # nolint end
  value <- NULL

  killed <- FALSE

  width <- getOption("width") - nchar('||100%  ~ 999.9 h remaining.')

  update <- function(i) {
    if (i == 0) return()

    value <<- i
    times[i] <- proc.time()[3] - start

    avg <- times[i] / i
    time_left <- (n - i) * avg

    nbars <- trunc(i / n * width)

    cat_line("|", str_rep("=", nbars), str_rep(" ", width - nbars), "|",
      format(i / n * 100, width = 3), "% ~", show_time(time_left), " remaining")
  }
  getVal <- function() value
  kill <- function(){
    if (killed) return()
    killed <<- TRUE

    if (value == n) {
      cat_line("|", str_rep("=", width), "|100%")
      cat("Completed after", show_time(proc.time()[3] - start), "\n")
    } else {
      cat("Killed after", show_time(proc.time()[3] - start), "\n")
    }
  }

  cat_line("|", str_rep(" ", width), "|  0%")

  structure(
    list(getVal = getVal, up = update, kill = kill),
    class = "txtProgressBar")
}

show_time <- function(x) {
  if (x < 60) {
    paste(round(x), "s")
  } else if (x < 60 * 60) {
    paste(round(x / 60), "m")
  } else {
    paste(round(x / (60 * 60)), "h")
  }
}

cat_line <- function(...) {
  msg <- paste(..., sep = "", collapse = "")
  gap <- max(c(0, getOption("width") - nchar(msg, "width")))
  cat("\r", msg, rep.int(" ", gap), sep = "")
  flush.console()
}

str_rep <- function(x, i) {
  paste(rep.int(x, i), collapse = "")
}

context("rbind.fill.matrix")

test_that ("merge 3 matrices: should behave like rbind.fill for data.frame",{
  a <- matrix (1:9, 3)
  b <- matrix (1:12, 3)
  c <- matrix (1:12, 2)

  new <- rbind.fill.matrix(a, b, c)

  ref <- as.matrix (rbind.fill (as.data.frame (a),
                                as.data.frame (b),
                                as.data.frame (c)))
  colnames (ref) <- seq_len(ncol(ref))
  # rbind.fill.matrix always sets
  # colnames. I don't think it's worth
  # wile trying to suppress that if no
  # matrix had column names before

  rownames (ref) <- NULL
  expect_that(new, equals(ref))
})


test_that ("additional columns are NA: should behave like rbind.fill for data.frame",{
  a <- matrix (1:9, 3)
  b <- matrix (1:12, 3)

  new <- rbind.fill.matrix (a, b)

  ref <- as.matrix (rbind.fill (as.data.frame (a), as.data.frame (b)))
  colnames (ref) <- seq_len(ncol(ref))
  rownames (ref) <- NULL
  
  expect_that(new, equals(ref))
})

test_that ("merge with column names: should behave like rbind.fill for data.frame",{
  a <- matrix (1:9, 3)
  colnames (a) <- letters [1 : 3]
  b <- matrix (1:9, 3)
  colnames (b) <- letters [3 : 1]

  new <- rbind.fill.matrix (a, b)

  ref <- as.matrix (rbind.fill (as.data.frame (a), as.data.frame (b)))
  rownames (ref) <- NULL
  
  expect_that(new, equals(ref))
})


test_that ("merge with column names: should behave like rbind.fill for data.frame",{
  a <- matrix (1:9, 3)
  colnames (a) <- letters [1 : 3]
  b <- matrix (1:9, 3)
  colnames (b) <- letters [c (1, 2, 4)]

  new <- rbind.fill.matrix (a, b)

  ref <- as.matrix (rbind.fill (as.data.frame (a), as.data.frame (b)))
  rownames (ref) <- NULL
  
  expect_that(new, equals(ref))
})

test_that ("only 1 element: should behave like rbind.fill for data.frame",{
  a <- matrix (1, 1)
  colnames (a) <- letters [2]
  
  b <- matrix (1:9, 3)
  colnames (b) <- letters [c (1, 2, 4)]
  
  new <- rbind.fill.matrix (a, b)

  ref <- as.matrix (rbind.fill (as.data.frame (a), as.data.frame (b)))
  rownames (ref) <- NULL
  
  expect_that(new, equals(ref))
})


test_that ("character + numeric: should behave like rbind.fill for data.frame",{
  a <- matrix (letters [1:9], 3)
  colnames (a) <- letters [1:3]
  b <- matrix (1:9, 3)
  colnames (b) <- letters [c (1, 2, 4)]

  new <- rbind.fill.matrix (a, b)
  ref <- rbind.fill (as.data.frame (a, stringsAsFactors = FALSE),
                     as.data.frame (b, stringsAsFactors = FALSE))
  ref <- as.matrix (sapply (ref, as.character)) # the last column is integer and would gain a second
                                                # character with direct as.matrix
  
  expect_that(new, equals(ref))
})


test_that ("factor: stops with error",{
  a <- factor (rep (LETTERS [1 : 3], 3))
  dim (a) <- c (3, 3)
  expect_that(rbind.fill.matrix (a), throws_error ("factor"))
})

test_that ("vector: uses as.matrix",{
  a <- 1

  new <- rbind.fill.matrix (a)

  ref <- data.frame (a = I (as.matrix (a)))
  colnames (ref) <- paste ("X", seq_len (ncol (ref)), sep = "")

  expect_that(new, equals (new))
})


 

#' Remove splitting variables from a data frame.
#'
#' This is useful when you want to perform some operation to every column
#' in the data frame, except the variables that you have used to split it.
#' These variables will be automatically added back on to the result when
#' combining all results together.
#'
#' @param df data frame produced by \code{d*ply}.
#' @export
#' @examples
#' dlply(mtcars, c("vs", "am"))
#' dlply(mtcars, c("vs", "am"), strip_splits)
strip_splits <- function(df) {
  df[setdiff(names(df), attr(df, "vars"))]
}

#' Modify names by name, not position.
#'
#' @param x named object to modify
#' @param replace named character vector, with new names as values, and
#'   old names as names.
#' @param warn_missing print a message if any of the old names are
#'   not actually present in \code{x}.
#' @param warn_duplicated print a message if any name appears more
#'   than once in \code{x} after the operation.
#' Note: x is not altered: To save the result, you need to copy the returned
#'   data into a variable.
#' @export
#' @importFrom stats setNames
#' @examples
#' x <- c("a" = 1, "b" = 2, d = 3, 4)
#' # Rename column d to "c", updating the variable "x" with the result
#' x <- rename(x, replace = c("d" = "c"))
#' x
#' # Rename column "disp" to "displacement"
#' rename(mtcars, c("disp" = "displacement"))
rename <- function(x, replace, warn_missing = TRUE, warn_duplicated = TRUE ) {

  # This line does the real work of `rename()`.
  names(x) <- revalue(names(x), replace, warn_missing = warn_missing)

  # Check if any names are duplicated.
  duplicated_names <- names(x)[duplicated(names(x))]
  if (warn_duplicated && (length(duplicated_names) > 0L)) {
    duplicated_names_message <- paste0("`", duplicated_names, "`", collapse=", ")
    warning("The plyr::rename operation has created duplicates for the ",
            "following name(s): (", duplicated_names_message, ")",
            call. = FALSE)
  }
  x
}

#' plyr: the split-apply-combine paradigm for R.
#'
#' The plyr package is a set of clean and consistent tools that implement the
#' split-apply-combine pattern in R. This is an extremely common pattern in
#' data analysis: you solve a complex problem by breaking it down into small
#' pieces, doing something to each piece and then combining the results back
#' together again.
#'
#' The plyr functions are named according to what sort of data structure they
#' split up and what sort of data structure they return:
#'
#' \describe{
#'   \item{a}{array}
#'   \item{l}{list}
#'   \item{d}{data.frame}
#'   \item{m}{multiple inputs}
#'   \item{r}{repeat multiple times}
#'   \item{_}{nothing}
#' }
#'
#' So \code{\link{ddply}} takes a data frame as input and returns a data frame
#' as output, and \code{\link{l_ply}} takes a list as input and returns nothing
#' as output.
#'
#' @section Row names:
#'
#' By design, no plyr function will preserve row names - in general it is too
#' hard to know what should be done with them for many of the operations
#' supported by plyr. If you want to preserve row names, use
#' \code{\link{name_rows}} to convert them into an explicit column in your
#' data frame, perform the plyr operations, and then use \code{\link{name_rows}}
#' again to convert the column back into row names.
#'
#' @section Helpers:
#'
#' Plyr also provides a set of helper functions for common data analysis
#' problems:
#'
#' \itemize{
#'   \item \code{\link{arrange}}: re-order the rows of a data frame by
#'     specifying the columns to order by
#'   \item \code{\link{mutate}}: add new columns or modifying existing columns,
#'     like \code{\link{transform}}, but new columns can refer to other columns
#'     that you just created.
#'   \item \code{\link{summarise}}: like \code{\link{mutate}} but create a
#'     new data frame, not preserving any columns in the old data frame.
#'
#'   \item \code{\link{join}}: an adapation of \code{\link{merge}} which is
#'     more similar to SQL, and has a much faster implementation if you only
#'     want to find the first match.
#'   \item \code{\link{match_df}}: a version of \code{\link{join}} that instead
#'     of returning the two tables combined together, only returns the rows
#'     in the first table that match the second.
#'
#'   \item \code{\link{colwise}}: make any function work colwise on a dataframe
#'   \item \code{\link{rename}}: easily rename columns in a data frame
#'   \item \code{\link{round_any}}: round a number to any degree of precision
#'   \item \code{\link{count}}: quickly count unique combinations and return
#'     return as a data frame.
#' }
#'
#' @docType package
#' @importFrom Rcpp sourceCpp
#' @name plyr
# EXCLUDE COVERAGE START
NULL


.onUnload <- function (libpath) {
  library.dynam.unload("plyr", libpath)
}
# EXCLUDE COVERAGE END

#' Split list, apply function, and return results in a data frame.
#'
#' For each element of a list, apply function then combine results into a data 
#' frame. 
#'
#' @template ply
#' @template l-
#' @template -d
#' @export
ldply <- function(.data, .fun = NULL, ..., .progress = "none", .parallel = FALSE) {
  if (!inherits(.data, "split")) .data <- as.list(.data)
  res <- llply(.data = .data, .fun = .fun, ..., 
    .progress = .progress, .parallel = .parallel)
  
  list_to_dataframe(res, attr(.data, "split_labels"))
}

#' Split data frame, apply function, and return results in a data frame.
#'
#' For each subset of a data frame, apply function then combine results into a
#' data frame.
#'
#' @template ply
#' @template d-
#' @template -d
#' @export
#' @examples
#' ddply(baseball, .(year), "nrow") 
#' ddply(baseball, .(lg), c("nrow", "ncol")) 
#' 
#' rbi <- ddply(baseball, .(year), summarise, 
#'   mean_rbi = mean(rbi, na.rm = TRUE))
#' with(rbi, plot(year, mean_rbi, type="l"))
#'
#' base2 <- ddply(baseball, .(id), transform, 
#'  career_year = year - min(year) + 1
#' )
ddply <- function(.data, .variables, .fun = NULL, ..., .progress = "none", .drop = TRUE, .parallel = FALSE) {
  if (empty(.data)) return(.data)
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop)
  
  ldply(.data = pieces, .fun = .fun, ..., 
    .progress = .progress, .parallel = .parallel)
}

#' Split array, apply function, and return results in a data frame.
#'
#' For each slice of an array, apply function then combine results into a data
#' frame.
#'
#' @template ply
#' @template a-
#' @template -d
#' @export
adply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE, .progress = "none", .parallel = FALSE) {
  pieces <- splitter_a(.data, .margins, .expand)
  
  ldply(.data = pieces, .fun = .fun, ..., 
    .progress = .progress, .parallel = .parallel)
}

context("List to data frame")

a <- as.POSIXct(1, origin="2011-01-01")

test_that("classes preserved for atomic scalars", {
  li <- list(a, a+1)
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(class(df[,1]), equals(class(a)))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(1))
})

test_that("classes preserved for atomic scalars in list of length 1", {
  li <- list(a)
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(1))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("classes preserved for atomic vectors", {
  li <- list(c(a, a+1), c(a+2, a+3))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("classes preserved for atomic vectors in list of length 1", {
  li <- list(c(a, a+1))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(2))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("classes preserved for data.frames", {
  li <- list(data.frame(V1=a, V2=a+1), data.frame(V1=a+2, V2=a+3))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("names preserved for atomic scalars", {
  li <- list(c(foo=1), c(foo=2))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(1))
  expect_that(names(df), equals(c("foo")))
})

test_that("names preserved for atomic scalars in list of length 1", {
  li <- list(c(foo=1))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(1))
  expect_that(names(df), equals(c("foo")))
})

test_that("names preserved for atomic vectors", {
  li <- list(c(foo=1, bar=2), c(foo=3, bar=4))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(class(df), equals("data.frame"))
  expect_that(names(df), equals(c("foo","bar")))
})

test_that("names preserved for atomic vectors n list of length 1", {
  li <- list(c(foo=1, bar=2))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(2))
  expect_that(names(df), equals(c("foo","bar")))
})

test_that("names preserved for data.frames", {
  li <- list(data.frame(foo=1, bar=2), data.frame(foo=3, bar=4))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(names(df), equals(c("foo","bar")))
})

test_that("names preserved and filled for atomic vectors", {
  li <- list(c(foo=1, 2), c(foo=3, 4))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(names(df), equals(c("foo","V1")))
})

test_that("names captured from list", {
  li <- list(a = 1:5, b = 5:10, c = 5:15)

  df <- ldply(li, function(x) mean(x))
  expect_that(df$.id, equals(c("a", "b", "c")))

  df <- ldply(li, function(x) {
      if (any(x >= 10)) mean(x)
  })
  expect_that(df$.id, equals(c("b", "c")))
})

test_that("correct number of rows outputted", {
  testdata <- data.frame(a = rep(letters[1:3], each = 5), b = rnorm(15))
  res <- ddply(testdata, .(a), function(x) c(mean(x$b), sd(x$b)))
  
  expect_that(nrow(res), equals(3))
})

context("Data frames")


test_that("results ordered in order of split variables", {
  d <- data.frame(x = c("a","b"), y = c("d","c"), stringsAsFactors = FALSE)

  plyed <- ddply(d, c("x" ,"y"))
  expect_that(plyed$x, equals(c("a", "b")))
  expect_that(plyed$y, equals(c("d", "c")))

  plyed <- ddply(d, c("y" ,"x"))
  expect_that(plyed$y, equals(c("c", "d")))
  expect_that(plyed$x, equals(c("b", "a")))

})

test_that("character vectors not change to factors", {
  d <- data.frame(x = c("a","b"), y = c("d","c"), stringsAsFactors = FALSE)

  plyed <- ddply(d, c("x" ,"y"), nrow)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))

  plyed <- ddply(d, c("x"), identity)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))

  plyed <- ddply(d, c("x" ,"y"), nrow, .drop = FALSE)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))

  plyed <- ddply(d, c("x"), identity, .drop = FALSE)
  expect_that(plyed$x, is_a("character"))
  expect_that(plyed$y, is_a("character"))
})


# Bug report contributed by Thomas P Harte <THarte@tiaa-cref.org>
test_that("column names not changed", {
  d1 <- data.frame(`--WEIRD`=1:5, a = letters[1:5], `-b` = 1:5,
    check.names = FALSE)
  d2 <- ddply(d1, .(`--WEIRD`), force)
  expect_that(names(d2), equals(names(d1)))


})

# Bug reported by Karl Ove Hufthammer <karl@huftis.org>
test_that("label variables always preserved", {

  d <- data.frame(x = 101:104, y = 1:4)
  f <- function(df) sum(df$y)
  g <- function(df) if(df$x <= 102) sum(df$y)

  out1 <- ddply(d, "x", f) # This one works correctly
  out2 <- ddply(d, "x", g) # This one doesn’t

  expect_that(names(out1), equals(names(out2)))
  expect_that(out1$x[1:2], equals(out2$x))


})

# Test for #140
test_that(".id column can be renamed or dropped", {
  l <- llply(1:4, function(i) rep(i, i))
  names(l) <- 1:4
  f <- function(l) data.frame(sum=sum(unlist(l)))

  out1 <- ldply(l, f)
  out2 <- ldply(l, f, .id='x')
  out3 <- ldply(l, f, .id=NULL)

  expect_equal(names(out1), c('.id', 'sum'))
  expect_equal(names(out2), c('x', 'sum'))
  expect_equal(names(out3), c('sum'))

  expect_identical(out1$.id, names(l))
  expect_identical(out2$x, factor(names(l)))

  out4 <- ldply(l, f, .id='sum') # names conflict
  expect_equal(names(out4), c('sum'))

  out5 <- ldply(l, f, .id=NA) # defaults
  expect_equal(names(out5), c('.id', 'sum'))
  expect_identical(out5$.id, names(l))

  out6 <- ldply(l, f, .id='.id') # defaults
  expect_equal(names(out6), c('.id', 'sum'))
  expect_identical(out6$.id, factor(names(l)))

  # no names = no .id column
  expect_equal(ldply(unname(l), f, .id=NA), out3)
  expect_equal(ldply(unname(l), f, .id="Name"), out3)
  expect_equal(ldply(unname(l), f, .id=NULL), out3)

  # todo: test for list with attr(,'split-labels'), needed?
})

context("ID column name")

test_that(".id parameter for ldply", {

  data <- setNames(nm = 1:10)

  expect_equal(names(ldply(data, identity)), c(".id", "V1"))
  expect_equal(names(ldply(data, identity, .id = NULL)), c("V1"))
  expect_equal(names(ldply(data, identity, .id = NA)), c(".id", "V1"))
  expect_equal(names(ldply(data, identity, .id = "ID")), c("ID", "V1"))

})

test_that("ID column is a factor if .id argument is set", {

  data <- setNames(nm = 1:10)

  expect_false(is.factor(ldply(data, identity)$.id))
  expect_true(is.factor(ldply(data, identity, .id = "ID")$ID))

})

test_that(".id parameter for rdply", {

  expect_equal(names(rdply(10, 0)), c(".n", "V1"))
  expect_false(is.factor(rdply(10, 0)$.n))
  expect_equal(names(rdply(10, 0, .id = NULL)), c("V1"))
  expect_equal(names(rdply(10, 0, .id = NA)), c(".n", "V1"))
  expect_equal(names(rdply(10, 0, .id = "ID")), c("ID", "V1"))
  expect_false(is.factor(rdply(10, 0, .id = "ID")$ID))

})

test_that(".id parameter for adply", {
  data <- array(1:27, dim = c(3, 3, 3))

  expect_equal(names(adply(data, 1, identity)), c("X1", "1", "2", "3"))
  expect_equal(names(adply(data, 2, identity)), c("X1", "1", "2", "3"))
  expect_equal(names(adply(data, 3, identity)), c("X1", "1", "2", "3"))
  expect_equal(names(adply(data, c(1, 2), identity)), c("X1", "X2", "V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 3), identity)), c("X1", "X2", "V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 2, 3), identity)), c("X1", "X2", "X3", "V1"))
  expect_equal(names(adply(data, c(), identity)), paste0("V", data))

  expect_equal(names(adply(data, 1, identity, .id = NA)), c("X1", "1", "2", "3"))
  expect_equal(names(adply(data, 2, identity, .id = NA)), c("X1", "1", "2", "3"))
  expect_equal(names(adply(data, 3, identity, .id = NA)), c("X1", "1", "2", "3"))
  expect_equal(names(adply(data, c(1, 2), identity, .id = NA)), c("X1", "X2", "V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 3), identity, .id = NA)), c("X1", "X2", "V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 2, 3), identity, .id = NA)), c("X1", "X2", "X3", "V1"))
  expect_equal(names(adply(data, c(), identity, .id = NA)), paste0("V", data))

  expect_equal(names(adply(data, 1, identity, .id = NULL)), c("1", "2", "3"))
  expect_equal(names(adply(data, 2, identity, .id = NULL)), c("1", "2", "3"))
  expect_equal(names(adply(data, 3, identity, .id = NULL)), c("1", "2", "3"))
  expect_equal(names(adply(data, c(1, 2), identity, .id = NULL)), c("V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 3), identity, .id = NULL)), c("V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 2, 3), identity, .id = NULL)), c("V1"))
  expect_equal(names(adply(data, c(), identity, .id = NULL)), paste0("V", data))

  expect_equal(names(adply(data, 1, identity, .id = LETTERS[1])), c("A", "1", "2", "3"))
  expect_equal(names(adply(data, 2, identity, .id = LETTERS[1])), c("A", "1", "2", "3"))
  expect_equal(names(adply(data, 3, identity, .id = LETTERS[1])), c("A", "1", "2", "3"))
  expect_equal(names(adply(data, c(1, 2), identity, .id = LETTERS[1:2])), c("A", "B", "V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 3), identity, .id = LETTERS[1:2])), c("A", "B", "V1", "V2", "V3"))
  expect_equal(names(adply(data, c(1, 2, 3), identity, .id = LETTERS[1:3])), c("A", "B", "C", "V1"))

  error_rx <- "[.]id argument.*number of margins"
  expect_error(adply(data, 1, identity, .id = LETTERS[1:2]), error_rx)
  expect_error(adply(data, 2, identity, .id = LETTERS[1:2]), error_rx)
  expect_error(adply(data, 3, identity, .id = LETTERS[1:2]), error_rx)
  expect_error(adply(data, c(1, 2), identity, .id = LETTERS[1:3]), error_rx)
  expect_error(adply(data, c(1, 3), identity, .id = LETTERS[1:3]), error_rx)
  expect_error(adply(data, c(1, 2, 3), identity, .id = LETTERS[1:4]), error_rx)
  expect_error(adply(data, c(), identity, .id = LETTERS[1]), error_rx)
})

context("List to data frame")

a <- as.POSIXct(1, origin="2011-01-01")

test_that("classes preserved for atomic scalars", {
  li <- list(a, a + 1)
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(class(df[,1]), equals(class(a)))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(1))
})

test_that("classes preserved for atomic scalars in list of length 1", {
  li <- list(a)
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(1))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("classes preserved for atomic vectors", {
  li <- list(c(a, a + 1), c(a + 2, a + 3))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("classes preserved for atomic vectors in list of length 1", {
  li <- list(c(a, a + 1))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(2))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("classes preserved for data.frames", {
  li <- list(data.frame(V1=a, V2=a + 1), data.frame(V1=a + 2, V2=a + 3))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(class(df[,1]), equals(class(a)))
})

test_that("names preserved for atomic scalars", {
  li <- list(c(foo=1), c(foo=2))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(1))
  expect_that(names(df), equals(c("foo")))
})

test_that("names preserved for atomic scalars in list of length 1", {
  li <- list(c(foo=1))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(1))
  expect_that(names(df), equals(c("foo")))
})

test_that("names preserved for atomic vectors", {
  li <- list(c(foo=1, bar=2), c(foo=3, bar=4))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(class(df), equals("data.frame"))
  expect_that(names(df), equals(c("foo","bar")))
})

test_that("names preserved for atomic vectors n list of length 1", {
  li <- list(c(foo=1, bar=2))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(1))
  expect_that(ncol(df), equals(2))
  expect_that(names(df), equals(c("foo","bar")))
})

test_that("names preserved for data.frames", {
  li <- list(data.frame(foo=1, bar=2), data.frame(foo=3, bar=4))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(names(df), equals(c("foo","bar")))
})

test_that("names preserved and filled for atomic vectors", {
  li <- list(c(foo=1, 2), c(foo=3, 4))
  df <- list_to_dataframe(li)
  expect_that(df, is_a("data.frame"))
  expect_that(nrow(df), equals(2))
  expect_that(ncol(df), equals(2))
  expect_that(names(df), equals(c("foo","V1")))
})

test_that("names captured from list", {
  li <- list(c = 5:15, b = 5:10, a = 1:5)

  df <- ldply(li, function(x) mean(x))
  expect_that(df$.id, equals(names(li)))

  df <- ldply(li, function(x) {
      if (any(x >= 10)) mean(x)
  })
  expect_that(df$.id, equals(names(li)[-3]))
})

test_that("correct number of rows outputted", {
  testdata <- data.frame(a = rep(letters[1:3], each = 5), b = rnorm(15))
  res <- ddply(testdata, .(a), function(x) c(mean(x$b), sd(x$b)))

  expect_that(nrow(res), equals(3))
})

test_that("matrices converted to data frames, without id column", {
  mat <- matrix(1:20, ncol = 4)
  colnames(mat) <- letters[1:4]

  li <- list(a = mat, b = mat)
  df <- list_to_dataframe(li)

  expect_equal(nrow(df), 2 * nrow(mat))
  expect_equal(names(df), c("a", "b", "c", "d"))
})

test_that("matrices converted to data frames, with id column", {
  mat <- matrix(1:20, ncol = 4)
  colnames(mat) <- letters[1:4]

  li <- list(a = mat, b = mat)
  df <- plyr:::list_to_dataframe(li, id_name = "my_id")

  expect_equal(nrow(df), 2 * nrow(mat))
  expect_equal(names(df), c("my_id", "a", "b", "c", "d"))
  expect_equal(df$my_id, rep(c("a", "b"), c(5, 5)))
})

test_that("matrices converted to data frames, with id column as factor", {
  mat <- matrix(1:20, ncol = 4)
  colnames(mat) <- letters[1:4]

  li <- list(a = mat, b = mat)
  df <- list_to_dataframe(li, id_name = "my_id", id_as_factor = TRUE)

  expect_equal(nrow(df), 2 * nrow(mat))
  expect_equal(names(df), c("my_id", "a", "b", "c", "d"))
  expect_equal(levels(df$my_id), c("a", "b"))
})

#' Determine if a vector is discrete.
#'
#' A discrete vector is a factor or a character vector
#'
#' @param x vector to test
#' @keywords internal
#' @export
#' @examples
#' is.discrete(1:10)
#' is.discrete(c("a", "b", "c"))
#' is.discrete(factor(c("a", "b", "c")))
is.discrete <- function(x) is.factor(x) || is.character(x) || is.logical(x)

#' Un-rowname.
#'
#' Strip rownames from an object
#'
#' @keywords internal
#' @param x data frame
#' @export
unrowname <- function(x) {
  rownames(x) <- NULL
  x
}

#' Function that always returns true.
#'
#' @param ... all input ignored
#' @return \code{TRUE}
#' @keywords internal
#' @seealso \code{\link{colwise}} which uses it
#' @export
true <- function(...) TRUE

#' Compact list.
#'
#' Remove all NULL entries from a list
#'
#' @param l list
#' @keywords manip internal
#' @export
compact <- function(l) Filter(Negate(is.null), l)

#' Number of unique values.
#'
#' Calculate number of unique values of a variable as efficiently as possible.
#'
#' @param x vector
#' @keywords internal
nunique <- function(x) {
  if (is.factor(x)) {
    length(levels(x))
  } else {
    length(unique(x))
  }
}

#' Check if a data frame is empty.
#'
#' Empty if it's null or it has 0 rows or columns
#'
#' @param df data frame to check
#' @keywords internal
#' @export
empty <- function(df) {
  (is.null(df) || nrow(df) == 0 || ncol(df) == 0)
}

#' Is a formula?
#' Checks if argument is a formula
#'
#' @keywords internal
#' @export
is.formula <- function(x) inherits(x, "formula")

"%||%" <- function(a, b) if (is.null(a)) b else a

.matrix_to_df <- function(.data) {
  cnames <- colnames(.data)
  if (is.null(cnames)) cnames <- rep("", ncol(.data))
  .data <- as.data.frame(.data, stringsAsFactors = FALSE)
  colnames(.data) <- cnames
  .data
}

context("Utilities")

test_that("is.discrete", {
  expect_true(is.discrete(factor(3)))
  expect_true(is.discrete("3"))
  expect_true(is.discrete(TRUE))
  expect_false(is.discrete(3L))
  expect_false(is.discrete(3.0))
  expect_false(is.discrete(identity))
})

test_that("nunique", {
  expect_equal(nunique(LETTERS), 26)
  expect_equal(nunique(factor(LETTERS)), 26)

  # Odd behavior, for compatibility reasons:
  expect_equal(nunique(factor(LETTERS)[1:3]), 26)
})

test_that("check for formula", {
  expect_true(is.formula(~a))
  expect_false(is.formula("a"))
})

#' Mutate a data frame by adding new or replacing existing columns.
#'
#' This function is very similar to \code{\link{transform}} but it executes
#' the transformations iteratively so that later transformations can use the
#' columns created by earlier transformations.  Like transform, unnamed
#' components are silently dropped.
#'
#' Mutate seems to be considerably faster than transform for large data
#' frames.
#'
#' @param .data the data frame to transform
#' @param ... named parameters giving definitions of new columns.
#' @seealso \code{\link{subset}}, \code{\link{summarise}},
#'   \code{\link{arrange}}.  For another somewhat different approach to
#'   solving the same problem, see \code{\link{within}}.
#' @export
#' @examples
#' # Examples from transform
#' mutate(airquality, Ozone = -Ozone)
#' mutate(airquality, new = -Ozone, Temp = (Temp - 32) / 1.8)
#'
#' # Things transform can't do
#' mutate(airquality, Temp = (Temp - 32) / 1.8, OzT = Ozone / Temp) 
#'
#' # mutate is rather faster than transform
#' system.time(transform(baseball, avg_ab = ab / g))
#' system.time(mutate(baseball, avg_ab = ab / g))
mutate <- function(.data, ...) {
  cols <- as.list(substitute(list(...))[-1])
  cols <- cols[names(cols) != ""] # Silently drop unnamed columns
  
  for(col in names(cols)) {
    .data[[col]] <- eval(cols[[col]], .data, parent.frame())
  }
  .data
}

context("Mutate")

test_that("mutate behaves the same as transform", {
  m1 <- mutate(airquality, Ozone = -Ozone)
  t1 <- mutate(airquality, Ozone = -Ozone)
  expect_that(m1, equals(t1))
  
  m2 <- mutate(airquality, new = -Ozone, Temp = (Temp-32)/1.8)
  t2 <- mutate(airquality, new = -Ozone, Temp = (Temp-32)/1.8)
  expect_that(m2, equals(t2))
})

test_that("columns can depend on previously created", {
  m1 <- mutate(airquality, dm = Month + Day / 31, dm2 = 2 * dm)
  dm2 <- with(airquality, 2 * (Month + Day / 31))
  
  expect_that(m1$dm2, equals(dm2))
})

#' Split data frame, apply function, and return results in a list.
#'
#' For each subset of a data frame, apply function then combine results into a
#' list. \code{dlply} is similar to \code{\link{by}} except that the results
#' are returned in a different format.
#' To apply a function for each row, use \code{\link{alply}} with
#' \code{.margins} set to \code{1}.
#'
#' @template ply
#' @template d-
#' @template -l
#' @export
#' @examples
#' linmod <- function(df) {
#'   lm(rbi ~ year, data = mutate(df, year = year - min(year)))
#' }
#' models <- dlply(baseball, .(id), linmod)
#' models[[1]]
#'
#' coef <- ldply(models, coef)
#' with(coef, plot(`(Intercept)`, year))
#' qual <- laply(models, function(mod) summary(mod)$r.squared)
#' hist(qual)
dlply <- function(.data, .variables, .fun = NULL, ..., .progress = "none",
                  .inform = FALSE, .drop = TRUE, .parallel = FALSE,
                  .paropts = NULL) {
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop)

  llply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts)
}

#' Summarise a data frame.
#'
#' Summarise works in an analogous way to \code{\link{mutate}}, except
#' instead of adding columns to an existing data frame, it creates a new
#' data frame.  This is particularly useful in conjunction with
#' \code{\link{ddply}} as it makes it easy to perform group-wise summaries.
#'
#' @param .data the data frame to be summarised
#' @param ... further arguments of the form var = value
#' @keywords manip
#' @aliases summarise summarize
#' @export summarise summarize
#' @note Be careful when using existing variable names; the corresponding
#' columns will be immediately updated with the new data and this can affect
#' subsequent operations referring to those variables.
#' @examples
#' # Let's extract the number of teams and total period of time
#' # covered by the baseball dataframe
#' summarise(baseball,
#'  duration = max(year) - min(year),
#'  nteams = length(unique(team)))
#' # Combine with ddply to do that for each separate id
#' ddply(baseball, "id", summarise,
#'  duration = max(year) - min(year),
#'  nteams = length(unique(team)))
summarise <- function(.data, ...) {
  stopifnot(is.data.frame(.data) || is.list(.data) || is.environment(.data))

  cols <- as.list(substitute(list(...))[-1])

  # ... not a named list, figure out names by deparsing call
  if(is.null(names(cols))) {
    missing_names <-  rep(TRUE, length(cols))
  } else {
    missing_names <- names(cols) == ""
  }
  if (any(missing_names)) {
    names <- unname(unlist(lapply(match.call(expand.dots = FALSE)$`...`, deparse))) # nolint
    names(cols)[missing_names] <- names[missing_names]
  }
  .data <- as.list(.data)
  for (col in names(cols)) {
    .data[[col]] <- eval(cols[[col]], .data, parent.frame())
  }
  quickdf(.data[names(cols)])
}
summarize <- summarise

context("Summarise")

test_that("summarise creates correct names", {
  df <- summarise(mtcars, cyl, vs)
  expect_that(names(df), equals(c("cyl", "vs")))

  df <- summarise(mtcars, x = cyl, vs)
  expect_that(names(df), equals(c("x", "vs")))

  df <- summarise(mtcars, x = cyl, y = vs)
  expect_that(names(df), equals(c("x", "y")))

  # df <- summarise(mtcars, mean(cyl), mean(vs))
  # expect_that(names(df), equals("x", "y"))
  
})

context("Summarise")

test_that("summarise creates correct names", {
  df <- summarise(mtcars, cyl, vs)
  expect_that(names(df), equals(c("cyl", "vs")))

  df <- summarise(mtcars, x = cyl, vs)
  expect_that(names(df), equals(c("x", "vs")))

  df <- summarise(mtcars, x = cyl, y = vs)
  expect_that(names(df), equals(c("x", "y")))

  df <- summarise(mtcars, mean(cyl), mvs = mean(vs))
  expect_that(names(df), equals(c("mean(cyl)", "mvs")))

})

#' List to vector.
#'
#' Reduce/simplify a list of homogenous objects to a vector
#' 
#' @param res list of input data
#' @keywords internal
#' @family list simplification functions
list_to_vector <- function(res) {
  n <- length(res)
  if (n == 0) return(vector())
  if (n == 1) return(res[[1]])
  
  atomic <- sapply(res, is.atomic)
  if (all(atomic)) {
    numeric <- all(unlist(lapply(res, is.numeric)))    
    classes <- unique(lapply(res, class))
    if (numeric || length(classes) == 1) {
      res <- unlist(res)
    }
  } 

  res
}

#' @param .fun function to apply to each piece
#' @param ... other arguments passed on to \code{.fun}
#' @param .progress name of the progress bar to use, see
#'   \code{\link{create_progress_bar}}
#' @keywords manip
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy 
#'   for Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.   

#' Split a data frame by variables.
#'
#' Split a data frame into pieces based on variable contained in that data frame
#' 
#' This is the workhorse of the \code{d*ply} functions.  Based on the variables
#' you supply, it breaks up a single data frame into a list of data frames,
#' each containing a single combination from the levels of the specified
#' variables.
#' 
#' This is basically a thin wrapper around \code{\link{split}} which
#' evaluates the variables in the context of the data, and includes enough
#' information to reconstruct the labelling of the data frame after 
#' other operations.
#' 
#' @seealso \code{\link{.}} for quoting variables, \code{\link{split}}
#' @family splitter functions
#' @param data data frame
#' @param .variables a \link{quoted} list of variables
#' @param drop drop unnused factor levels?
#' @return a list of data.frames, with attributes that record split details
#' @keywords internal
#' @examples
#' plyr:::splitter_d(mtcars, .(cyl))
#' plyr:::splitter_d(mtcars, .(vs, am))
#' plyr:::splitter_d(mtcars, .(am, vs))
#'
#' mtcars$cyl2 <- factor(mtcars$cyl, levels = c(2, 4, 6, 8, 10))
#' plyr:::splitter_d(mtcars, .(cyl2), drop = TRUE)
#' plyr:::splitter_d(mtcars, .(cyl2), drop = FALSE)
#'
#' mtcars$cyl3 <- ifelse(mtcars$vs == 1, NA, mtcars$cyl)
#' plyr:::splitter_d(mtcars, .(cyl3))
#' plyr:::splitter_d(mtcars, .(cyl3, vs))
#' plyr:::splitter_d(mtcars, .(cyl3, vs), drop = FALSE)
splitter_d <- function(data, .variables = NULL, drop = TRUE) {
  stopifnot(is.quoted(.variables))
  
  
  if (length(.variables) == 0) {
    splitv <- rep(1, nrow(data))
    split_labels <- NULL
    attr(splitv, "n") <- max(splitv)
    vars <- character(0)
  } else {
    splits <- eval.quoted(.variables, data)

    splitv <- id(splits, drop = drop)
    split_labels <- split_labels(splits, drop = drop, id = splitv)
    vars <- unlist(lapply(.variables, all.vars))
  }
  
  index <- split_indices(seq_along(splitv), as.integer(splitv), 
    attr(splitv, "n"))

  il <- indexed_df(data, index, vars)
  
  structure(
    il,
    class = c(class(il), "split", "list"),
    split_type = "data.frame",
    split_labels = split_labels
  )
}

#' Generate labels for split data frame.
#'
#' Create data frame giving labels for split data frame.
#' 
#' @param list of variables to split up by
#' @param whether all possible combinations should be considered, or only those present in the data
#' @keywords internal
#' @export
split_labels <- function(splits, drop, id = plyr::id(splits, drop = TRUE)) {
  if (length(splits) == 0) return(data.frame())
  
  if (drop) {
    # Need levels which occur in data
    representative <- which(!duplicated(id))[order(unique(id))]
    quickdf(lapply(splits, function(x) x[representative]))
  } else {
    unique_values <- llply(splits, ulevels)
    names(unique_values) <- names(splits)
    rev(expand.grid(rev(unique_values), stringsAsFactors = FALSE))
  }
}

ulevels <- function(x) {
  if (is.factor(x)) return(levels(x))
  sort(unique(x))
}

context("Split labels")

test_that("Empty levels preserved", {
  df <- data.frame(fac1 = letters[1:4], fac2 = LETTERS[1:4])

  a <- split_labels(df, FALSE)
  b <- split_labels(df[1, ], FALSE)

  expect_that(a, equals(b))

})

#' Count the number of occurences.
#'
#' Equivalent to \code{as.data.frame(table(x))}, but does not include
#' combinations with zero counts.
#'
#' Speed-wise count is competitive with \code{\link{table}} for single
#' variables, but it really comes into its own when summarising multiple
#' dimensions because it only counts combinations that actually occur in the
#' data.
#'
#' Compared to \code{\link{table}} + \code{\link{as.data.frame}}, \code{count}
#' also preserves the type of the identifier variables, instead of converting
#' them to characters/factors.
#'
#' @param df data frame to be processed
#' @param vars variables to count unique values of
#' @param wt_var optional variable to weight by - if this is non-NULL, count
#'   will sum up the value of this variable for each combination of id
#'   variables.
#' @return a data frame with label and freq columns
#' @keywords manip
#' @seealso \code{\link{table}} for related functionality in the base package
#' @export
#' @examples
#' # Count of each value of "id" in the first 100 cases
#' count(baseball[1:100,], vars = "id")
#' # Count of ids, weighted by their "g" loading
#' count(baseball[1:100,], vars = "id", wt_var = "g")
#' count(baseball, "id", "ab")
#' count(baseball, "lg")
#' # How many stints do players do?
#' count(baseball, "stint")
#' # Count of times each player appeared in each of the years they played
#' count(baseball[1:100,], c("id", "year"))
#' # Count of counts
#' count(count(baseball[1:100,], c("id", "year")), "id", "freq")
#' count(count(baseball, c("id", "year")), "freq")
count <- function(df, vars = NULL, wt_var = NULL) {
  if (is.atomic(df)) {
    df <- data.frame(x = df)
  }

  if (!is.null(vars)) {
    vars <- as.quoted(vars)
    df2 <- quickdf(eval.quoted(vars, df))
  } else {
    df2 <- df
  }

  id <- ninteraction(df2, drop = TRUE)
  u_id <- !duplicated(id)
  labels <- df2[u_id, , drop = FALSE]
  labels <- labels[order(id[u_id]), , drop = FALSE]

  if (is.null(wt_var) && "freq" %in% names(df)) {
    message("Using freq as weighting variable")
    wt_var <- "freq"
  }

  if (!is.null(wt_var)) {
    wt_var <- as.quoted(wt_var)
    if (length(wt_var) > 1) {
      stop("wt_var must be a single variable", call. = FALSE)
    }

    wt <- eval.quoted(wt_var, df)[[1]]
    freq <- vaggregate(wt, id, sum, .default = 0)
  } else {
    freq <- tabulate(id, attr(id, "n"))
  }

  unrowname(data.frame(labels, freq))
}

#' Create progress bar.
#'
#' Create progress bar object from text string.
#'
#' Progress bars give feedback on how apply step is proceeding.  This
#' is mainly useful for long running functions, as for short functions, the
#' time taken up by splitting and combining may be on the same order (or
#' longer) as the apply step.  Additionally, for short functions, the time
#' needed to update the progress bar can significantly slow down the process.
#' For the trivial examples below, using the tk progress bar slows things down
#' by a factor of a thousand.
#'
#' Note the that progress bar is approximate, and if the time taken by
#' individual function applications is highly non-uniform it may not be very
#' informative of the time left.
#'
#' There are currently four types of progress bar:  "none", "text", "tk", and
#' "win".  See the individual documentation for more details.  In plyr
#' functions, these can either be specified by name, or you can create the
#' progress bar object yourself if you want more control over its apperance.
#' See the examples.
#'
#' @param name type of progress bar to create
#' @param ... other arguments passed onto progress bar function
#' @seealso \code{\link{progress_none}}, \code{\link{progress_text}}, \code{\link{progress_tk}}, \code{\link{progress_win}}
#' @keywords utilities
#' @export
#' @examples
#' # No progress bar
#' l_ply(1:100, identity, .progress = "none")
#' \dontrun{
#' # Use the Tcl/Tk interface
#' l_ply(1:100, identity, .progress = "tk")
#' }
#' # Text-based progress (|======|)
#' l_ply(1:100, identity, .progress = "text")
#' # Choose a progress character, run a length of time you can see
#' l_ply(1:10000, identity, .progress = progress_text(char = "."))
create_progress_bar <- function(name = "none", ...) {
  if (!is.character(name)) return(name)
  name <- paste("progress", name, sep="_")

  if (!exists(name, mode = "function")) {
    warning("Cannot find progress bar ", name, call. = FALSE)
    progress_none()
  } else {
    match.fun(name)(...)
  }
}

#' Null progress bar
#'
#' A progress bar that does nothing
#'
#' This the default progress bar used by plyr functions.  It's very simple to
#' understand - it does nothing!
#'
#' @keywords internal
#' @family progress bars
#' @export
#' @examples
#' l_ply(1:100, identity, .progress = "none")
progress_none <- function() {
  list(
    init = function(x) NULL,
    step = function()  NULL,
    term = function()  NULL
  )
}

#' Text progress bar.
#'
#' A textual progress bar
#'
#' This progress bar displays a textual progress bar that works on all
#' platforms.  It is a thin wrapper around the built-in
#' \code{\link{setTxtProgressBar}} and can be customised in the same way.
#'
#' @param style style of text bar, see Details section of \code{\link{txtProgressBar}}
#' @param ... other arugments passed on to \code{\link{txtProgressBar}}
#' @family progress bars
#' @export
#' @examples
#' l_ply(1:100, identity, .progress = "text")
#' l_ply(1:100, identity, .progress = progress_text(char = "-"))
progress_text <- function(style = 3, ...) {
  n <- 0
  txt <- NULL

  list(
    init = function(x) {
      txt <<- txtProgressBar(max = x, style = style, ...)
      setTxtProgressBar(txt, 0)
    },
    step = function() {
      n <<- n + 1
      setTxtProgressBar(txt, n)
    },
    term = function() close(txt)
  )
}

#' Graphical progress bar, powered by Tk.
#'
#' A graphical progress bar displayed in a Tk window
#'
#' This graphical progress will appear in a separate window.
#'
#' @param title window title
#' @param label progress bar label (inside window)
#' @param ... other arguments passed on to \code{\link[tcltk]{tkProgressBar}}
#' @seealso \code{\link[tcltk]{tkProgressBar}} for the function that powers this progress bar
#' @family progress bars
#' @export
#' @examples
#' \dontrun{
#' l_ply(1:100, identity, .progress = "tk")
#' l_ply(1:100, identity, .progress = progress_tk(width=400))
#' l_ply(1:100, identity, .progress = progress_tk(label=""))
#' }
progress_tk <- function(title = "plyr progress", label = "Working...", ...) {
  stopifnot(requireNamespace("tcltk", quietly = TRUE))
  n <- 0
  tk <- NULL

  list(
    init = function(x) {
      tk <<- tcltk::tkProgressBar(max = x, title = title, label = label, ...)
      tcltk::setTkProgressBar(tk, 0)
    },
    step = function() {
      n <<- n + 1
      tcltk::setTkProgressBar(tk, n)
    },
    term = function() close(tk)
  )
}

#' Graphical progress bar, powered by Windows.
#'
#' A graphical progress bar displayed in a separate window
#'
#' This graphical progress only works on Windows.
#'
#' @param title window title
#' @param ... other arguments passed on to \code{winProgressBar}
#' @seealso \code{winProgressBar} for the function that powers this progress bar
#' @export
#' @family progress bars
#' @examples
#' if(exists("winProgressBar")) {
#' l_ply(1:100, identity, .progress = "win")
#' l_ply(1:100, identity, .progress = progress_win(title="Working..."))
#' }
progress_win <- function(title = "plyr progress", ...) {
  n <- 0
  win <- NULL

  list(
    init = function(x) {
      win <<- winProgressBar(max = x, title = title, ...) # nolint
      setWinProgressBar(win, 0) # nolint
    },
    step = function() {
      n <<- n + 1
      setWinProgressBar(win, n) # nolint
    },
    term = function() close(win)
  )
}

#' An indexed data frame.
#'
#' Create a indexed list, a space efficient way of indexing into a large data frame
#'
#' @param env environment containing data frame
#' @param index list of indices
#' @param vars a character vector giving the variables used for subsetting
#' @keywords internal
indexed_df <- function(data, index, vars) {

  structure(
    list(data = data, index = index, vars = vars),
    class = c("indexed", "indexed_df")
  )
}

#' @export
"[[.indexed_df" <- function(x, i) {
  out <- extract_rows(x$data, x$index[[i]])
  attr(out, "vars") <- x$vars
  out
}

extract_rows <- function(x, i) {
  if (!is.data.frame(x)) return(x[i, , drop = FALSE])

  n <- ncol(x)

  out <- lapply(seq_len(n), extract_col_rows, df = x, i = i)

  names(out) <- names(x)
  class(out) <- "data.frame"
  attr(out, "row.names") <- c(NA_integer_, -length(out[[1]]))

  out
}
extract_col_rows <- function(df, i, j) {
  col <- .subset2(df, j)
  if (isS4(col)) return(col[i])

  if (is.null(attr(col, "class"))) {
    .subset(col, i)
  } else if (inherits(col, "factor") || inherits(col, "POSIXt")) {
    out <- .subset(col, i)
    attributes(out) <- attributes(col)
    out
  } else {
    col[i]
  }
}

#' Split indices.
#'
#' An optimised version of split for the special case of splitting row
#' indices into groups, as used by \code{\link{splitter_d}}
#'
#' @param index integer indices
#' @param group integer groups
#' @param n largest integer (may not appear in index)
#' @useDynLib plyr
#' @keywords internal manip
split_indices <- function(index, group, n = max(group)) {
  if (length(index) == 0) return(integer())
  stopifnot(is.integer(index))
  stopifnot(is.integer(group))
  
  .Call("split_indices", index, group, as.integer(n))
}

#' Split list, apply function, and return results in a data frame.
#'
#' For each element of a list, apply function then combine results into a data
#' frame.
#'
#' @template ply
#' @template l-
#' @template -d
#' @param .id name of the index column (used if \code{.data} is a named list).
#'   Pass \code{NULL} to avoid creation of the index column. For compatibility,
#'   omit this argument or pass \code{NA} to avoid converting the index column
#'   to a factor; in this case, \code{".id"} is used as colum name.
#' @export
ldply <- function(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
                  .parallel = FALSE, .paropts = NULL, .id = NA) {
  if (!inherits(.data, "split")) .data <- as.list(.data)
  res <- llply(.data = .data, .fun = .fun, ...,
    .progress = .progress, .inform = .inform,
    .parallel = .parallel, .paropts = .paropts)

  if (identical(.id, NA)) {
    .id <- ".id"
    id_as_factor <- FALSE
  } else {
    id_as_factor <- TRUE
  }
  list_to_dataframe(res, attr(.data, "split_labels"), .id, id_as_factor)
}

#' Split data frame, apply function, and return results in an array.
#'
#' For each subset of data frame, apply function then combine results into
#' an array.  \code{daply} with a function that operates column-wise is
#' similar to \code{\link{aggregate}}.
#' To apply a function for each row, use \code{\link{aaply}} with
#' \code{.margins} set to \code{1}.
#'
#' @template ply
#' @section Input: This function splits data frames by variables.
#' @section Output:
#'   If there are no results, then this function will return a vector of
#'   length 0 (\code{vector()}).
#' @param .data data frame to be processed
#' @param .variables variables to split data frame by, as quoted
#'   variables, a formula or character vector
#' @param .drop_i should combinations of variables that do not appear in the
#'   input data be preserved (FALSE) or dropped (TRUE, default)
#' @return if results are atomic with same type and dimensionality, a
#'   vector, matrix or array; otherwise, a list-array (a list with
#'   dimensions)
#' @param .drop_o should extra dimensions of length 1 in the output be
#'   dropped, simplifying the output.  Defaults to \code{TRUE}
#' @family array output
#' @family data frame input
#' @export
#' @examples
#' daply(baseball, .(year), nrow)
#'
#' # Several different ways of summarising by variables that should not be
#' # included in the summary
#'
#' daply(baseball[, c(2, 6:9)], .(year), colwise(mean))
#' daply(baseball[, 6:9], .(baseball$year), colwise(mean))
#' daply(baseball, .(year), function(df) colwise(mean)(df[, 6:9]))
daply <- function(.data, .variables, .fun = NULL, ..., .progress = "none",
                  .inform = FALSE, .drop_i = TRUE, .drop_o = TRUE, .parallel = FALSE,
                  .paropts = NULL) {
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop_i)

  laply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform, .drop = .drop_o,
    .parallel = .parallel, .paropts = .paropts)
}

#' Quick data frame.
#'
#' Experimental version of \code{\link{as.data.frame}} that converts a
#' list to a data frame, but doesn't do any checks to make sure it's a
#' valid format.  Much faster.
#'
#' @param list list to convert to data frame
#' @keywords internal
#' @export
quickdf <- function(list) {
  rows <- unique(unlist(lapply(list, NROW)))
  stopifnot(length(rows) == 1)

  names(list) <- make_names(list, "X")
  class(list) <- "data.frame"
  attr(list, "row.names") <- c(NA_integer_, -rows)

  list
}

make_names <- function(x, prefix = "X") {
  nm <- names(x)
  if (is.null(nm)) {
    nm <- rep.int("", length(x))
  }

  n <- sum(nm == "", na.rm = TRUE)
  nm[nm == ""] <- paste(prefix, seq_len(n), sep = "")
  nm
}

#' Split list, apply function, and return results in an array.
#'
#' For each element of a list, apply function then combine results into an
#' array. \code{laply} is similar in spirit to \code{\link{sapply}} except
#' that it will always return an array, and the output is transposed with
#' respect \code{sapply} - each element of the list corresponds to a column,
#' not a row.
#'
#' @template ply
#' @template l-
#' @template -a
#' @export
#' @examples
#' laply(baseball, is.factor)
#' # cf
#' ldply(baseball, is.factor)
#' colwise(is.factor)(baseball)
#'
#' laply(seq_len(10), identity)
#' laply(seq_len(10), rep, times = 4)
#' laply(seq_len(10), matrix, nrow = 2, ncol = 2)
laply <-  function(.data, .fun = NULL, ..., .progress = "none", .drop = TRUE, .parallel = FALSE) {
  if (is.character(.fun)) .fun <- do.call("each", as.list(.fun))
  if (!is.function(.fun)) stop(".fun is not a function.")
  
  if (!inherits(.data, "split")) .data <- as.list(.data)
  res <- llply(.data = .data, .fun = .fun, ..., 
    .progress = .progress, .parallel = .parallel)
  
  list_to_array(res, attr(.data, "split_labels"), .drop)
}


#' Split data frame, apply function, and return results in an array.
#'
#' For each subset of data frame, apply function then combine results into
#' an array.  \code{daply} with a function that operates column-wise is
#' similar to \code{\link{aggregate}}. 
#' 
#' @template ply
#' @section Input: This function splits data frames by variables.
#' @section Output:
#'   If there are no results, then this function will return a vector of
#'   length 0 (\code{vector()}).
#' @param .data data frame to be processed
#' @param .variables variables to split data frame by, as quoted
#'   variables, a formula or character vector
#' @param .drop_i should combinations of variables that do not appear in the 
#'   input data be preserved (FALSE) or dropped (TRUE, default)
#' @param .parallel if \code{TRUE}, apply function in parallel, using parallel 
#'   backend provided by foreach
#' @return if results are atomic with same type and dimensionality, a
#'   vector, matrix or array; otherwise, a list-array (a list with
#'   dimensions)
#' @param .drop_o should extra dimensions of length 1 in the output be
#'   dropped, simplifying the output.  Defaults to \code{TRUE}
#' @family array output
#' @family data frame input
#' @export
#' @examples
#' daply(baseball, .(year), nrow)
#'
#' # Several different ways of summarising by variables that should not be 
#' # included in the summary
#' 
#' daply(baseball[, c(2, 6:9)], .(year), colwise(mean))
#' daply(baseball[, 6:9], .(baseball$year), colwise(mean))
#' daply(baseball, .(year), function(df) colwise(mean)(df[, 6:9]))
daply <- function(.data, .variables, .fun = NULL, ..., .progress = "none", .drop_i = TRUE, .drop_o = TRUE, .parallel = FALSE) {
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop_i)
  
  laply(.data = pieces, .fun = .fun, ..., 
    .progress = .progress, .drop = .drop_o, .parallel = .parallel)
}

#' Split array, apply function, and return results in an array.
#'
#' For each slice of an array, apply function, keeping results as an array.
#' This function is very similar to \code{\link{apply}}, except that it will
#' always return an array, and when the function returns >1 d data structures,
#' those dimensions are added on to the highest dimensions, rather than the
#' lowest dimensions.  This makes \code{aaply} idempotent, so that
#' \code{apply(input, X, identity)} is equivalent to \code{aperm(input, X)}.
#' 
#' @template ply
#' @template a-
#' @template -a
#' @export
#' @examples
#' dim(ozone)
#' aaply(ozone, 1, mean)
#' aaply(ozone, 1, mean, .drop = FALSE)
#' aaply(ozone, 3, mean)
#' aaply(ozone, c(1,2), mean)
#'
#' dim(aaply(ozone, c(1,2), mean))
#' dim(aaply(ozone, c(1,2), mean, .drop = FALSE)) 
#'
#' aaply(ozone, 1, each(min, max))
#' aaply(ozone, 3, each(min, max))
#' 
#' standardise <- function(x) (x - min(x)) / (max(x) - min(x))
#' aaply(ozone, 3, standardise)
#' aaply(ozone, 1:2, standardise)
#'  
#' aaply(ozone, 1:2, diff)
aaply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE, .progress = "none", .drop = TRUE, .parallel = FALSE) {
  pieces <- splitter_a(.data, .margins, .expand)
  
  laply(.data = pieces, .fun = .fun, ..., 
    .progress = .progress, .drop = .drop, .parallel = .parallel)
}

context("Arrays")

test_that("incorrect result dimensions raise errors", {
  fs <- list(
    function(x) rep(x, sample(10, 1)),
    function(x) if (x < 5) x else matrix(x, 2, 2)
  )
  
  expect_that(laply(1:10, fs[[1]]), throws_error("same dim"))
  expect_that(laply(1:10, fs[[2]]), throws_error("same number"))
})

test_that("zero length margin operates on whole object", {
  a <- array(1:24, 2:4)
  
  expect_that(alply(a, NULL, sum)[[1]], equals(sum(1:24)))  
})

test_that("results must have positive dimensions", {
  expect_that(
    aaply(matrix(0,2,2), 2, function(x) numeric(0)),
    throws_error("one or more dimensions"))
    
  expect_that(
    aaply(matrix(0,2,2), 2, function(x) NULL),
    throws_error("one or more dimensions"))
})


test_that("simple operations equivalent to vectorised form", {
  expect_that(laply(1:10, mean), is_equivalent_to(1:10))
  expect_that(laply(1:10, sqrt), is_equivalent_to(sqrt(1:10)))
})

test_that("array binding is correct", {
  library(abind)
  f <- function(x) matrix(x, 2, 2)
  m2d <- lapply(1:10, f)
  m3d <- abind(m2d, along = 0)
  
  expect_that(laply(1:10, f), is_equivalent_to(m3d))

  f <- function(x) array(x, c(2, 2, 2))
  m3d <- lapply(1:10, f)
  m4d <- abind(m3d, along = 0)
  
  expect_that(laply(1:10, f), is_equivalent_to(m4d))
})

# Basis of test contributed by anonymous reviewer.
test_that("idempotent function equivalent to permutation",  {  
  x <- array(1:24, 4:2, 
    dimnames = list(LETTERS[1:4], letters[24:26], letters[1:2]))

  perms <- unique(alply(as.matrix(subset(expand.grid(x=0:3,y=0:3,z=0:3), (x+y+z)>0 & !any(duplicated(setdiff(c(x,y,z), 0))))), 1, function(x) setdiff(x, 0)))

  aperms <- llply(perms, function(perm) aperm(x, unique(c(perm, 1:3))))
  aaplys <- llply(perms, function(perm) aaply(x, perm, identity))
  
  for(i in seq_along(aperms)) {
    perm <- paste(perms[[i]], collapse = ", ")
    expect_that(dim(aaplys[[i]]), equals(dim(aperms[[i]])), perm)
    expect_that(unname(dimnames(aaplys[[i]])), equals(dimnames(aperms[[i]])),
      perm)
    expect_that(aaplys[[i]], is_equivalent_to(aperms[[i]]), perm)
  }

})

# Test contributed by Baptiste Auguie
test_that("single column data frames work when treated as an array", {
  foo <- function(a="a", b="b", c="c", ...){
    paste(a, b, c, sep="")
  }

  df <- data.frame(b=1:2)
  res <- adply(df, 1, splat(foo))
  
  expect_that(res$b, equals(1:2))
  expect_that(as.character(res$V1), equals(c("a1c", "a2c")))
})

test_that("aaply equivalent to apply with correct permutation", {
  a <- matrix(seq_len(400), ncol = 20)
  expect_that(rowMeans(a), equals(aaply(a, 1, mean), check.attr = FALSE))
  expect_that(colMeans(a), equals(aaply(a, 2, mean), check.attr = FALSE))
  
  b <- structure(a, dimnames = amv_dimnames(a))
  expect_that(rowMeans(b), equals(aaply(b, 1, mean), check.attr = FALSE))
  expect_that(colMeans(b), equals(aaply(b, 2, mean), check.attr = FALSE))  
})

test_that("array reconstruction correct with missing cells", {
  df <- data.frame(i = rep(1:3, each = 12), j = rep(1:3, each = 4), v = 1:36) 
  df <- subset(df, i != j)

  da <- daply(df, .(i, j), function(q) sum(q$v))
  dd <- ddply(df, .(i, j), summarise, v1 = sum(v))

  m <- matrix(NA, 3, 3)
  m[cbind(dd$i, dd$j)] <- dd$v1
  
  expect_that(da, equals(m, check.attributes = FALSE))
})


set_dimnames <- function(x, nm) {
  dimnames(x) <- nm
  x
}

test_that("array names do not affect output", {
  base <- array(1:48, dim = c(12, 4))
  arrays <- list(
    none = base,
    numeric = set_dimnames(base, list(R = 1:12, C = 1:4)),
    numeric_rev = set_dimnames(base, list(R = 12:1, C = 4:1)),
    alpha = set_dimnames(base, list(R = letters[1:12], C = LETTERS[1:4])),
    alpha_rev = set_dimnames(base, list(R = letters[12:1], C = LETTERS[4:1]))
  ) 

  for(name in names(arrays)) {
    array <- arrays[[name]]
    expect_that(aaply(array, 1, sum), 
      equals(rowSums(array), check.attributes = FALSE), info = name)
    expect_that(aaply(array, 2, sum), 
      equals(colSums(array), check.attributes = FALSE), info = name)
  }
  
})

context("Arrays")

test_that("incorrect result dimensions raise errors", {
  fs <- list(
    function(x) rep(x, sample(10, 1)),
    function(x) if (x < 5) x else matrix(x, 2, 2),
    function(x) as.list(rep(x, sample(10, 1))),
    function(x) if (x < 5) list(x) else matrix(list(x), 2, 2)
  )

  expect_that(laply(1:10, fs[[1]]), throws_error("same dim"))
  expect_that(laply(1:10, fs[[2]]), throws_error("same number"))
  expect_that(laply(1:10, fs[[3]]), throws_error("same dim"))
  expect_that(laply(1:10, fs[[4]]), throws_error("same number"))
})

test_that("incompatible result types raise errors", {
  f <- function(x) if (x < 5) c(x, x) else as.list(x)

  expect_that(laply(1:10, f), throws_error("compatible type"))
})

test_that("zero length margin operates on whole object", {
  a <- array(1:24, 2:4)

  expect_that(alply(a, NULL, sum)[[1]], equals(sum(1:24)))
})

test_that("results must have positive dimensions", {
  expect_that(
    aaply(matrix(0,2,2), 2, function(x) NULL),
    throws_error("one or more dimensions"))
})


test_that("simple operations equivalent to vectorised form", {
  expect_that(laply(1:10, mean), is_equivalent_to(1:10))
  expect_that(laply(1:10, sqrt), is_equivalent_to(sqrt(1:10)))
})

test_that("array binding is correct", {
  library(abind)
  f <- function(x) matrix(x, 2, 2)
  m2d <- lapply(1:10, f)
  m3d <- abind(m2d, along = 0)

  expect_that(laply(1:10, f), is_equivalent_to(m3d))

  f <- function(x) array(x, c(2, 2, 2))
  m3d <- lapply(1:10, f)
  m4d <- abind(m3d, along = 0)

  expect_that(laply(1:10, f), is_equivalent_to(m4d))
})

test_that("array binding of lists is correct", {
  #this is identical to the previous test but in list mode
  f <- function(x) matrix(as.list(x), 2, 2)
  m2d <- lapply(1:10, f)
  #as abind itself doesn't do lists...
  m3d <- aperm(array(do.call(c, m2d), c(2, 2, 10)), c(3,1,2))

  expect_that(laply(1:10, f), is_equivalent_to(m3d))
  f <- function(x) array(as.list(x), c(2, 2, 2))
  m3d <- lapply(1:10, f)
  m4d <- aperm(array(do.call(c, m3d), c(2, 2, 2, 10)), c(4, 1, 2, 3))

  expect_that(laply(1:10, f), is_equivalent_to(m4d))
})

# Basis of test contributed by anonymous reviewer.
test_that("idempotent function equivalent to permutation",  {
  x <- array(1:24, 4:2,
    dimnames = list(LETTERS[1:4], letters[24:26], letters[1:2]))

  perms <- unique(alply(as.matrix(subset(expand.grid(x=0:3,y=0:3,z=0:3),
                                         (x + y + z) > 0 & !any(duplicated(setdiff(c(x,y,z), 0))))),
                        1,
                        function(x) setdiff(x, 0)))

  aperms <- llply(perms, function(perm) aperm(x, unique(c(perm, 1:3))))
  aaplys <- llply(perms, function(perm) aaply(x, perm, identity))

  for (i in seq_along(aperms)) {
    perm <- paste(perms[[i]], collapse = ", ")
    expect_that(dim(aaplys[[i]]), equals(dim(aperms[[i]])), perm)
    expect_that(unname(dimnames(aaplys[[i]])), equals(dimnames(aperms[[i]])),
      perm)
    expect_that(aaplys[[i]], is_equivalent_to(aperms[[i]]), perm)
  }

})

test_that("alply sets dims and dimnames, equivalence to permutation", {
  x <- array(1:24, 4:2,
             dimnames = list(dim1=LETTERS[1:4], dim2=letters[c(24,26,25)], dim3=NULL))
  #unlisting an alply should leave elements the the same order as
  #an aperm with the unused dimensions shifted to the front.
  #check against all ways to split this array
  p_alply <- unique(alply(as.matrix(subset(expand.grid(x=0:3,y=0:3,z=0:3),
                                         (x + y + z) > 0 & !any(duplicated(setdiff(c(x,y,z), 0))))),
                        1, function(x) setdiff(x, 0)))
  p_aperm <- llply(p_alply, function(x) union(setdiff(1:3, x), x))
  alplys <- lapply(p_alply, alply, .data=x, identity, .dims = TRUE)
  #alply will fill in dimnames on a dim that has none, so match that here
  dimnames(x)[[3]] <- c("1", "2")
  aperms <- llply(p_aperm, .fun=aperm, a=x)

  m_ply(cbind(x_perm=p_alply, x_ply=alplys, x_aperm=aperms),
        function(x_perm, x_ply, x_aperm) {
          expect_equivalent(dim(x_ply),
                            dim(x)[x_perm])
          expect_equivalent(dimnames(x_ply),
                            dimnames(x)[x_perm])
          expect_equivalent(dim(x_ply),
                            dim(x_aperm)[(length(dim(x)) - length(x_perm) + 1):(length(dim(x)))])
          expect_equivalent(as.vector(unlist(x_ply)), as.vector(x_aperm))
  })
})

# Test contributed by Baptiste Auguie
test_that("single column data frames work when treated as an array", {
  foo <- function(a="a", b="b", c="c", ...){
    paste(a, b, c, sep="")
  }

  df <- data.frame(b=1:2)
  res <- adply(df, 1, splat(foo))

  expect_that(res$b, equals(1:2))
  expect_that(as.character(res$V1), equals(c("a1c", "a2c")))
})

test_that("aaply equivalent to apply with correct permutation", {
  a <- matrix(seq_len(400), ncol = 20)
  expect_equivalent(rowMeans(a), aaply(a, 1, mean))
  expect_equivalent(colMeans(a), aaply(a, 2, mean))

  b <- structure(a, dimnames = amv_dimnames(a))
  expect_equivalent(rowMeans(b), aaply(b, 1, mean))
  expect_equivalent(colMeans(b), aaply(b, 2, mean))
})

test_that("array reconstruction correct with missing cells", {
  df <- data.frame(i = rep(1:3, each = 12), j = rep(1:3, each = 4), v = 1:36)
  df <- subset(df, i != j)

  da <- daply(df, .(i, j), function(q) sum(q$v))
  dd <- ddply(df, .(i, j), summarise, v1 = sum(v))

  m <- matrix(NA, 3, 3)
  m[cbind(dd$i, dd$j)] <- dd$v1

  expect_that(da, equals(m, check.attributes = FALSE))
})


set_dimnames <- function(x, nm) {
  dimnames(x) <- nm
  x
}

test_that("array names do not affect output", {
  base <- array(1:48, dim = c(12, 4))
  arrays <- list(
    none = base,
    numeric = set_dimnames(base, list(R = 1:12, C = 1:4)),
    numeric_rev = set_dimnames(base, list(R = 12:1, C = 4:1)),
    alpha = set_dimnames(base, list(R = letters[1:12], C = LETTERS[1:4])),
    alpha_rev = set_dimnames(base, list(R = letters[12:1], C = LETTERS[4:1]))
  )

  for (name in names(arrays)) {
    array <- arrays[[name]]
    expect_that(aaply(array, 1, sum),
      equals(rowSums(array), check.attributes = FALSE), info = name)
    expect_that(aaply(array, 2, sum),
      equals(colSums(array), check.attributes = FALSE), info = name)
  }

})

test_that("no support for duplicate names (#211)", {

  n <- function(x) {
    setNames(x, letters[c(1:9,2)])
  }
  B <- list(X=n(1:10), Y=n(11:20), Z=n(21:30))

  expect_warning(laply(B, identity), "Duplicate names")

  AB <- c('a', 'b', 'a', 'b')
  ABCD <- c('a', 'b', 'c', 'd')
  ar <-  array(rep(rep(rep(1:4, 4), 4), 2), dim=c(4, 4, 2), dimnames=list(ABCD, ABCD, c('i', 'ii')))
  ar[,,2] <- ar[,,2]+4
  dimnames(ar)[1:2] <- list(AB, AB)
  expect_warning(aaply(ar, 3, identity), "Duplicate names")

})

#' @section Output:
#'   If there are no results, then this function will return a vector of
#'   length 0 (\code{vector()}).
#' 
#' @return if results are atomic with same type and dimensionality, a
#'   vector, matrix or array; otherwise, a list-array (a list with
#'   dimensions)
#' @param .drop should extra dimensions of length 1 in the output be
#'   dropped, simplifying the output.  Defaults to \code{TRUE}
#' @family array output

#' Split an array by .margins.
#'
#' Split a 2d or higher data structure into lower-d pieces based
#'
#' This is the workhorse of the \code{a*ply} functions.  Given a >1 d
#' data structure (matrix, array, data.frame), it splits it into pieces
#' based on the subscripts that you supply.  Each piece is a lower dimensional
#' slice.
#'
#' The margins are specified in the same way as \code{\link{apply}}, but
#' \code{splitter_a} just splits up the data, while \code{apply} also
#' applies a function and combines the pieces back together.  This function
#' also includes enough information to recreate the split from attributes on
#' the list of pieces.
#'
#' @param data >1d data structure (matrix, data.frame or array)
#' @param .margins a vector giving the subscripts to split up \code{data} by.
#    1 splits up by rows, 2 by columns and c(1,2) by rows and columns
#' @param .expand if splitting a dataframe by row, should output be 1d
#'   (expand = FALSE), with an element for each row; or nd (expand = TRUE),
#'   with a dimension for each variable.
#' @param .id names of the split label.
#'   Pass \code{NULL} to avoid creation of split labels.
#'   Omit or pass \code{NA} to use the default names
#'   \code{"X1"}, \code{"X2"}, \ldots.
#'   Otherwise, this argument must have the same length as
#'   \code{.margins}.
#' @return a list of lower-d slices, with attributes that record split details
#' @family splitter functions
#' @keywords internal
#' @examples
#' plyr:::splitter_a(mtcars, 1)
#' plyr:::splitter_a(mtcars, 2)
#'
#' plyr:::splitter_a(ozone, 2)
#' plyr:::splitter_a(ozone, 3)
#' plyr:::splitter_a(ozone, 1:2)
splitter_a <- function(data, .margins = 1L, .expand = TRUE, .id = NA) {
  .margins <- as.integer(.margins)

  if (!is.null(.id)) {
    if (any(is.na(.id))) {
      .id <- paste("X", seq_along(.margins), sep="")
    } else {
      if (length(.id) != length(.margins)) {
        stop(".id argument must be of length ", length(.margins), " (=number of margins)")
      }
      .id <- as.character(.id)
    }
  }

  if (length(.margins) == 0) {
    return(list(data))
  }

  if (!all(.margins %in% seq_len(dims(data)))) stop("Invalid margin")

  dimensions <- lapply(amv_dim(data), seq_len)
  dimensions[-.margins] <- list("")
  indices <- expand.grid(dimensions, KEEP.OUT.ATTRS = FALSE,
    stringsAsFactors = FALSE)

  names(indices) <- paste("X", seq_len(ncol(indices)), sep="")

  # Ensure indices are ordered in the way in which they should appear in the
  # output - last margin varies fastest
  ord <- do.call(order, indices[rev(.margins)])
  indices <- unrowname(indices[ord, , drop = FALSE])

  il <- indexed_array(environment(), indices)

  if (is.data.frame(data) && .expand && identical(.margins, 1L)) {
    split_labels <- data
  } else {
    if (is.data.frame(data)) {
      dnames <- list(seq_len(nrow(data)), names(data))
    } else {
      dnames <- amv_dimnames(data)
      if (any(vapply(dnames, anyDuplicated, integer(1)) != 0)) {
        warning("Duplicate names not supported.", call. = FALSE)
      }
      dnames <- lapply(dnames, function(x) factor(x, levels = x))
    }

    raw <- mapply("[", dnames[.margins], indices[.margins], SIMPLIFY = FALSE)
    split_labels <- data.frame(raw, stringsAsFactors = FALSE)

    if (!is.null(names(dnames))) {
      names(split_labels) <- names(dnames)[.margins]
    } else {
      names(split_labels) <- .id
    }

    if (is.null(.id))
      split_labels <- NULL
  }

  structure(
    il,
    class = c(class(il), "split", "list"),
    split_type = "array",
    split_labels = split_labels
  )
}

#' Replicate expression and return results in a list.
#'
#' Evalulate expression n times then combine results into a list
#' 
#' This function runs an expression multiple times, and combines the 
#' result into a list.  If there are no results, then this function will return
#' a list of length 0  (\code{list()}). This function is equivalent to
#' \code{\link{replicate}}, but will always return results as a list.
#' 
#' 
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @return list of results
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' mods <- rlply(100, lm(y ~ x, data=data.frame(x=rnorm(100), y=rnorm(100))))
#' hist(laply(mods, function(x) summary(x)$r.squared))
rlply <- function(.n, .expr, .progress = "none") {
  if (is.function(.expr)) {
    f <- .expr
  } else {
    f <- eval.parent(substitute(function() .expr))    
  }

  progress <- create_progress_bar(.progress)  
  result <- vector("list", length = .n)

  progress$init(.n)
  on.exit(progress$term())

  for(i in seq_len(.n)) {
    result[i] <- list(f())
    progress$step()
  }
  
  result
}

#' Replicate expression and return results in a data frame.
#'
#' Evalulate expression n times then combine results into a data frame
#' 
#' This function runs an expression multiple times, and combines the 
#' result into a data frame.  If there are no results, then this function
#' returns a data frame with zero rows and columns (\code{data.frame()}).
#' This function is equivalent to \code{\link{replicate}}, but will always
#' return results as a data frame.
#' 
#' 
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @return a data frame
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' rdply(20, mean(runif(100)))
#' rdply(20, each(mean, var)(runif(100)))
#' rdply(20, data.frame(x = runif(2)))
rdply <- function(.n, .expr, .progress = "none") {
  if (is.function(.expr)) {
    f <- .expr
  } else {
    f <- eval.parent(substitute(function() .expr))    
  }
  
  res <- rlply(.n = .n, .expr = f, .progress = .progress)
  labels <- data.frame(.n = seq_len(.n))
  list_to_dataframe(res, labels)
}


#' Replicate expression and return results in a array.
#'
#' Evalulate expression n times then combine results into an array
#' 
#' This function runs an expression multiple times, and combines the 
#' result into a data frame.  If there are no results, then this function
#' returns a vector of length 0 (\code{vector(0)}).
#' This function is equivalent to \code{\link{replicate}}, but will always
#' return results as a vector, matrix or array.
#' 
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @return if results are atomic with same type and dimensionality, a vector, matrix or array; otherwise, a list-array (a list with dimensions)
#' @param .drop should extra dimensions of length 1 be dropped, simplifying the output.  Defaults to \code{TRUE}
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' raply(100, mean(runif(100)))
#' raply(100, each(mean, var)(runif(100)))
#'
#' raply(10, runif(4))
#' raply(10, matrix(runif(4), nrow=2))
#' 
#' # See the central limit theorem in action
#' hist(raply(1000, mean(rexp(10))))
#' hist(raply(1000, mean(rexp(100))))
#' hist(raply(1000, mean(rexp(1000))))
raply <- function(.n, .expr, .progress = "none", .drop = TRUE) {
  if (is.function(.expr)) {
    f <- .expr
  } else {
    f <- eval.parent(substitute(function() .expr))    
  }
  
  res <- rlply(.n = .n, .expr = f, .progress = .progress)
  list_to_array(res, NULL, .drop)
}

#' Replicate expression and discard results.
#'
#' Evalulate expression n times then discard results
#' 
#' This function runs an expression multiple times, discarding the results. 
#' This function is equivalent to \code{\link{replicate}}, but never returns
#' anything
#' 
#' @keywords manip
#' @param .n number of times to evaluate the expression
#' @param .expr expression to evaluate
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .print automatically print each result? (default: \code{FALSE})
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
#' @examples
#' r_ply(10, plot(runif(50)))
#' r_ply(25, hist(runif(1000)))
r_ply <- function(.n, .expr, .progress = "none", .print = FALSE) {
  if (is.function(.expr)) {
    f <- .expr
  } else {
    f <- eval.parent(substitute(function() .expr))    
  }

  progress <- create_progress_bar(.progress)  

  progress$init(.n)
  on.exit(progress$term())

  for(i in seq_len(.n)) {
    f()
    progress$step()
  }
  progress$term()
}

context("Replicate")

test_that("length of results are correct", {
  a <- rlply(4, NULL)
  b <- rlply(4, 1)

  expect_equal(length(a), 4)
  expect_equal(length(b), 4)
})

test_that("name of id column is set", {
  df <- rdply(4, function() c(a=1), .id='index')

  expect_equal(names(df), c('index', 'a'))
})

context("r?ply")

test_that("Side effects for r_ply", {
  counts <- c(0, 1, 5)

  # Simple function with side effect of incrementing i in an outer environment
  # by one
  inc <- function() {
    i <<- i + 1; invisible(NULL)
  }

  # For each of the possible counts, check that exactly n side effects are seen
  # for various types of invocations of inc: As a statement, as a function call
  # or as a function calling the function.  Calling r_ply with a function that
  # returns the inc function should not produce any side effects, this is
  # intentional.
  for (n in counts) {
    i <- 0
    r_ply(n, inc)
    expect_equal(i, n, info="inc")

    i <- 0
    r_ply(n, inc())
    expect_equal(i, n, info="inc()")

    i <- 0
    r_ply(n, inc() + inc())
    expect_equal(i, 2 * n, info="inc() + inc()")

    i <- 0
    r_ply(n, function() inc())
    expect_equal(i, n, info="function() inc()")

    i <- 0
    r_ply(n, function() inc() + inc())
    expect_equal(i, 2 * n, info="function() inc() + inc()")

    i <- 0
    r_ply(n, function() inc)
    expect_equal(i, 0, info="function() inc")
  }
})

test_that("Side effects for rlply", {
  counts <- c(0, 1, 5)

  # Similar to the test for r_ply, now there is also a return value in incition
  # to the side effect
  inc <- function() {
    i <<- i + 1
  }

  # The test now checks, in incition to side effect count, that the returned
  # list is correct
  for (n in counts) {
    i <- 0
    res <- rlply(n, inc)
    expect_equal(res, as.list(seq_len(n)), info="inc")
    expect_equal(i, n, info="inc")

    i <- 0
    res <- rlply(n, inc())
    expect_equal(res, as.list(seq_len(n)), info="inc()")
    expect_equal(i, n, info="inc()")

    i <- 0
    res <- rlply(n, function() inc())
    expect_equal(res, as.list(seq_len(n)), info="function() inc()")
    expect_equal(i, n, info="function() inc()")

    # Funny case: A function that returns a function, this is not
    # handled at all
    i <- 0
    rlply(n, function() inc)
    expect_equal(i, 0, info="function() inc")
  }
})

test_that("Side effects for raply", {
  counts <- c(0, 1, 5)

  inc <- function() {
    i <<- i + 1
  }

  for (n in counts) {
    # This is funny. Why does raply(.n, inc) return a named vector only for
    # .n == 1?
    if (n == 0) {
      exp_res <- logical()
    } else if (n == 1) {
      exp_res <- setNames(nm = 1)
    } else
      exp_res <- seq_len(n)

    i <- 0
    res <- raply(n, inc)
    expect_equal(res, exp_res, info="inc")
    expect_equal(i, n, info="inc")

    i <- 0
    res <- raply(n, inc())
    expect_equal(res, exp_res, info="inc()")
    expect_equal(i, n, info="inc()")

    i <- 0
    res <- raply(n, function() inc())
    expect_equal(res, exp_res, info="function() inc()")
    expect_equal(i, n, info="function() inc()")
  }
})

test_that("Side effects for rdply", {
  counts <- c(0, 1, 5)

  inc <- function() {
    i <<- i + 1; data.frame(i = i)
  }

  for (n in counts) {
    if (n == 0) {
      exp_res <- data.frame()
    } else {
      exp_res <- data.frame(.n = 1L:n, i = 1L:n, stringsAsFactors = FALSE)
    }

    i <- 0
    res <- rdply(n, inc)
    expect_equal(res, exp_res, info="inc")
    expect_equal(i, n, info="inc")

    i <- 0
    res <- rdply(n, inc())
    expect_equal(res, exp_res, info="inc()")
    expect_equal(i, n, info="inc()")

    i <- 0
    res <- rdply(n, function() inc())
    expect_equal(res, exp_res, info="function() inc()")
    expect_equal(i, n, info="function() inc()")
  }
})

test_that("Invalid arguments for r_ply", {
  expect_error(r_ply(-3, identity))
  expect_error(r_ply("abc", identity))
  expect_error(r_ply(c(1,2), identity))
  expect_error(r_ply(list(5), identity))
})

test_that(".id column for rdply", {
  expect_equal(rdply(5, 10)$.n, 1:5)
  expect_equal(rdply(5, 10, .id=".x")$.x, 1:5)
})

#' Split list, apply function, and discard results.
#'
#' For each element of a list, apply function and discard results
#' 
#' All plyr functions use the same split-apply-combine strategy: they split the
#' input into simpler pieces, apply \code{.fun} to each piece, and then combine
#' the pieces into a single data structure.  This function splits lists by
#' elements and discards the output.  This is useful for functions that you are 
#' calling purely for their side effects like display plots and saving output.
#' 
#' 
#' @keywords manip
#' @param .data list to be processed
#' @param .fun function to apply to each piece
#' @param ... other arguments passed on to \code{.fun}
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .print automatically print each result? (default: \code{FALSE})
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
l_ply <- function(.data, .fun = NULL, ..., .progress = "none", .print = FALSE) {
  if (is.character(.fun) || is.list(.fun)) .fun <- each(.fun)
  if (!is.function(.fun)) stop(".fun is not a function.")
  
  progress <- create_progress_bar(.progress)
  progress$init(length(.data))
  on.exit(progress$term())
  
  .data <- as.list(.data)
  for(i in seq_along(.data)) {
    x <- .fun(.data[[i]], ...)
    if (.print) print(x)
    progress$step()
  }
  
  invisible()
}

#' Split data frame, apply function, and discard results.
#'
#' For each subset of a data frame, apply function and discard results
#' 
#' All plyr functions use the same split-apply-combine strategy: they split the
#' input into simpler pieces, apply \code{.fun} to each piece, and then combine
#' the pieces into a single data structure.  This function splits data frames
#' by variable and discards the output.  This is useful for functions that you
#' are calling purely for their side effects like display plots and saving
#' output.
#' 
#' 
#' @keywords manip
#' @param .data data frame to be processed
#' @param .variables variables to split data frame by, as quoted variables, a formula or character vector
#' @param .fun function to apply to each piece
#' @param ... other arguments passed on to \code{.fun}
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .print automatically print each result? (default: \code{FALSE})
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
d_ply <- function(.data, .variables, .fun = NULL, ..., .progress = "none", .print = FALSE) {
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables)
  
  l_ply(.data = pieces, .fun = .fun, ..., .progress = .progress, .print = .print)
}

#' Split array, apply function, and discard results.
#'
#' For each slice of an array, apply function and discard results
#' 
#' All plyr functions use the same split-apply-combine strategy: they split the
#' input into simpler pieces, apply \code{.fun} to each piece, and then combine
#' the pieces into a single data structure.  This function splits matrices,
#' arrays and data frames by dimensions and discards the output.  This is
#' useful for functions that you are calling purely for their side effects like
#' display plots and saving output.
#' 
#' 
#' @keywords manip
#' @param .data matrix, array or data frame to be processed
#' @param .margins a vector giving the subscripts to split up \code{data} by.  1 splits up by rows, 2 by columns and c(1,2) by rows and columns, and so on for higher dimensions
#' @param .fun function to apply to each piece
#' @param ... other arguments passed on to \code{.fun}
#' @param .expand if \code{.data} is a data frame, should output be 1d 
#'   (expand = FALSE), with an element for each row; or nd (expand = TRUE),
#'    with a dimension for each variable.
#' @param .progress name of the progress bar to use, see \code{\link{create_progress_bar}}
#' @param .print automatically print each result? (default: \code{FALSE})
#' @export
#' @references Hadley Wickham (2011). The Split-Apply-Combine Strategy for
#'   Data Analysis. Journal of Statistical Software, 40(1), 1-29. 
#'   \url{http://www.jstatsoft.org/v40/i01/}.
a_ply <- function(.data, .margins, .fun = NULL, ..., .expand = TRUE, .progress = "none", .print = FALSE) {
  pieces <- splitter_a(.data, .margins, .expand)
  
  l_ply(.data = pieces, .fun = .fun, ..., .progress = .progress, .print = .print)
}

#' Summarise a data frame.
#'
#' Summarise works in an analagous way to transform, except instead of adding
#' columns to an existing data frame, it creates a new one.  This is
#' particularly useful in conjunction with \code{\link{ddply}} as it makes it
#' easy to perform group-wise summaries.
#' 
#' @param .data the data frame to be summarised
#' @param ... further arguments of the form var = value
#' @keywords manip
#' @aliases summarise summarize
#' @export summarise summarize
#' @examples
#' summarise(baseball, 
#'  duration = max(year) - min(year), 
#'  nteams = length(unique(team)))
#' ddply(baseball, "id", summarise, 
#'  duration = max(year) - min(year), 
#'  nteams = length(unique(team)))
summarise <- function(.data, ...) {
  cols <- eval(substitute(list(...)), .data, parent.frame())
  
  # ... not a named list, figure out names by deparsing call
  if(is.null(names(cols))) {
    missing_names <-  rep(TRUE, length(cols))
  } else {
    missing_names <- names(cols) == ""
  }
  if (any(missing_names)) {
    names <- unname(unlist(lapply(match.call(expand = FALSE)$`...`, deparse)))
    names(cols)[missing_names] <- names[missing_names]
  }

  quickdf(cols)
}
summarize <- summarise

#' List to data frame.
#'
#' Reduce/simplify a list of homogenous objects to a data frame.
#' All \code{NULL} entries are removed. Remaining entries must be all atomic
#' or all data frames.
#' 
#' @family list simplification functions
#' @param res list of input data
#' @param labels a data frame of labels, one row for each element of res
#' @keywords internal
list_to_dataframe <- function(res, labels = NULL) {
  null <- vapply(res, is.null, logical(1))
  res <- res[!null]
  if (length(res) == 0) return(data.frame())

  if (!is.null(labels)) {
    stopifnot(nrow(labels) == length(null))
    labels <- labels[!null, , drop = FALSE]
  }
  if (is.null(labels) && !is.null(names(res))) {
    labels <- data.frame(.id = names(res), stringsAsFactors = FALSE)
  }

  # Figure out how to turn elements into a data frame
  atomic <- unlist(lapply(res, is.atomic))
  df <- unlist(lapply(res, is.data.frame))

  if (all(atomic)) {
    nrow <- length(res)
    ncol <- unique(unlist(lapply(res, length)))
    if (length(ncol) != 1) stop("Results do not have equal lengths")
    
    vec <- unname(do.call("c", res))
    
    resdf <- quickdf(unname(split(vec, rep(seq_len(ncol), nrow))))
    names(resdf) <- make_names(res[[1]], "V")
    
    rows <- rep(1, length(nrow))
  } else if (all(df)) {
    resdf <- rbind.fill(res)
    rows <- unlist(lapply(res, NROW))
  } else {
    stop("Results must be all atomic, or all data frames")
  }
  
  if(is.null(labels)) return(unrowname(resdf))

  # Add labels to results
  names(labels) <- make_names(labels, "X")
  
  cols <- setdiff(names(labels), names(resdf))
  labels <- labels[rep(1:nrow(labels), rows), cols, drop = FALSE]
  
  unrowname(cbind(labels, resdf))
}

#' Split data frame, apply function, and discard results.
#'
#' For each subset of a data frame, apply function and discard results.
#' To apply a function for each row, use \code{\link{a_ply}} with
#' \code{.margins} set to \code{1}.
#'
#' @template ply
#' @template d-
#' @template -_
#' @export
d_ply <- function(.data, .variables, .fun = NULL, ..., .progress = "none",
                  .inform = FALSE, .drop = TRUE, .print = FALSE,
                  .parallel = FALSE, .paropts = NULL) {
  .variables <- as.quoted(.variables)
  pieces <- splitter_d(.data, .variables, drop = .drop)

  l_ply(.data = pieces, .fun = .fun, ...,
    .progress = .progress, .inform = .inform, .print = .print,
    .parallel = .parallel, .paropts = .paropts)
}

context("Informative messages")

test_that(".inform parameter works for all l?ply functions", {
  funcnames <- ls(name = asNamespace("plyr"), pattern = "^l[^i]ply$")

  old_options <- options(show.error.messages = FALSE)
  on.exit(options(old_options), add = TRUE)

  input <- 1:10
  for (funcname in funcnames) {
    func <- get(funcname, asNamespace("plyr"))
    expect_error(func(input, function(...) stop("qq"), .inform = TRUE), "piece 1", info = funcname)
  }
})

test_that(".inform parameter works for all d?ply functions", {
  funcnames <- ls(name = asNamespace("plyr"), pattern = "^d[^i]ply$")

  old_options <- options(show.error.messages = FALSE)
  on.exit(options(old_options), add = TRUE)

  input <- data.frame(a = 1:10)
  for (funcname in funcnames) {
    func <- get(funcname, asNamespace("plyr"))
    expect_error(func(input, .(), function(...) stop("qq"), .inform = TRUE), "piece 1", info = funcname)
  }
})

test_that(".inform parameter works for all a?ply functions", {
  funcnames <- ls(name = asNamespace("plyr"), pattern = "^a[^i]ply$")

  old_options <- options(show.error.messages = FALSE)
  on.exit(options(old_options), add = TRUE)

  input <- data.frame(a = 1:10)
  for (funcname in funcnames) {
    func <- get(funcname, asNamespace("plyr"))
    expect_error(func(input, 1, function(...) stop("qq"), .inform = TRUE), "piece 1", info = funcname)
  }
})

test_that(".inform parameter works for all m?ply functions", {
  funcnames <- ls(name = asNamespace("plyr"), pattern = "^m[^i]ply$")

  old_options <- options(show.error.messages = FALSE)
  on.exit(options(old_options), add = TRUE)

  input <- data.frame(a = 1:10)
  for (funcname in funcnames) {
    func <- get(funcname, asNamespace("plyr"))
    expect_error(func(input, function(...) stop("qq"), .inform = TRUE), "piece 1", info = funcname)
  }
})

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/quote.r
\name{as.quoted}
\alias{as.quoted}
\title{Convert input to quoted variables.}
\usage{
as.quoted(x, env = parent.frame())
}
\arguments{
\item{x}{input to quote}

\item{env}{environment in which unbound symbols in expression should be
evaluated. Defaults to the environment in which \code{as.quoted} was
executed.}
}
\value{
a list of quoted variables
}
\description{
Convert characters, formulas and calls to quoted .variables
}
\details{
This method is called by default on all plyr functions that take a
\code{.variables} argument, so that equivalent forms can be used anywhere.

Currently conversions exist for character vectors, formulas and
call objects.
}
\examples{
as.quoted(c("a", "b", "log(d)"))
as.quoted(a ~ b + log(d))
}
\seealso{
\code{\link[=quoted]{.}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/alply.r
\name{alply}
\alias{alply}
\title{Split array, apply function, and return results in a list.}
\usage{
alply(.data, .margins, .fun = NULL, ..., .expand = TRUE,
  .progress = "none", .inform = FALSE, .parallel = FALSE,
  .paropts = NULL, .dims = FALSE)
}
\arguments{
\item{.data}{matrix, array or data frame to be processed}

\item{.margins}{a vector giving the subscripts to split up \code{data} by.
1 splits up by rows, 2 by columns and c(1,2) by rows and columns, and so
on for higher dimensions}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.expand}{if \code{.data} is a data frame, should output be 1d (expand
 = FALSE), with an element for each row; or nd (expand = TRUE), with a
dimension for each variable.}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}

\item{.dims}{if \code{TRUE}, copy over dimensions and names from input.}
}
\value{
list of results
}
\description{
For each slice of an array, apply function then combine results into a
list.
}
\details{
The list will have "dims" and "dimnames" corresponding to the
margins given. For instance \code{alply(x, c(3,2), ...)} where
\code{x} has dims \code{c(4,3,2)} will give a result with dims
\code{c(2,3)}.

\code{alply} is somewhat similar to \code{\link{apply}} for cases
where the results are not atomic.
}
\section{Input}{
 This function splits matrices, arrays and data frames by
  dimensions
}

\section{Output}{
 If there are no results, then this function will return
  a list of length 0 (\code{list()}).
}
\examples{
alply(ozone, 3, quantile)
alply(ozone, 3, function(x) table(round(x)))
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other array input: \code{\link{a_ply}};
  \code{\link{aaply}}; \code{\link{adply}}

Other list output: \code{\link{dlply}};
  \code{\link{llply}}; \code{\link{mlply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{ozone}
\alias{ozone}
\title{Monthly ozone measurements over Central America.}
\format{A 24 x 24 x 72 numeric array}
\usage{
ozone
}
\description{
This data set is a subset of the data from the 2006 ASA Data expo
challenge, \url{http://stat-computing.org/dataexpo/2006/}. The data are
monthly ozone averages on a very coarse 24 by 24 grid covering Central
America, from Jan 1995 to Dec 2000. The data is stored in a 3d area with
the first two dimensions representing latitude and longitude, and the third
representing time.
}
\examples{
value <- ozone[1, 1, ]
time <- 1:72
month.abbr <- c("Jan", "Feb", "Mar", "Apr", "May",
 "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")
month <- factor(rep(month.abbr, length = 72), levels = month.abbr)
year <- rep(1:6, each = 12)
deseasf <- function(value) lm(value ~ month - 1)

models <- alply(ozone, 1:2, deseasf)
coefs <- laply(models, coef)
dimnames(coefs)[[3]] <- month.abbr
names(dimnames(coefs))[3] <- "month"

deseas <- laply(models, resid)
dimnames(deseas)[[3]] <- 1:72
names(dimnames(deseas))[3] <- "time"

dim(coefs)
dim(deseas)
}
\references{
\url{http://stat-computing.org/dataexpo/2006/}
}
\keyword{datasets}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/data-frame.r
\name{as.data.frame.function}
\alias{as.data.frame.function}
\title{Make a function return a data frame.}
\usage{
\method{as.data.frame}{function}(x, row.names, optional, ...)
}
\arguments{
\item{x}{function to make return a data frame}

\item{row.names}{necessary to match the generic, but not used}

\item{optional}{necessary to match the generic, but not used}

\item{...}{necessary to match the generic, but not used}
}
\description{
Create a new function that returns the existing function wrapped in a
data.frame with a single column, \code{value}.
}
\details{
This is useful when calling \code{*dply} functions with a function that
returns a vector, and you want the output in rows, rather than columns.
The \code{value} column is always created, even for empty inputs.
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/quickdf.r
\name{quickdf}
\alias{quickdf}
\title{Quick data frame.}
\usage{
quickdf(list)
}
\arguments{
\item{list}{list to convert to data frame}
}
\description{
Experimental version of \code{\link{as.data.frame}} that converts a
list to a data frame, but doesn't do any checks to make sure it's a
valid format.  Much faster.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/splitter-d.r
\name{split_labels}
\alias{split_labels}
\title{Generate labels for split data frame.}
\usage{
split_labels(splits, drop, id = plyr::id(splits, drop = TRUE))
}
\arguments{
\item{list}{of variables to split up by}

\item{whether}{all possible combinations should be considered, or only those present in the data}
}
\description{
Create data frame giving labels for split data frame.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/progress.r
\name{create_progress_bar}
\alias{create_progress_bar}
\title{Create progress bar.}
\usage{
create_progress_bar(name = "none", ...)
}
\arguments{
\item{name}{type of progress bar to create}

\item{...}{other arguments passed onto progress bar function}
}
\description{
Create progress bar object from text string.
}
\details{
Progress bars give feedback on how apply step is proceeding.  This
is mainly useful for long running functions, as for short functions, the
time taken up by splitting and combining may be on the same order (or
longer) as the apply step.  Additionally, for short functions, the time
needed to update the progress bar can significantly slow down the process.
For the trivial examples below, using the tk progress bar slows things down
by a factor of a thousand.

Note the that progress bar is approximate, and if the time taken by
individual function applications is highly non-uniform it may not be very
informative of the time left.

There are currently four types of progress bar:  "none", "text", "tk", and
"win".  See the individual documentation for more details.  In plyr
functions, these can either be specified by name, or you can create the
progress bar object yourself if you want more control over its apperance.
See the examples.
}
\examples{
# No progress bar
l_ply(1:100, identity, .progress = "none")
\dontrun{
# Use the Tcl/Tk interface
l_ply(1:100, identity, .progress = "tk")
}
# Text-based progress (|======|)
l_ply(1:100, identity, .progress = "text")
# Choose a progress character, run a length of time you can see
l_ply(1:10000, identity, .progress = progress_text(char = "."))
}
\seealso{
\code{\link{progress_none}}, \code{\link{progress_text}}, \code{\link{progress_tk}}, \code{\link{progress_win}}
}
\keyword{utilities}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/progress.r
\name{progress_text}
\alias{progress_text}
\title{Text progress bar.}
\usage{
progress_text(style = 3, ...)
}
\arguments{
\item{style}{style of text bar, see Details section of \code{\link{txtProgressBar}}}

\item{...}{other arugments passed on to \code{\link{txtProgressBar}}}
}
\description{
A textual progress bar
}
\details{
This progress bar displays a textual progress bar that works on all
platforms.  It is a thin wrapper around the built-in
\code{\link{setTxtProgressBar}} and can be customised in the same way.
}
\examples{
l_ply(1:100, identity, .progress = "text")
l_ply(1:100, identity, .progress = progress_text(char = "-"))
}
\seealso{
Other progress bars: \code{\link{progress_none}};
  \code{\link{progress_time}}; \code{\link{progress_tk}};
  \code{\link{progress_win}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/revalue.r
\name{revalue}
\alias{revalue}
\title{Replace specified values with new values, in a factor or character vector.}
\usage{
revalue(x, replace = NULL, warn_missing = TRUE)
}
\arguments{
\item{x}{factor or character vector to modify}

\item{replace}{named character vector, with new values as values, and
old values as names.}

\item{warn_missing}{print a message if any of the old values are
  not actually present in \code{x}}
}
\description{
If \code{x} is a factor, the named levels of the factor will be
replaced with the new values.
}
\details{
This function works only on character vectors and factors, but the
related \code{mapvalues} function works on vectors of any type and factors,
and instead of a named vector specifying the original and replacement values,
it takes two separate vectors
}
\examples{
x <- c("a", "b", "c")
revalue(x, c(a = "A", c = "C"))
revalue(x, c("a" = "A", "c" = "C"))

y <- factor(c("a", "b", "c", "a"))
revalue(y, c(a = "A", c = "C"))
}
\seealso{
\code{\link{mapvalues}} to replace values with vectors of any type
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/list-to-vector.r
\name{list_to_vector}
\alias{list_to_vector}
\title{List to vector.}
\usage{
list_to_vector(res)
}
\arguments{
\item{res}{list of input data}
}
\description{
Reduce/simplify a list of homogenous objects to a vector
}
\seealso{
Other list simplification functions: \code{\link{list_to_array}};
  \code{\link{list_to_dataframe}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/split.r
\name{as.list.split}
\alias{as.list.split}
\title{Convert split list to regular list.}
\usage{
\method{as.list}{split}(x, ...)
}
\arguments{
\item{x}{object to convert to a list}

\item{...}{unused}
}
\description{
Strip off label related attributed to make a strip list as regular list
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/try.r
\name{tryapply}
\alias{tryapply}
\title{Apply with built in try.
Uses compact, lapply and tryNULL}
\usage{
tryapply(list, fun, ...)
}
\arguments{
\item{list}{list to apply function \code{f} on}

\item{...}{further arguments to \code{f}}

\item{f}{function}
}
\description{
Apply with built in try.
Uses compact, lapply and tryNULL
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/revalue.r
\name{mapvalues}
\alias{mapvalues}
\title{Replace specified values with new values, in a vector or factor.}
\usage{
mapvalues(x, from, to, warn_missing = TRUE)
}
\arguments{
\item{x}{the factor or vector to modify}

\item{from}{a vector of the items to replace}

\item{to}{a vector of replacement values}

\item{warn_missing}{print a message if any of the old values are
  not actually present in \code{x}}
}
\description{
Item in \code{x} that match items \code{from} will be replaced by
items in \code{to}, matched by position. For example, items in \code{x} that
match the first element in \code{from} will be replaced by the first
element of \code{to}.
}
\details{
If \code{x} is a factor, the matching levels of the factor will be
replaced with the new values.

The related \code{revalue} function works only on character vectors
and factors, but this function works on vectors of any type and factors.
}
\examples{
x <- c("a", "b", "c")
mapvalues(x, c("a", "c"), c("A", "C"))

# Works on factors
y <- factor(c("a", "b", "c", "a"))
mapvalues(y, c("a", "c"), c("A", "C"))

# Works on numeric vectors
z <- c(1, 4, 5, 9)
mapvalues(z, from = c(1, 5, 9), to = c(10, 50, 90))
}
\seealso{
\code{\link{revalue}} to do the same thing but with a single
  named vector instead of two separate vectors.
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/loop_apply.R
\name{loop_apply}
\alias{loop_apply}
\title{Loop apply}
\usage{
loop_apply(n, f, env = parent.frame())
}
\arguments{
\item{n}{length of sequence}

\item{f}{function to apply to each integer}

\item{env}{environment in which to evaluate function}
}
\description{
An optimised version of lapply for the special case of operating on
\code{seq_len(n)}
}
\keyword{internal}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/idataframe.r
\name{idata.frame}
\alias{idata.frame}
\title{Construct an immutable data frame.}
\usage{
idata.frame(df)
}
\arguments{
\item{df}{a data frame}
}
\value{
an immutable data frame
}
\description{
An immutable data frame works like an ordinary data frame, except that when
you subset it, it returns a reference to the original data frame, not a
a copy. This makes subsetting substantially faster and has a big impact
when you are working with large datasets with many groups.
}
\details{
This method is still a little experimental, so please let me know if you
run into any problems.
}
\examples{
system.time(dlply(baseball, "id", nrow))
system.time(dlply(idata.frame(baseball), "id", nrow))
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/split.r
\name{[.split}
\alias{[.split}
\title{Subset splits.}
\usage{
\method{[}{split}(x, i, ...)
}
\arguments{
\item{x}{split object}

\item{i}{index}

\item{...}{unused}
}
\description{
Subset splits, ensuring that labels keep matching
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/ldply.r
\name{ldply}
\alias{ldply}
\title{Split list, apply function, and return results in a data frame.}
\usage{
ldply(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
  .parallel = FALSE, .paropts = NULL, .id = NA)
}
\arguments{
\item{.data}{list to be processed}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}

\item{.id}{name of the index column (used if \code{.data} is a named list).
Pass \code{NULL} to avoid creation of the index column. For compatibility,
omit this argument or pass \code{NA} to avoid converting the index column
to a factor; in this case, \code{".id"} is used as colum name.}
}
\value{
A data frame, as described in the output section.
}
\description{
For each element of a list, apply function then combine results into a data
frame.
}
\section{Input}{
 This function splits lists by elements.
}

\section{Output}{

  The most unambiguous behaviour is achieved when \code{.fun} returns a
  data frame - in that case pieces will be combined with
  \code{\link{rbind.fill}}.  If \code{.fun} returns an atomic vector of
  fixed length, it will be \code{rbind}ed together and converted to a data
  frame. Any other values will result in an error.

 If there are no results, then this function will return a data
 frame with zero rows and columns (\code{data.frame()}).
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other data frame output: \code{\link{adply}};
  \code{\link{ddply}}; \code{\link{mdply}}

Other list input: \code{\link{l_ply}}; \code{\link{laply}};
  \code{\link{llply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/liply.r
\name{isplit2}
\alias{isplit2}
\title{Split iterator that returns values, not indices.}
\usage{
isplit2(x, f, drop = FALSE, ...)
}
\description{
Split iterator that returns values, not indices.
}
\section{Warning}{
Deprecated, do not use in new code.
}
\seealso{
\code{\link{plyr-deprecated}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/try.r
\name{try_default}
\alias{tryNULL}
\alias{try_default}
\title{Try, with default in case of error.}
\usage{
try_default(expr, default, quiet = FALSE)

tryNULL(expr)
}
\arguments{
\item{expr}{expression to try}

\item{default}{default value in case of error}

\item{quiet}{should errors be printed (TRUE) or ignored (FALSE, default)}
}
\description{
\code{try_default} wraps try so that it returns a default value in the case of error.
\code{tryNULL} provides a useful special case when dealing with lists.
}
\seealso{
\code{\link{tryapply}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/match-df.r
\name{match_df}
\alias{match_df}
\title{Extract matching rows of a data frame.}
\usage{
match_df(x, y, on = NULL)
}
\arguments{
\item{x}{data frame to subset.}

\item{y}{data frame defining matching rows.}

\item{on}{variables to match on - by default will use all variables common
to both data frames.}
}
\value{
a data frame
}
\description{
Match works in the same way as join, but instead of return the combined
dataset, it only returns the matching rows from the first dataset. This is
particularly useful when you've summarised the data in some way
and want to subset the original data by a characteristic of the subset.
}
\details{
\code{match_df} shares the same semantics as \code{\link{join}}, not
\code{\link{match}}:

\itemize{
  \item the match criterion is \code{==}, not \code{\link{identical}}).
  \item it doesn't work for columns that are not atomic vectors
  \item if there are no matches, the row will be omitted'
}
}
\examples{
# count the occurrences of each id in the baseball dataframe, then get the subset with a freq >25
longterm <- subset(count(baseball, "id"), freq > 25)
# longterm
#             id freq
# 30   ansonca01   27
# 48   baineha01   27
# ...
# Select only rows from these longterm players from the baseball dataframe
# (match would default to match on shared column names, but here was explicitly set "id")
bb_longterm <- match_df(baseball, longterm, on="id")
bb_longterm[1:5,]
}
\seealso{
\code{\link{join}} to combine the columns from both x and y
 and \code{\link{match}} for the base function selecting matching items
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/daply.r
\name{daply}
\alias{daply}
\title{Split data frame, apply function, and return results in an array.}
\usage{
daply(.data, .variables, .fun = NULL, ..., .progress = "none",
  .inform = FALSE, .drop_i = TRUE, .drop_o = TRUE, .parallel = FALSE,
  .paropts = NULL)
}
\arguments{
\item{.data}{data frame to be processed}

\item{.variables}{variables to split data frame by, as quoted
variables, a formula or character vector}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop_i}{should combinations of variables that do not appear in the
input data be preserved (FALSE) or dropped (TRUE, default)}

\item{.drop_o}{should extra dimensions of length 1 in the output be
dropped, simplifying the output.  Defaults to \code{TRUE}}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
if results are atomic with same type and dimensionality, a
  vector, matrix or array; otherwise, a list-array (a list with
  dimensions)
}
\description{
For each subset of data frame, apply function then combine results into
an array.  \code{daply} with a function that operates column-wise is
similar to \code{\link{aggregate}}.
To apply a function for each row, use \code{\link{aaply}} with
\code{.margins} set to \code{1}.
}
\section{Input}{
 This function splits data frames by variables.
}

\section{Output}{

  If there are no results, then this function will return a vector of
  length 0 (\code{vector()}).
}
\examples{
daply(baseball, .(year), nrow)

# Several different ways of summarising by variables that should not be
# included in the summary

daply(baseball[, c(2, 6:9)], .(year), colwise(mean))
daply(baseball[, 6:9], .(baseball$year), colwise(mean))
daply(baseball, .(year), function(df) colwise(mean)(df[, 6:9]))
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other array output: \code{\link{aaply}};
  \code{\link{laply}}; \code{\link{maply}}

Other data frame input: \code{\link{d_ply}};
  \code{\link{ddply}}; \code{\link{dlply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/join.r
\name{join}
\alias{join}
\title{Join two data frames together.}
\usage{
join(x, y, by = NULL, type = "left", match = "all")
}
\arguments{
\item{x}{data frame}

\item{y}{data frame}

\item{by}{character vector of variable names to join by. If omitted, will
match on all common variables.}

\item{type}{type of join: left (default), right, inner or full.  See
details for more information.}

\item{match}{how should duplicate ids be matched? Either match just the
\code{"first"} matching row, or match \code{"all"} matching rows. Defaults
to \code{"all"} for compatibility with merge, but \code{"first"} is
significantly faster.}
}
\description{
Join, like merge, is designed for the types of problems
where you would use a sql join.
}
\details{
The four join types return:

\itemize{
 \item \code{inner}:  only rows with matching keys in both x and y
 \item \code{left}:   all rows in x, adding matching columns from y
 \item \code{right}:  all rows in y, adding matching columns from x
 \item \code{full}:   all rows in x with matching columns in y, then the
   rows of y that don't match x.
}

Note that from plyr 1.5, \code{join} will (by default) return all matches,
not just the first match, as it did previously.

Unlike merge, preserves the order of x no matter what join type is used.
If needed, rows from y will be added to the bottom.  Join is often faster
than merge, although it is somewhat less featureful - it currently offers
no way to rename output or merge on different variables in the x and y
data frames.
}
\examples{
first <- ddply(baseball, "id", summarise, first = min(year))
system.time(b2 <- merge(baseball, first, by = "id", all.x = TRUE))
system.time(b3 <- join(baseball, first, by = "id"))

b2 <- arrange(b2, id, year, stint)
b3 <- arrange(b3, id, year, stint)
stopifnot(all.equal(b2, b3))
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{nunique}
\alias{nunique}
\title{Number of unique values.}
\usage{
nunique(x)
}
\arguments{
\item{x}{vector}
}
\description{
Calculate number of unique values of a variable as efficiently as possible.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/progress-time.r
\name{progress_time}
\alias{progress_time}
\title{Text progress bar with time.}
\usage{
progress_time()
}
\description{
A textual progress bar that estimates time remaining. It displays the
estimated time remaining and, when finished, total duration.
}
\examples{
l_ply(1:100, function(x) Sys.sleep(.01), .progress = "time")
}
\seealso{
Other progress bars: \code{\link{progress_none}};
  \code{\link{progress_text}}; \code{\link{progress_tk}};
  \code{\link{progress_win}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/list-to-array.r
\name{list_to_array}
\alias{list_to_array}
\title{List to array.}
\usage{
list_to_array(res, labels = NULL, .drop = FALSE)
}
\arguments{
\item{res}{list of input data}

\item{labels}{a data frame of labels, one row for each element of res}

\item{.drop}{should extra dimensions be dropped (TRUE) or preserved (FALSE)}
}
\description{
Reduce/simplify a list of homogenous objects to an array
}
\seealso{
Other list simplification functions: \code{\link{list_to_dataframe}};
  \code{\link{list_to_vector}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/rlply.r
\name{rlply}
\alias{rlply}
\title{Replicate expression and return results in a list.}
\usage{
rlply(.n, .expr, .progress = "none")
}
\arguments{
\item{.n}{number of times to evaluate the expression}

\item{.expr}{expression to evaluate}

\item{.progress}{name of the progress bar to use, see \code{\link{create_progress_bar}}}
}
\value{
list of results
}
\description{
Evalulate expression n times then combine results into a list
}
\details{
This function runs an expression multiple times, and combines the
result into a list.  If there are no results, then this function will return
a list of length 0  (\code{list()}). This function is equivalent to
\code{\link{replicate}}, but will always return results as a list.
}
\examples{
mods <- rlply(100, lm(y ~ x, data=data.frame(x=rnorm(100), y=rnorm(100))))
hist(laply(mods, function(x) summary(x)$r.squared))
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy for
  Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{is.formula}
\alias{is.formula}
\title{Is a formula?
Checks if argument is a formula}
\usage{
is.formula(x)
}
\description{
Is a formula?
Checks if argument is a formula
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/name-rows.r
\name{name_rows}
\alias{name_rows}
\title{Toggle row names between explicit and implicit.}
\usage{
name_rows(df)
}
\arguments{
\item{df}{a data.frame, with either \code{rownames}, or a column called
\code{.rownames}.}
}
\description{
Plyr functions ignore row names, so this function provides a way to preserve
them by converting them to an explicit column in the data frame.  After the
plyr operation, you can then apply \code{name_rows} again to convert back
from the explicit column to the implicit \code{rownames}.
}
\examples{
name_rows(mtcars)
name_rows(name_rows(mtcars))

df <- data.frame(a = sample(10))
arrange(df, a)
arrange(name_rows(df), a)
name_rows(arrange(name_rows(df), a))
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{unrowname}
\alias{unrowname}
\title{Un-rowname.}
\usage{
unrowname(x)
}
\arguments{
\item{x}{data frame}
}
\description{
Strip rownames from an object
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/ddply.r
\name{ddply}
\alias{ddply}
\title{Split data frame, apply function, and return results in a data frame.}
\usage{
ddply(.data, .variables, .fun = NULL, ..., .progress = "none",
  .inform = FALSE, .drop = TRUE, .parallel = FALSE, .paropts = NULL)
}
\arguments{
\item{.data}{data frame to be processed}

\item{.variables}{variables to split data frame by, as \code{\link{as.quoted}}
variables, a formula or character vector}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop}{should combinations of variables that do not appear in the
input data be preserved (FALSE) or dropped (TRUE, default)}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
A data frame, as described in the output section.
}
\description{
For each subset of a data frame, apply function then combine results into a
data frame.
To apply a function for each row, use \code{\link{adply}} with
\code{.margins} set to \code{1}.
}
\section{Input}{
 This function splits data frames by variables.
}

\section{Output}{

  The most unambiguous behaviour is achieved when \code{.fun} returns a
  data frame - in that case pieces will be combined with
  \code{\link{rbind.fill}}.  If \code{.fun} returns an atomic vector of
  fixed length, it will be \code{rbind}ed together and converted to a data
  frame. Any other values will result in an error.

 If there are no results, then this function will return a data
 frame with zero rows and columns (\code{data.frame()}).
}
\examples{
# Summarize a dataset by two variables
dfx <- data.frame(
  group = c(rep('A', 8), rep('B', 15), rep('C', 6)),
  sex = sample(c("M", "F"), size = 29, replace = TRUE),
  age = runif(n = 29, min = 18, max = 54)
)

# Note the use of the '.' function to allow
# group and sex to be used without quoting
ddply(dfx, .(group, sex), summarize,
 mean = round(mean(age), 2),
 sd = round(sd(age), 2))

# An example using a formula for .variables
ddply(baseball[1:100,], ~ year, nrow)
# Applying two functions; nrow and ncol
ddply(baseball, .(lg), c("nrow", "ncol"))

# Calculate mean runs batted in for each year
rbi <- ddply(baseball, .(year), summarise,
  mean_rbi = mean(rbi, na.rm = TRUE))
# Plot a line chart of the result
plot(mean_rbi ~ year, type = "l", data = rbi)

# make new variable career_year based on the
# start year for each player (id)
base2 <- ddply(baseball, .(id), mutate,
 career_year = year - min(year) + 1
)
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
\code{\link{tapply}} for similar functionality in the base package

Other data frame input: \code{\link{d_ply}};
  \code{\link{daply}}; \code{\link{dlply}}

Other data frame output: \code{\link{adply}};
  \code{\link{ldply}}; \code{\link{mdply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{compact}
\alias{compact}
\title{Compact list.}
\usage{
compact(l)
}
\arguments{
\item{l}{list}
}
\description{
Remove all NULL entries from a list
}
\keyword{internal}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/raply.r
\name{raply}
\alias{raply}
\title{Replicate expression and return results in a array.}
\usage{
raply(.n, .expr, .progress = "none", .drop = TRUE)
}
\arguments{
\item{.n}{number of times to evaluate the expression}

\item{.expr}{expression to evaluate}

\item{.progress}{name of the progress bar to use, see \code{\link{create_progress_bar}}}

\item{.drop}{should extra dimensions of length 1 be dropped, simplifying the output.  Defaults to \code{TRUE}}
}
\value{
if results are atomic with same type and dimensionality, a vector, matrix or array; otherwise, a list-array (a list with dimensions)
}
\description{
Evalulate expression n times then combine results into an array
}
\details{
This function runs an expression multiple times, and combines the
result into a data frame.  If there are no results, then this function
returns a vector of length 0 (\code{vector(0)}).
This function is equivalent to \code{\link{replicate}}, but will always
return results as a vector, matrix or array.
}
\examples{
raply(100, mean(runif(100)))
raply(100, each(mean, var)(runif(100)))

raply(10, runif(4))
raply(10, matrix(runif(4), nrow=2))

# See the central limit theorem in action
hist(raply(1000, mean(rexp(10))))
hist(raply(1000, mean(rexp(100))))
hist(raply(1000, mean(rexp(1000))))
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy for
  Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/id.r
\name{id_var}
\alias{id_var}
\title{Numeric id for a vector.}
\usage{
id_var(x, drop = FALSE)
}
\description{
Numeric id for a vector.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/id.r
\name{id}
\alias{id}
\alias{ninteraction}
\title{Compute a unique numeric id for each unique row in a data frame.}
\usage{
id(.variables, drop = FALSE)
}
\arguments{
\item{.variables}{list of variables}

\item{drop}{drop unusued factor levels?}
}
\value{
a numeric vector with attribute n, giving total number of
  possibilities
}
\description{
Properties:
\itemize{
  \item \code{order(id)} is equivalent to \code{do.call(order, df)}
  \item rows containing the same data have the same value
  \item if \code{drop = FALSE} then room for all possibilites
}
}
\seealso{
\code{\link{id_var}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/progress.r
\name{progress_none}
\alias{progress_none}
\title{Null progress bar}
\usage{
progress_none()
}
\description{
A progress bar that does nothing
}
\details{
This the default progress bar used by plyr functions.  It's very simple to
understand - it does nothing!
}
\examples{
l_ply(1:100, identity, .progress = "none")
}
\seealso{
Other progress bars: \code{\link{progress_text}};
  \code{\link{progress_time}}; \code{\link{progress_tk}};
  \code{\link{progress_win}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/maply.r
\name{maply}
\alias{maply}
\title{Call function with arguments in array or data frame, returning an array.}
\usage{
maply(.data, .fun = NULL, ..., .expand = TRUE, .progress = "none",
  .inform = FALSE, .drop = TRUE, .parallel = FALSE, .paropts = NULL)
}
\arguments{
\item{.data}{matrix or data frame to use as source of arguments}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.expand}{should output be 1d (expand = FALSE), with an element for
each row; or nd (expand = TRUE), with a dimension for each variable.}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop}{should extra dimensions of length 1 in the output be
dropped, simplifying the output.  Defaults to \code{TRUE}}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
if results are atomic with same type and dimensionality, a
  vector, matrix or array; otherwise, a list-array (a list with
  dimensions)
}
\description{
Call a multi-argument function with values taken from columns of an
data frame or array, and combine results into an array
}
\details{
The \code{m*ply} functions are the \code{plyr} version of \code{mapply},
specialised according to the type of output they produce.  These functions
are just a convenient wrapper around \code{a*ply} with \code{margins = 1}
and \code{.fun} wrapped in \code{\link{splat}}.
}
\section{Input}{
 Call a multi-argument function with values taken from
  columns of an data frame or array
}

\section{Output}{

  If there are no results, then this function will return a vector of
  length 0 (\code{vector()}).
}
\examples{
maply(cbind(mean = 1:5, sd = 1:5), rnorm, n = 5)
maply(expand.grid(mean = 1:5, sd = 1:5), rnorm, n = 5)
maply(cbind(1:5, 1:5), rnorm, n = 5)
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other array output: \code{\link{aaply}};
  \code{\link{daply}}; \code{\link{laply}}

Other multiple arguments input: \code{\link{m_ply}};
  \code{\link{mdply}}; \code{\link{mlply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/laply.r
\name{laply}
\alias{laply}
\title{Split list, apply function, and return results in an array.}
\usage{
laply(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
  .drop = TRUE, .parallel = FALSE, .paropts = NULL)
}
\arguments{
\item{.data}{list to be processed}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop}{should extra dimensions of length 1 in the output be
dropped, simplifying the output.  Defaults to \code{TRUE}}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
if results are atomic with same type and dimensionality, a
  vector, matrix or array; otherwise, a list-array (a list with
  dimensions)
}
\description{
For each element of a list, apply function then combine results into an
array.
}
\details{
\code{laply} is similar in spirit to \code{\link{sapply}} except
that it will always return an array, and the output is transposed with
respect \code{sapply} - each element of the list corresponds to a row,
not a column.
}
\section{Input}{
 This function splits lists by elements.
}

\section{Output}{

  If there are no results, then this function will return a vector of
  length 0 (\code{vector()}).
}
\examples{
laply(baseball, is.factor)
# cf
ldply(baseball, is.factor)
colwise(is.factor)(baseball)

laply(seq_len(10), identity)
laply(seq_len(10), rep, times = 4)
laply(seq_len(10), matrix, nrow = 2, ncol = 2)
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other array output: \code{\link{aaply}};
  \code{\link{daply}}; \code{\link{maply}}

Other list input: \code{\link{l_ply}}; \code{\link{ldply}};
  \code{\link{llply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/join-all.r
\name{join_all}
\alias{join_all}
\title{Recursively join a list of data frames.}
\usage{
join_all(dfs, by = NULL, type = "left", match = "all")
}
\arguments{
\item{dfs}{A list of data frames.}

\item{by}{character vector of variable names to join by. If omitted, will
match on all common variables.}

\item{type}{type of join: left (default), right, inner or full.  See
details for more information.}

\item{match}{how should duplicate ids be matched? Either match just the
\code{"first"} matching row, or match \code{"all"} matching rows. Defaults
to \code{"all"} for compatibility with merge, but \code{"first"} is
significantly faster.}
}
\description{
Recursively join a list of data frames.
}
\examples{
dfs <- list(
  a = data.frame(x = 1:10, a = runif(10)),
  b = data.frame(x = 1:10, b = runif(10)),
  c = data.frame(x = 1:10, c = runif(10))
)
join_all(dfs)
join_all(dfs, "x")
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/take.r
\name{take}
\alias{take}
\title{Take a subset along an arbitrary dimension}
\usage{
take(x, along, indices, drop = FALSE)
}
\arguments{
\item{x}{matrix or array to subset}

\item{along}{dimension to subset along}

\item{indices}{the indices to select}

\item{drop}{should the dimensions of the array be simplified? Defaults
to \code{FALSE} which is the opposite of the useful R default.}
}
\description{
Take a subset along an arbitrary dimension
}
\examples{
x <- array(seq_len(3 * 4 * 5), c(3, 4, 5))
take(x, 3, 1)
take(x, 2, 1)
take(x, 1, 1)
take(x, 3, 1, drop = TRUE)
take(x, 2, 1, drop = TRUE)
take(x, 1, 1, drop = TRUE)
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/arrange.r
\name{desc}
\alias{desc}
\title{Descending order.}
\usage{
desc(x)
}
\arguments{
\item{x}{vector to transform}
}
\description{
Transform a vector into a format that will be sorted in descending order.
}
\examples{
desc(1:10)
desc(factor(letters))
first_day <- seq(as.Date("1910/1/1"), as.Date("1920/1/1"), "years")
desc(first_day)
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{true}
\alias{true}
\title{Function that always returns true.}
\usage{
true(...)
}
\arguments{
\item{...}{all input ignored}
}
\value{
\code{TRUE}
}
\description{
Function that always returns true.
}
\seealso{
\code{\link{colwise}} which uses it
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/quote.r
\name{eval.quoted}
\alias{eval.quoted}
\title{Evaluate a quoted list of variables.}
\usage{
eval.quoted(exprs, envir = NULL, enclos = NULL, try = FALSE)
}
\arguments{
\item{try}{if TRUE, return \code{NULL} if evaluation unsuccesful}

\item{expr}{quoted object to evalution}
}
\value{
a list
}
\description{
Evaluates quoted variables in specified environment
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/splitter-a.r
\name{splitter_a}
\alias{splitter_a}
\title{Split an array by .margins.}
\usage{
splitter_a(data, .margins = 1L, .expand = TRUE, .id = NA)
}
\arguments{
\item{data}{>1d data structure (matrix, data.frame or array)}

\item{.margins}{a vector giving the subscripts to split up \code{data} by.}

\item{.expand}{if splitting a dataframe by row, should output be 1d
(expand = FALSE), with an element for each row; or nd (expand = TRUE),
with a dimension for each variable.}

\item{.id}{names of the split label.
Pass \code{NULL} to avoid creation of split labels.
Omit or pass \code{NA} to use the default names
\code{"X1"}, \code{"X2"}, \ldots.
Otherwise, this argument must have the same length as
\code{.margins}.}
}
\value{
a list of lower-d slices, with attributes that record split details
}
\description{
Split a 2d or higher data structure into lower-d pieces based
}
\details{
This is the workhorse of the \code{a*ply} functions.  Given a >1 d
data structure (matrix, array, data.frame), it splits it into pieces
based on the subscripts that you supply.  Each piece is a lower dimensional
slice.

The margins are specified in the same way as \code{\link{apply}}, but
\code{splitter_a} just splits up the data, while \code{apply} also
applies a function and combines the pieces back together.  This function
also includes enough information to recreate the split from attributes on
the list of pieces.
}
\examples{
plyr:::splitter_a(mtcars, 1)
plyr:::splitter_a(mtcars, 2)

plyr:::splitter_a(ozone, 2)
plyr:::splitter_a(ozone, 3)
plyr:::splitter_a(ozone, 1:2)
}
\seealso{
Other splitter functions: \code{\link{splitter_d}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/indexed-array.r
\name{indexed_array}
\alias{[[.indexed_array}
\alias{indexed_array}
\alias{length.indexed_array}
\alias{names.indexed_array}
\title{An indexed array.}
\usage{
indexed_array(env, index)
}
\arguments{
\item{env}{environment containing data frame}

\item{index}{list of indices}
}
\description{
Create a indexed array, a space efficient way of indexing into a large
array.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/rbind-fill-matrix.r
\name{rbind.fill.matrix}
\alias{rbind.fill.matrix}
\title{Bind matrices by row, and fill missing columns with NA.}
\usage{
rbind.fill.matrix(...)
}
\arguments{
\item{...}{the matrices to rbind. The first argument can be a list of
matrices, in which case all other arguments are ignored.}
}
\value{
a matrix with column names
}
\description{
The matrices are bound together using their column names or the column
indices (in that order of precedence.) Numeric columns may be converted to
character beforehand, e.g. using format.  If a matrix doesn't have
colnames, the column number is used. Note that this means that a
column with name \code{"1"} is merged with the first column of a matrix
without name and so on. The returned matrix will always have column names.
}
\details{
Vectors are converted to 1-column matrices.

Matrices of factors are not supported. (They are anyways quite
inconvenient.) You may convert them first to either numeric or character
matrices. If a matrices of different types are merged, then normal
covnersion precendence will apply.

Row names are ignored.
}
\examples{
A <- matrix (1:4, 2)
B <- matrix (6:11, 2)
A
B
rbind.fill.matrix (A, B)

colnames (A) <- c (3, 1)
A
rbind.fill.matrix (A, B)

rbind.fill.matrix (A, 99)
}
\author{
C. Beleites
}
\seealso{
\code{\link[base]{rbind}}, \code{\link[base]{cbind}},
   \code{\link[plyr]{rbind.fill}}

Other binding functions: \code{\link{rbind.fill}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/dimensions.r
\name{dims}
\alias{dims}
\title{Number of dimensions.}
\usage{
dims(x)
}
\arguments{
\item{x}{array}
}
\description{
Number of dimensions of an array or vector
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{is.discrete}
\alias{is.discrete}
\title{Determine if a vector is discrete.}
\usage{
is.discrete(x)
}
\arguments{
\item{x}{vector to test}
}
\description{
A discrete vector is a factor or a character vector
}
\examples{
is.discrete(1:10)
is.discrete(c("a", "b", "c"))
is.discrete(factor(c("a", "b", "c")))
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/list-to-dataframe.r
\name{list_to_dataframe}
\alias{list_to_dataframe}
\title{List to data frame.}
\usage{
list_to_dataframe(res, labels = NULL, id_name = NULL,
  id_as_factor = FALSE)
}
\arguments{
\item{res}{list of input data}

\item{labels}{a data frame of labels, one row for each element of res}

\item{idname}{the name of the index column, \code{NULL} for no index
column}
}
\description{
Reduce/simplify a list of homogenous objects to a data frame. All
\code{NULL} entries are removed. Remaining entries must be all atomic
or all data frames.
}
\seealso{
Other list simplification functions: \code{\link{list_to_array}};
  \code{\link{list_to_vector}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/arrange.r
\name{arrange}
\alias{arrange}
\title{Order a data frame by its colums.}
\usage{
arrange(df, ...)
}
\arguments{
\item{df}{data frame to reorder}

\item{...}{expressions evaluated in the context of \code{df} and then fed
to \code{\link{order}}}
}
\description{
This function completes the subsetting, transforming and ordering triad
with a function that works in a similar way to \code{\link{subset}} and
\code{\link{transform}} but for reordering a data frame by its columns.
This saves a lot of typing!
}
\examples{
# sort mtcars data by cylinder and displacement
mtcars[with(mtcars, order(cyl, disp)), ]
# Same result using arrange: no need to use with(), as the context is implicit
# NOTE: plyr functions do NOT preserve row.names
arrange(mtcars, cyl, disp)
# Let's keep the row.names in this example
myCars = cbind(vehicle=row.names(mtcars), mtcars)
arrange(myCars, cyl, disp)
# Sort with displacement in descending order
arrange(myCars, cyl, desc(disp))
}
\seealso{
\code{\link{order}} for sorting function in the base package
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/splat.r
\name{splat}
\alias{splat}
\title{`Splat' arguments to a function.}
\usage{
splat(flat)
}
\arguments{
\item{flat}{function to splat}
}
\value{
a function
}
\description{
Wraps a function in do.call, so instead of taking multiple arguments, it
takes a single named list which will be interpreted as its arguments.
}
\details{
This is useful when you want to pass a function a row of data frame or
array, and don't want to manually pull it apart in your function.
}
\examples{
hp_per_cyl <- function(hp, cyl, ...) hp / cyl
splat(hp_per_cyl)(mtcars[1,])
splat(hp_per_cyl)(mtcars)

f <- function(mpg, wt, ...) data.frame(mw = mpg / wt)
ddply(mtcars, .(cyl), splat(f))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{baseball}
\alias{baseball}
\title{Yearly batting records for all major league baseball players}
\format{A 21699 x 22 data frame}
\usage{
baseball
}
\description{
This data frame contains batting statistics for a subset of players
collected from \url{http://www.baseball-databank.org/}. There are a total
of 21,699 records, covering 1,228 players from 1871 to 2007. Only players
with more 15 seasons of play are included.
}
\section{Variables}{

Variables:
\itemize{
 \item id, unique player id
 \item year, year of data
 \item stint
 \item team, team played for
 \item lg, league
 \item g, number of games
 \item ab, number of times at bat
 \item r, number of runs
 \item h, hits, times reached base because of a batted, fair ball without
     error by the defense
 \item X2b, hits on which the batter reached second base safely
 \item X3b, hits on which the batter reached third base safely
 \item hr, number of home runs
 \item rbi, runs batted in
 \item sb, stolen bases
 \item cs, caught stealing
 \item bb, base on balls (walk)
 \item so, strike outs
 \item ibb, intentional base on balls
 \item hbp, hits by pitch
 \item sh, sacrifice hits
 \item sf, sacrifice flies
 \item gidp, ground into double play
}
}
\examples{
baberuth <- subset(baseball, id == "ruthba01")
baberuth$cyear <- baberuth$year - min(baberuth$year) + 1

calculate_cyear <- function(df) {
  mutate(df,
    cyear = year - min(year),
    cpercent = cyear / (max(year) - min(year))
  )
}

baseball <- ddply(baseball, .(id), calculate_cyear)
baseball <- subset(baseball, ab >= 25)

model <- function(df) {
  lm(rbi / ab ~ cyear, data=df)
}
model(baberuth)
models <- dlply(baseball, .(id), model)
}
\references{
\url{http://www.baseball-databank.org/}
}
\keyword{datasets}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/progress.r
\name{progress_tk}
\alias{progress_tk}
\title{Graphical progress bar, powered by Tk.}
\usage{
progress_tk(title = "plyr progress", label = "Working...", ...)
}
\arguments{
\item{title}{window title}

\item{label}{progress bar label (inside window)}

\item{...}{other arguments passed on to \code{\link[tcltk]{tkProgressBar}}}
}
\description{
A graphical progress bar displayed in a Tk window
}
\details{
This graphical progress will appear in a separate window.
}
\examples{
\dontrun{
l_ply(1:100, identity, .progress = "tk")
l_ply(1:100, identity, .progress = progress_tk(width=400))
l_ply(1:100, identity, .progress = progress_tk(label=""))
}
}
\seealso{
\code{\link[tcltk]{tkProgressBar}} for the function that powers this progress bar

Other progress bars: \code{\link{progress_none}};
  \code{\link{progress_text}}; \code{\link{progress_time}};
  \code{\link{progress_win}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/dimensions.r
\name{amv_dimnames}
\alias{amv_dimnames}
\title{Dimension names.}
\usage{
amv_dimnames(x)
}
\arguments{
\item{x}{array, matrix or vector}
}
\description{
Consistent dimnames for vectors, matrices and arrays.
}
\details{
Unlike \code{\link{dimnames}} no part of the output will ever be
null.  If a component of dimnames is omitted, \code{amv_dimnames}
will return an integer sequence of the appropriate length.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/mutate.r
\name{mutate}
\alias{mutate}
\title{Mutate a data frame by adding new or replacing existing columns.}
\usage{
mutate(.data, ...)
}
\arguments{
\item{.data}{the data frame to transform}

\item{...}{named parameters giving definitions of new columns.}
}
\description{
This function is very similar to \code{\link{transform}} but it executes
the transformations iteratively so that later transformations can use the
columns created by earlier transformations.  Like transform, unnamed
components are silently dropped.
}
\details{
Mutate seems to be considerably faster than transform for large data
frames.
}
\examples{
# Examples from transform
mutate(airquality, Ozone = -Ozone)
mutate(airquality, new = -Ozone, Temp = (Temp - 32) / 1.8)

# Things transform can't do
mutate(airquality, Temp = (Temp - 32) / 1.8, OzT = Ozone / Temp)

# mutate is rather faster than transform
system.time(transform(baseball, avg_ab = ab / g))
system.time(mutate(baseball, avg_ab = ab / g))
}
\seealso{
\code{\link{subset}}, \code{\link{summarise}},
  \code{\link{arrange}}.  For another somewhat different approach to
  solving the same problem, see \code{\link{within}}.
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/aaply.r
\name{aaply}
\alias{aaply}
\title{Split array, apply function, and return results in an array.}
\usage{
aaply(.data, .margins, .fun = NULL, ..., .expand = TRUE,
  .progress = "none", .inform = FALSE, .drop = TRUE, .parallel = FALSE,
  .paropts = NULL)
}
\arguments{
\item{.data}{matrix, array or data frame to be processed}

\item{.margins}{a vector giving the subscripts to split up \code{data} by.
1 splits up by rows, 2 by columns and c(1,2) by rows and columns, and so
on for higher dimensions}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.expand}{if \code{.data} is a data frame, should output be 1d (expand
 = FALSE), with an element for each row; or nd (expand = TRUE), with a
dimension for each variable.}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop}{should extra dimensions of length 1 in the output be
dropped, simplifying the output.  Defaults to \code{TRUE}}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
if results are atomic with same type and dimensionality, a
  vector, matrix or array; otherwise, a list-array (a list with
  dimensions)
}
\description{
For each slice of an array, apply function, keeping results as an array.
}
\details{
This function is very similar to \code{\link{apply}}, except that it will
always return an array, and when the function returns >1 d data structures,
those dimensions are added on to the highest dimensions, rather than the
lowest dimensions.  This makes \code{aaply} idempotent, so that
\code{aaply(input, X, identity)} is equivalent to \code{aperm(input, X)}.
}
\section{Warning}{
Passing a data frame as first argument may lead to
unexpected results, see \url{https://github.com/hadley/plyr/issues/212}.
}

\section{Input}{
 This function splits matrices, arrays and data frames by
  dimensions
}

\section{Output}{

  If there are no results, then this function will return a vector of
  length 0 (\code{vector()}).
}
\examples{
dim(ozone)
aaply(ozone, 1, mean)
aaply(ozone, 1, mean, .drop = FALSE)
aaply(ozone, 3, mean)
aaply(ozone, c(1,2), mean)

dim(aaply(ozone, c(1,2), mean))
dim(aaply(ozone, c(1,2), mean, .drop = FALSE))

aaply(ozone, 1, each(min, max))
aaply(ozone, 3, each(min, max))

standardise <- function(x) (x - min(x)) / (max(x) - min(x))
aaply(ozone, 3, standardise)
aaply(ozone, 1:2, standardise)

aaply(ozone, 1:2, diff)
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other array input: \code{\link{a_ply}};
  \code{\link{adply}}; \code{\link{alply}}

Other array output: \code{\link{daply}};
  \code{\link{laply}}; \code{\link{maply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/dimensions.r
\name{amv_dim}
\alias{amv_dim}
\title{Dimensions.}
\usage{
amv_dim(x)
}
\arguments{
\item{x}{array, matrix or vector}
}
\description{
Consistent dimensions for vectors, matrices and arrays.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/defaults.r
\name{defaults}
\alias{defaults}
\title{Set defaults.}
\usage{
defaults(x, y)
}
\arguments{
\item{x}{list of values}

\item{y}{defaults}
}
\description{
Convient method for combining a list of values with their defaults.
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/try.r
\name{failwith}
\alias{failwith}
\title{Fail with specified value.}
\usage{
failwith(default = NULL, f, quiet = FALSE)
}
\arguments{
\item{default}{default value}

\item{f}{function}

\item{quiet}{all error messages be suppressed?}
}
\value{
a function
}
\description{
Modify a function so that it returns a default value when there is an
error.
}
\examples{
f <- function(x) if (x == 1) stop("Error!") else 1
\dontrun{
f(1)
f(2)
}

safef <- failwith(NULL, f)
safef(1)
safef(2)
}
\seealso{
\code{\link{try_default}}
}
\keyword{debugging}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/liply.r
\name{liply}
\alias{liply}
\title{Experimental iterator based version of llply.}
\usage{
liply(.iterator, .fun = NULL, ...)
}
\arguments{
\item{.iterator}{iterator object}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}
}
\description{
Because iterators do not have known length, \code{liply} starts by
allocating an output list of length 50, and then doubles that length
whenever it runs out of space.  This gives O(n ln n) performance rather
than the O(n ^ 2) performance from the naive strategy of growing the list
each time.
}
\section{Warning}{
Deprecated, do not use in new code.
}
\seealso{
\code{\link{plyr-deprecated}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{split_indices}
\alias{split_indices}
\title{Split indices.}
\usage{
split_indices(group, n = 0L)
}
\arguments{
\item{n}{largest integer (may not appear in index). This is hint: if
the largest value of \code{group} is bigger than \code{n}, the output
will silently expand.}

\item{index}{integer indices}
}
\description{
An optimised version of split for the special case of splitting row
indices into groups, as used by \code{\link{splitter_d}}.
}
\examples{
split_indices(sample(10, 100, rep = TRUE))
split_indices(sample(10, 100, rep = TRUE), 10)
}
\keyword{internal}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/r_ply.r
\name{r_ply}
\alias{r_ply}
\title{Replicate expression and discard results.}
\usage{
r_ply(.n, .expr, .progress = "none", .print = FALSE)
}
\arguments{
\item{.n}{number of times to evaluate the expression}

\item{.expr}{expression to evaluate}

\item{.progress}{name of the progress bar to use, see \code{\link{create_progress_bar}}}

\item{.print}{automatically print each result? (default: \code{FALSE})}
}
\description{
Evalulate expression n times then discard results
}
\details{
This function runs an expression multiple times, discarding the results.
This function is equivalent to \code{\link{replicate}}, but never returns
anything
}
\examples{
r_ply(10, plot(runif(50)))
r_ply(25, hist(runif(1000)))
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy for
  Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/here.r
\name{here}
\alias{here}
\title{Capture current evaluation context.}
\usage{
here(f)
}
\arguments{
\item{f}{a function that does non-standard evaluation}
}
\description{
This function captures the current context, making it easier
to use \code{**ply} with functions that do special evaluation and
need access to the environment where ddply was called from.
}
\examples{
df <- data.frame(a = rep(c("a","b"), each = 10), b = 1:20)
f1 <- function(label) {
   ddply(df, "a", mutate, label = paste(label, b))
}
\dontrun{f1("name:")}
# Doesn't work because mutate can't find label in the current scope

f2 <- function(label) {
   ddply(df, "a", here(mutate), label = paste(label, b))
}
f2("name:")
# Works :)
}
\author{
Peter Meilstrup, \url{https://github.com/crowding}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/plyr-deprecated.r
\name{plyr-deprecated}
\alias{plyr-deprecated}
\title{Deprecated Functions in Package plyr}
\description{
These functions are provided for compatibility with older versions of
\code{plyr} only, and may be defunct as soon as the next release.
}
\details{
\itemize{
  \item \code{\link{liply}}
  \item \code{\link{isplit2}}
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/dlply.r
\name{dlply}
\alias{dlply}
\title{Split data frame, apply function, and return results in a list.}
\usage{
dlply(.data, .variables, .fun = NULL, ..., .progress = "none",
  .inform = FALSE, .drop = TRUE, .parallel = FALSE, .paropts = NULL)
}
\arguments{
\item{.data}{data frame to be processed}

\item{.variables}{variables to split data frame by, as \code{\link{as.quoted}}
variables, a formula or character vector}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop}{should combinations of variables that do not appear in the
input data be preserved (FALSE) or dropped (TRUE, default)}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
list of results
}
\description{
For each subset of a data frame, apply function then combine results into a
list. \code{dlply} is similar to \code{\link{by}} except that the results
are returned in a different format.
To apply a function for each row, use \code{\link{alply}} with
\code{.margins} set to \code{1}.
}
\section{Input}{
 This function splits data frames by variables.
}

\section{Output}{
 If there are no results, then this function will return
  a list of length 0 (\code{list()}).
}
\examples{
linmod <- function(df) {
  lm(rbi ~ year, data = mutate(df, year = year - min(year)))
}
models <- dlply(baseball, .(id), linmod)
models[[1]]

coef <- ldply(models, coef)
with(coef, plot(`(Intercept)`, year))
qual <- laply(models, function(mod) summary(mod)$r.squared)
hist(qual)
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other data frame input: \code{\link{d_ply}};
  \code{\link{daply}}; \code{\link{ddply}}

Other list output: \code{\link{alply}};
  \code{\link{llply}}; \code{\link{mlply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/plyr.r
\docType{package}
\name{plyr}
\alias{plyr}
\alias{plyr-package}
\title{plyr: the split-apply-combine paradigm for R.}
\description{
The plyr package is a set of clean and consistent tools that implement the
split-apply-combine pattern in R. This is an extremely common pattern in
data analysis: you solve a complex problem by breaking it down into small
pieces, doing something to each piece and then combining the results back
together again.
}
\details{
The plyr functions are named according to what sort of data structure they
split up and what sort of data structure they return:

\describe{
  \item{a}{array}
  \item{l}{list}
  \item{d}{data.frame}
  \item{m}{multiple inputs}
  \item{r}{repeat multiple times}
  \item{_}{nothing}
}

So \code{\link{ddply}} takes a data frame as input and returns a data frame
as output, and \code{\link{l_ply}} takes a list as input and returns nothing
as output.
}
\section{Row names}{


By design, no plyr function will preserve row names - in general it is too
hard to know what should be done with them for many of the operations
supported by plyr. If you want to preserve row names, use
\code{\link{name_rows}} to convert them into an explicit column in your
data frame, perform the plyr operations, and then use \code{\link{name_rows}}
again to convert the column back into row names.
}

\section{Helpers}{


Plyr also provides a set of helper functions for common data analysis
problems:

\itemize{
  \item \code{\link{arrange}}: re-order the rows of a data frame by
    specifying the columns to order by
  \item \code{\link{mutate}}: add new columns or modifying existing columns,
    like \code{\link{transform}}, but new columns can refer to other columns
    that you just created.
  \item \code{\link{summarise}}: like \code{\link{mutate}} but create a
    new data frame, not preserving any columns in the old data frame.

  \item \code{\link{join}}: an adapation of \code{\link{merge}} which is
    more similar to SQL, and has a much faster implementation if you only
    want to find the first match.
  \item \code{\link{match_df}}: a version of \code{\link{join}} that instead
    of returning the two tables combined together, only returns the rows
    in the first table that match the second.

  \item \code{\link{colwise}}: make any function work colwise on a dataframe
  \item \code{\link{rename}}: easily rename columns in a data frame
  \item \code{\link{round_any}}: round a number to any degree of precision
  \item \code{\link{count}}: quickly count unique combinations and return
    return as a data frame.
}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/splitter-d.r
\name{splitter_d}
\alias{splitter_d}
\title{Split a data frame by variables.}
\usage{
splitter_d(data, .variables = NULL, drop = TRUE)
}
\arguments{
\item{data}{data frame}

\item{.variables}{a \link{quoted} list of variables}

\item{drop}{drop unnused factor levels?}
}
\value{
a list of data.frames, with attributes that record split details
}
\description{
Split a data frame into pieces based on variable contained in that data frame
}
\details{
This is the workhorse of the \code{d*ply} functions.  Based on the variables
you supply, it breaks up a single data frame into a list of data frames,
each containing a single combination from the levels of the specified
variables.

This is basically a thin wrapper around \code{\link{split}} which
evaluates the variables in the context of the data, and includes enough
information to reconstruct the labelling of the data frame after
other operations.
}
\examples{
plyr:::splitter_d(mtcars, .(cyl))
plyr:::splitter_d(mtcars, .(vs, am))
plyr:::splitter_d(mtcars, .(am, vs))

mtcars$cyl2 <- factor(mtcars$cyl, levels = c(2, 4, 6, 8, 10))
plyr:::splitter_d(mtcars, .(cyl2), drop = TRUE)
plyr:::splitter_d(mtcars, .(cyl2), drop = FALSE)

mtcars$cyl3 <- ifelse(mtcars$vs == 1, NA, mtcars$cyl)
plyr:::splitter_d(mtcars, .(cyl3))
plyr:::splitter_d(mtcars, .(cyl3, vs))
plyr:::splitter_d(mtcars, .(cyl3, vs), drop = FALSE)
}
\seealso{
\code{\link{.}} for quoting variables, \code{\link{split}}

Other splitter functions: \code{\link{splitter_a}}
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/summarise.r
\name{summarise}
\alias{summarise}
\alias{summarize}
\title{Summarise a data frame.}
\usage{
summarise(.data, ...)
}
\arguments{
\item{.data}{the data frame to be summarised}

\item{...}{further arguments of the form var = value}
}
\description{
Summarise works in an analogous way to \code{\link{mutate}}, except
instead of adding columns to an existing data frame, it creates a new
data frame.  This is particularly useful in conjunction with
\code{\link{ddply}} as it makes it easy to perform group-wise summaries.
}
\note{
Be careful when using existing variable names; the corresponding
columns will be immediately updated with the new data and this can affect
subsequent operations referring to those variables.
}
\examples{
# Let's extract the number of teams and total period of time
# covered by the baseball dataframe
summarise(baseball,
 duration = max(year) - min(year),
 nteams = length(unique(team)))
# Combine with ddply to do that for each separate id
ddply(baseball, "id", summarise,
 duration = max(year) - min(year),
 nteams = length(unique(team)))
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/colwise.r
\name{colwise}
\alias{catcolwise}
\alias{colwise}
\alias{numcolwise}
\title{Column-wise function.}
\usage{
colwise(.fun, .cols = true, ...)

catcolwise(.fun, ...)

numcolwise(.fun, ...)
}
\arguments{
\item{.fun}{function}

\item{.cols}{either a function that tests columns for inclusion, or a
quoted object giving which columns to process}

\item{...}{other arguments passed on to \code{.fun}}
}
\description{
Turn a function that operates on a vector into a function that operates
column-wise on a data.frame.
}
\details{
\code{catcolwise} and \code{numcolwise} provide version that only operate
on discrete and numeric variables respectively.
}
\examples{
# Count number of missing values
nmissing <- function(x) sum(is.na(x))

# Apply to every column in a data frame
colwise(nmissing)(baseball)
# This syntax looks a little different.  It is shorthand for the
# the following:
f <- colwise(nmissing)
f(baseball)

# This is particularly useful in conjunction with d*ply
ddply(baseball, .(year), colwise(nmissing))

# To operate only on specified columns, supply them as the second
# argument.  Many different forms are accepted.
ddply(baseball, .(year), colwise(nmissing, .(sb, cs, so)))
ddply(baseball, .(year), colwise(nmissing, c("sb", "cs", "so")))
ddply(baseball, .(year), colwise(nmissing, ~ sb + cs + so))

# Alternatively, you can specify a boolean function that determines
# whether or not a column should be included
ddply(baseball, .(year), colwise(nmissing, is.character))
ddply(baseball, .(year), colwise(nmissing, is.numeric))
ddply(baseball, .(year), colwise(nmissing, is.discrete))

# These last two cases are particularly common, so some shortcuts are
# provided:
ddply(baseball, .(year), numcolwise(nmissing))
ddply(baseball, .(year), catcolwise(nmissing))

# You can supply additional arguments to either colwise, or the function
# it generates:
numcolwise(mean)(baseball, na.rm = TRUE)
numcolwise(mean, na.rm = TRUE)(baseball)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/each.r
\name{each}
\alias{each}
\title{Aggregate multiple functions into a single function.}
\usage{
each(...)
}
\arguments{
\item{...}{functions to combine. each function should produce a single
number as output}
}
\description{
Combine multiple functions into a single function returning a named vector
of outputs.
Note: you cannot supply additional parameters for the summary functions
}
\examples{
# Call min() and max() on the vector 1:10
each(min, max)(1:10)
# This syntax looks a little different.  It is shorthand for the
# the following:
f<- each(min, max)
f(1:10)
# Three equivalent ways to call min() and max() on the vector 1:10
each("min", "max")(1:10)
each(c("min", "max"))(1:10)
each(c(min, max))(1:10)
# Call length(), min() and max() on a random normal vector
each(length, mean, var)(rnorm(100))
}
\seealso{
\code{\link{summarise}} for applying summary functions to data
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/llply.r
\name{llply}
\alias{llply}
\title{Split list, apply function, and return results in a list.}
\usage{
llply(.data, .fun = NULL, ..., .progress = "none", .inform = FALSE,
  .parallel = FALSE, .paropts = NULL)
}
\arguments{
\item{.data}{list to be processed}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
list of results
}
\description{
For each element of a list, apply function, keeping results as a list.
}
\details{
\code{llply} is equivalent to \code{\link{lapply}} except that it will
preserve labels and can display a progress bar.
}
\section{Input}{
 This function splits lists by elements.
}

\section{Output}{
 If there are no results, then this function will return
  a list of length 0 (\code{list()}).
}
\examples{
llply(llply(mtcars, round), table)
llply(baseball, summary)
# Examples from ?lapply
x <- list(a = 1:10, beta = exp(-3:3), logic = c(TRUE,FALSE,FALSE,TRUE))

llply(x, mean)
llply(x, quantile, probs = 1:3/4)
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other list input: \code{\link{l_ply}}; \code{\link{laply}};
  \code{\link{ldply}}

Other list output: \code{\link{alply}};
  \code{\link{dlply}}; \code{\link{mlply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/split.r
\name{print.split}
\alias{print.split}
\title{Print split.}
\usage{
\method{print}{split}(x, ...)
}
\arguments{
\item{x}{object to print}

\item{...}{unused}
}
\description{
Don't print labels, so it appears like a regular list
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/indexed-data-frame.r
\name{indexed_df}
\alias{indexed_df}
\title{An indexed data frame.}
\usage{
indexed_df(data, index, vars)
}
\arguments{
\item{index}{list of indices}

\item{vars}{a character vector giving the variables used for subsetting}

\item{env}{environment containing data frame}
}
\description{
Create a indexed list, a space efficient way of indexing into a large data frame
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/rename.r
\name{rename}
\alias{rename}
\title{Modify names by name, not position.}
\usage{
rename(x, replace, warn_missing = TRUE, warn_duplicated = TRUE)
}
\arguments{
\item{x}{named object to modify}

\item{replace}{named character vector, with new names as values, and
old names as names.}

\item{warn_missing}{print a message if any of the old names are
not actually present in \code{x}.}

\item{warn_duplicated}{print a message if any name appears more
  than once in \code{x} after the operation.
Note: x is not altered: To save the result, you need to copy the returned
  data into a variable.}
}
\description{
Modify names by name, not position.
}
\examples{
x <- c("a" = 1, "b" = 2, d = 3, 4)
# Rename column d to "c", updating the variable "x" with the result
x <- rename(x, replace = c("d" = "c"))
x
# Rename column "disp" to "displacement"
rename(mtcars, c("disp" = "displacement"))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/quote.r
\name{.}
\alias{.}
\alias{is.quoted}
\alias{quoted}
\title{Quote variables to create a list of unevaluated expressions for later
evaluation.}
\usage{
.(..., .env = parent.frame())
}
\arguments{
\item{...}{unevaluated expressions to be recorded.  Specify names if you
want the set the names of the resultant variables}

\item{.env}{environment in which unbound symbols in \code{...} should be
evaluated.  Defaults to the environment in which \code{.} was executed.}
}
\value{
list of symbol and language primitives
}
\description{
This function is similar to \code{\link{~}} in that it is used to
capture the name of variables, not their current value.  This is used
throughout plyr to specify the names of variables (or more complicated
expressions).
}
\details{
Similar tricks can be performed with \code{\link{substitute}}, but when
functions can be called in multiple ways it becomes increasingly tricky
to ensure that the values are extracted from the correct frame.  Substitute
tricks also make it difficult to program against the functions that use
them, while the \code{quoted} class provides
\code{as.quoted.character} to convert strings to the appropriate
data structure.
}
\examples{
.(a, b, c)
.(first = a, second = b, third = c)
.(a ^ 2, b - d, log(c))
as.quoted(~ a + b + c)
as.quoted(a ~ b + c)
as.quoted(c("a", "b", "c"))

# Some examples using ddply - look at the column names
ddply(mtcars, "cyl", each(nrow, ncol))
ddply(mtcars, ~ cyl, each(nrow, ncol))
ddply(mtcars, .(cyl), each(nrow, ncol))
ddply(mtcars, .(log(cyl)), each(nrow, ncol))
ddply(mtcars, .(logcyl = log(cyl)), each(nrow, ncol))
ddply(mtcars, .(vs + am), each(nrow, ncol))
ddply(mtcars, .(vsam = vs + am), each(nrow, ncol))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/dimensions.r
\name{reduce_dim}
\alias{reduce_dim}
\title{Reduce dimensions.}
\usage{
reduce_dim(x)
}
\arguments{
\item{x}{array}
}
\description{
Remove extraneous dimensions
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/quote.r
\name{print.quoted}
\alias{print.quoted}
\title{Print quoted variables.}
\usage{
\method{print}{quoted}(x, ...)
}
\description{
Display the \code{\link{str}}ucture of quoted variables
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/count.r
\name{count}
\alias{count}
\title{Count the number of occurences.}
\usage{
count(df, vars = NULL, wt_var = NULL)
}
\arguments{
\item{df}{data frame to be processed}

\item{vars}{variables to count unique values of}

\item{wt_var}{optional variable to weight by - if this is non-NULL, count
will sum up the value of this variable for each combination of id
variables.}
}
\value{
a data frame with label and freq columns
}
\description{
Equivalent to \code{as.data.frame(table(x))}, but does not include
combinations with zero counts.
}
\details{
Speed-wise count is competitive with \code{\link{table}} for single
variables, but it really comes into its own when summarising multiple
dimensions because it only counts combinations that actually occur in the
data.

Compared to \code{\link{table}} + \code{\link{as.data.frame}}, \code{count}
also preserves the type of the identifier variables, instead of converting
them to characters/factors.
}
\examples{
# Count of each value of "id" in the first 100 cases
count(baseball[1:100,], vars = "id")
# Count of ids, weighted by their "g" loading
count(baseball[1:100,], vars = "id", wt_var = "g")
count(baseball, "id", "ab")
count(baseball, "lg")
# How many stints do players do?
count(baseball, "stint")
# Count of times each player appeared in each of the years they played
count(baseball[1:100,], c("id", "year"))
# Count of counts
count(count(baseball[1:100,], c("id", "year")), "id", "freq")
count(count(baseball, c("id", "year")), "freq")
}
\seealso{
\code{\link{table}} for related functionality in the base package
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/d_ply.r
\name{d_ply}
\alias{d_ply}
\title{Split data frame, apply function, and discard results.}
\usage{
d_ply(.data, .variables, .fun = NULL, ..., .progress = "none",
  .inform = FALSE, .drop = TRUE, .print = FALSE, .parallel = FALSE,
  .paropts = NULL)
}
\arguments{
\item{.data}{data frame to be processed}

\item{.variables}{variables to split data frame by, as \code{\link{as.quoted}}
variables, a formula or character vector}

\item{.fun}{function to apply to each piece}

\item{...}{other arguments passed on to \code{.fun}}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.inform}{produce informative error messages?  This is turned off
by default because it substantially slows processing speed, but is very
useful for debugging}

\item{.drop}{should combinations of variables that do not appear in the
input data be preserved (FALSE) or dropped (TRUE, default)}

\item{.print}{automatically print each result? (default: \code{FALSE})}

\item{.parallel}{if \code{TRUE}, apply function in parallel, using parallel
backend provided by foreach}

\item{.paropts}{a list of additional options passed into
the \code{\link[foreach]{foreach}} function when parallel computation
is enabled.  This is important if (for example) your code relies on
external data or packages: use the \code{.export} and \code{.packages}
arguments to supply them so that all cluster nodes have the correct
environment set up for computing.}
}
\value{
Nothing
}
\description{
For each subset of a data frame, apply function and discard results.
To apply a function for each row, use \code{\link{a_ply}} with
\code{.margins} set to \code{1}.
}
\section{Input}{
 This function splits data frames by variables.
}

\section{Output}{

  All output is discarded. This is useful for functions that you are
  calling purely for their side effects like displaying plots or
  saving output.
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy
  for Data Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\seealso{
Other data frame input: \code{\link{daply}};
  \code{\link{ddply}}; \code{\link{dlply}}

Other no output: \code{\link{a_ply}}; \code{\link{l_ply}};
  \code{\link{m_ply}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/round-any.r
\name{round_any}
\alias{round_any}
\title{Round to multiple of any number.}
\usage{
round_any(x, accuracy, f = round)
}
\arguments{
\item{x}{numeric or date-time (POSIXct) vector to round}

\item{accuracy}{number to round to; for POSIXct objects, a number of seconds}

\item{f}{rounding function: \code{\link{floor}}, \code{\link{ceiling}} or
\code{\link{round}}}
}
\description{
Round to multiple of any number.
}
\examples{
round_any(135, 10)
round_any(135, 100)
round_any(135, 25)
round_any(135, 10, floor)
round_any(135, 100, floor)
round_any(135, 25, floor)
round_any(135, 10, ceiling)
round_any(135, 100, ceiling)
round_any(135, 25, ceiling)

round_any(Sys.time() + 1:10, 5)
round_any(Sys.time() + 1:10, 5, floor)
round_any(Sys.time(), 3600)
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/quote.r
\name{names.quoted}
\alias{names.quoted}
\title{Compute names of quoted variables.}
\usage{
\method{names}{quoted}(x)
}
\description{
Figure out names of quoted variables, using specified names if they exist,
otherwise converting the values to character strings.  This may create
variable names that can only be accessed using \code{``}.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/rdply.r
\name{rdply}
\alias{rdply}
\title{Replicate expression and return results in a data frame.}
\usage{
rdply(.n, .expr, .progress = "none", .id = NA)
}
\arguments{
\item{.n}{number of times to evaluate the expression}

\item{.expr}{expression to evaluate}

\item{.progress}{name of the progress bar to use, see
\code{\link{create_progress_bar}}}

\item{.id}{name of the index column. Pass \code{NULL} to avoid creation of
the index column. For compatibility, omit this argument or pass \code{NA}
to use \code{".n"} as column name.}
}
\value{
a data frame
}
\description{
Evaluate expression n times then combine results into a data frame
}
\details{
This function runs an expression multiple times, and combines the result into
a data frame.  If there are no results, then this function returns a data
frame with zero rows and columns (\code{data.frame()}). This function is
equivalent to \code{\link{replicate}}, but will always return results as a
data frame.
}
\examples{
rdply(20, mean(runif(100)))
rdply(20, each(mean, var)(runif(100)))
rdply(20, data.frame(x = runif(2)))
}
\references{
Hadley Wickham (2011). The Split-Apply-Combine Strategy for Data
  Analysis. Journal of Statistical Software, 40(1), 1-29.
  \url{http://www.jstatsoft.org/v40/i01/}.
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/join.r
\name{join.keys}
\alias{join.keys}
\title{Join keys.
Given two data frames, create a unique key for each row.}
\usage{
join.keys(x, y, by)
}
\arguments{
\item{x}{data frame}

\item{y}{data frame}

\item{by}{character vector of variable names to join by}
}
\description{
Join keys.
Given two data frames, create a unique key for each row.
}
\keyword{internal}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/progress.r
\name{progress_win}
\alias{progress_win}
\title{Graphical progress bar, powered by Windows.}
\usage{
progress_win(title = "plyr progress", ...)
}
\arguments{
\item{title}{window title}

\item{...}{other arguments passed on to \code{winProgressBar}}
}
\description{
A graphical progress bar displayed in a separate window
}
\details{
This graphical progress only works on Windows.
}
\examples{
if(exists("winProgressBar")) {
l_ply(1:100, identity, .progress = "win")
l_ply(1:100, identity, .progress = progress_win(title="Working..."))
}
}
\seealso{
\code{winProgressBar} for the function that powers this progress bar

Other progress bars: \code{\link{progress_none}};
  \code{\link{progress_text}}; \code{\link{progress_time}};
  \code{\link{progress_tk}}
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/vaggregate.r
\name{vaggregate}
\alias{vaggregate}
\title{Vector aggregate.}
\usage{
vaggregate(.value, .group, .fun, ..., .default = NULL, .n = nlevels(.group))
}
\arguments{
\item{.value}{vector of values to aggregate}

\item{.group}{grouping vector}

\item{.fun}{aggregation function}

\item{...}{other arguments passed on to \code{.fun}}

\item{.default}{default value used for missing groups.  This argument is
also used as the template for function output.}

\item{.n}{total number of groups}
}
\description{
This function is somewhat similar to \code{tapply}, but is designed for
use in conjunction with \code{id}. It is simpler in that it only
accepts a single grouping vector (use \code{\link{id}} if you have more)
and uses \code{\link{vapply}} internally, using the \code{.default} value
as the template.
}
\details{
\code{vaggregate} should be faster than \code{tapply} in most situations
because it avoids making a copy of the data.
}
\examples{
# Some examples of use borrowed from ?tapply
n <- 17; fac <- factor(rep(1:3, length = n), levels = 1:5)
table(fac)
vaggregate(1:n, fac, sum)
vaggregate(1:n, fac, sum, .default = NA_integer_)
vaggregate(1:n, fac, range)
vaggregate(1:n, fac, range, .default = c(NA, NA) + 0)
vaggregate(1:n, fac, quantile)
# Unlike tapply, vaggregate does not support multi-d output:
tapply(warpbreaks$breaks, warpbreaks[,-1], sum)
vaggregate(warpbreaks$breaks, id(warpbreaks[,-1]), sum)

# But it is about 10x faster
x <- rnorm(1e6)
y1 <- sample.int(10, 1e6, replace = TRUE)
system.time(tapply(x, y1, mean))
system.time(vaggregate(x, y1, mean))
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/strip-splits.r
\name{strip_splits}
\alias{strip_splits}
\title{Remove splitting variables from a data frame.}
\usage{
strip_splits(df)
}
\arguments{
\item{df}{data frame produced by \code{d*ply}.}
}
\description{
This is useful when you want to perform some operation to every column
in the data frame, except the variables that you have used to split it.
These variables will be automatically added back on to the result when
combining all results together.
}
\examples{
dlply(mtcars, c("vs", "am"))
dlply(mtcars, c("vs", "am"), strip_splits)
}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/rbind-fill.r
\name{rbind.fill}
\alias{rbind.fill}
\title{Combine data.frames by row, filling in missing columns.}
\usage{
rbind.fill(...)
}
\arguments{
\item{...}{input data frames to row bind together.  The first argument can
be a list of data frames, in which case all other arguments are ignored.
Any NULL inputs are silently dropped. If all inputs are NULL, the output
is NULL.}
}
\value{
a single data frame
}
\description{
\code{rbind}s a list of data frames filling missing columns with NA.
}
\details{
This is an enhancement to \code{\link{rbind}} that adds in columns
that are not present in all inputs, accepts a list of data frames, and
operates substantially faster.

Column names and types in the output will appear in the order in which
they were encountered.

Unordered factor columns will have their levels unified and
character data bound with factors will be converted to
character. POSIXct data will be converted to be in the same time
zone. Array and matrix columns must have identical dimensions after
the row count. Aside from these there are no general checks that
each column is of consistent data type.
}
\examples{
rbind.fill(mtcars[c("mpg", "wt")], mtcars[c("wt", "cyl")])
}
\seealso{
Other binding functions: \code{\link{rbind.fill.matrix}}
}
\keyword{manip}

% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/utils.r
\name{empty}
\alias{empty}
\title{Check if a data frame is empty.}
\usage{
empty(df)
}
\arguments{
\item{df}{data frame to check}
}
\description{
Empty if it's null or it has 0 rows or columns
}
\keyword{internal}
